<%@ page import="javax.management.*" %>
<%@ page import="coms.*" %>
<%@ page import="coms.metadata.*" %>
<%@ page import="coms.core.inference.*" %>
<%@ page import="java.lang.reflect.Method" %>
<%@ page import="java.util.HashMap" %>
<%@ page import="java.util.Hashtable" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="java.io.IOException" %>
<%@ page import="java.util.Set" %>
<%@ page import="java.util.LinkedHashSet" %>
<%@ page import="java.util.LinkedHashMap" %>
<%@ page import="java.util.Map" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="java.lang.SecurityException" %>
<%@ page import="coms.core.inference.*" %>
<%@ include file="functions.jsp" %>
<%@ include file="ruleFunctions.jsp" %>
<%@ page contentType="text/html; charset=ISO-8859-5" %> 
<%

String redirectURL = "index.jsp?id=components";
String action = request.getParameter("action");
String output = "", errormsg = "";

if(action == null) action = "undefined";

if(action.equals("stop")){
	
	try{
		String ID = request.getParameter("comID");
		stopComponent(ID);
		response.sendRedirect(redirectURL);
	}catch(Exception e){
		errormsg = "Could not connect to the CoMS<br>Caused by: "+ e.toString();
		response.sendRedirect("index.jsp?id=error&errormsg="+errormsg);
	}
	
}else if(action.equals("start")){
	
	try{
		String ID = request.getParameter("comID");
		startComponent(ID);
		response.sendRedirect(redirectURL);
	}catch(Exception e){
		errormsg = "Could not connect to the CoMS<br>Caused by: "+ e.toString();
		response.sendRedirect("index.jsp?id=error&errormsg="+errormsg);
	}

}else if(action.equals("changeConfig")){

	String comID = request.getParameter("comID");
	Map map = request.getParameterMap();
	HashMap configMap = getComponentConfig(comID);
		Set list = map.keySet();
		Iterator it = list.iterator();
		while(it.hasNext()){
			String key = (String) it.next();
			if(!key.equals("comID") && !key.equals("id") && !key.equals("action")){
				String[] values = (String[])map.get(key);
				if(configMap.containsKey(key))
					configMap.put(key, values[0]);
				
			}
		}
	changeComponentConfig(comID, configMap);
	response.sendRedirect("index.jsp?id=config&comID="+comID);
	

}else if(action.equals("addRule")){
	try{
		// Get id
		String comID 	= request.getParameter("comID");
		
		// Process form to create rule
		Rule rule = processFormData(request);
		
		System.out.println("Content: "+rule.getActions().getContent());
		
		// Get engine and engine ruleset
		Engine engine = getEngine(comID);	
		RuleSet ruleset = engine.getRuleSet();

		// Add rule to ruleset
		ruleset.add(rule);
		
		int ruleID = ruleset.getCount();
		
		// Reload ruleset	
		engine.reloadRules();
	
		response.sendRedirect("index.jsp?id=config&action=ruleChanged&comID="+comID+"&ruleid="+ruleID);
		
	}catch(Exception e){
		e.printStackTrace();
		errormsg = "Could not add rule<br>Caused by: "+e.toString();
		response.sendRedirect("index.jsp?id=error&errormsg="+errormsg);

	}
	
}else if(action.equals("deleteRule")){
	
	// Get ids
	String comID 	= request.getParameter("comID");	
	String ruleID	= request.getParameter("ruleID");
	
	// Get engine and engine ruleset
	Engine engine = getEngine(comID);	
	RuleSet ruleset = engine.getRuleSet();
	
	// Get rules hashmap
	HashMap rules = ruleset.getRules();
	
	// Remove rule
	rules.remove(new Integer(ruleID));
	
	// Reload ruleset
	engine.reloadRules();
	
	response.sendRedirect("index.jsp?id=config&action=ruleDeleted&comID="+comID+"&ruleid="+ruleID);
	
}else if(action.equals("changeRule")){
	try{
		String comID = request.getParameter("comID");
		
		// Get rule id
		String ruleID	 		= request.getParameter("rule:id");
	
		// Process form to create rule
		Rule rule = processFormData(request);	
	
		// Get engine and engine ruleset
		Engine engine = getEngine(comID);	
		RuleSet ruleset = engine.getRuleSet();
		
		// Get rules hashmap
		HashMap rules = ruleset.getRules();
		
		// Remove old rule
		rules.remove(new Integer(ruleID));
		
		// Update with new rule
		rules.put(new Integer(ruleID), rule);
		engine.reloadRules();

		response.sendRedirect("index.jsp?id=config&action=ruleChanged&comID="+comID+"&ruleid="+ruleID);
	
	}catch(Exception e){
		e.printStackTrace();
		errormsg = "Could not change rule<br>Caused by: "+e.toString();
		response.sendRedirect("index.jsp?id=error&errormsg="+errormsg);
	}
}
	
%>