<%!
	String htmlstr = "";
	
	public String buildFactClasses(Hashtable factClasses, String classname){
		String html = "";
		Iterator it = factClasses.keySet().iterator();
		
		while(it.hasNext()){		
			String key = (String) it.next();
			Class cls = (Class) factClasses.get(key);

			if(classname.equals(cls.getName()))
				html += "<option value=\""+key+"\" SELECTED>"+key+"</option>\n";
			else
				html += "<option value=\""+key+"\">"+key+"</option>\n";
				
		}
		
		return html;
	}

	public String buildSelects(HashMap selects, Hashtable factClasses){
		
		htmlstr = "";
		Iterator iter = selects.keySet().iterator();
			
		// Display select classes
		int i=0;
		while(iter.hasNext()){
			String id = (String) iter.next();
			String classname = (String) selects.get(id);
			
			htmlstr += "<tr><td><b>Select:</b></td><td width=\"15\">&nbsp;</td><td><select name=\"selects:class["+i+"]\">\n";
				
			htmlstr += buildFactClasses(factClasses, classname);
			
			htmlstr += "</select></td>\n<td width=\"15\">&nbsp;</td><td><b>ID: </b></td><td width=\"15\">&nbsp;</td>";
			
			// Display id class tag
			htmlstr += "<td><input type=\"text\" name=\"selects:id["+i+"]\" value=\""+id+"\" size=\"8\"></td></tr>";
			i++;
		}
		
		// Number of conditions
		htmlstr += "<tr><td><input type=\"hidden\" name=\"selects:count\" value=\""+i+"\"></td></tr>";
		
		return htmlstr;
	}
	
	public Class displayClasses(String selected, Hashtable factClasses){
		Class condClass = null;
		Iterator it = factClasses.keySet().iterator();
		// Display classes for exp1
		while(it.hasNext()){		
			String key = (String) it.next();
			Class cls = (Class) factClasses.get(key);

			// This class is shown as selected
			if(selected.equals(cls.getName())){ 
				condClass = cls;
				htmlstr += "<option value=\""+key+"\" SELECTED>"+key+"</option>\n";
			}else{
				htmlstr += "<option value=\""+key+"\">"+key+"</option>\n";
			}
		}
		
		
		return condClass;

	}
	
	public String displayMethods(Class condClass, String selectedMethod){
		
		Method[] methods2 = condClass.getMethods();
		String result = "";

		for(int i=0;i<methods2.length;i++){		
			
			// Only int, floats, doubles or boolean types can be used
			boolean typeSafe = false;
			if(methods2[i].getReturnType().getName().equalsIgnoreCase("boolean")) typeSafe = true;
			if(methods2[i].getReturnType().getName().equalsIgnoreCase("int")) typeSafe = true;
			if(methods2[i].getReturnType().getName().equalsIgnoreCase("float")) typeSafe = true;
			if(methods2[i].getReturnType().getName().equalsIgnoreCase("double")) typeSafe = true;
			
			// Ignore inherited methods
			if(!methods2[i].getDeclaringClass().getName().equals(condClass.getName())) typeSafe = false;
			
			
			if(typeSafe){
				
				// Remove unwanted data from string
				String[] parts = methods2[i].getName().split("\\.");
				String mname = parts[parts.length-1];
				mname += "()";
		
				if(mname.equals(selectedMethod))
					result += "<option value=\""+mname+"\" SELECTED>"+mname+"</option>\n";
				else
					result += "<option value=\""+mname+"\">"+mname+"</option>\n";
			}
			
		}
		
		return result;
		
	}
	
	public String buildConditions(Set conditions, Hashtable factClasses){
		
		htmlstr = "";
		Iterator iter = conditions.iterator();
			
		// Create html for all conditions
		int i =0;
		while(iter.hasNext()){
			Condition condition = (Condition) iter.next();
			String operator = condition.getOperator();
		
			htmlstr += "<tr><td><b>Condition:</b></td><td width=\"15\">&nbsp;</td><td><select name=\"condition:exp1:class["+i+"]\">\n";
						
			// Display classes for exp 1
			Class condClass = null;
			if(condition.isLExpMethod())
				condClass = displayClasses(condition.getLClass(), factClasses);
			else
				condClass = displayClasses(condition.getRClass(), factClasses);
			
			
			htmlstr += "</select></td><td width=\"15\">&nbsp;</td><td><select name=\"condition:exp1:method["+i+"]\">\n";
			
			
			// Display methods for exp1
			if(condition.isLExpMethod())
				htmlstr += displayMethods(condClass, condition.getLExp());
			else
				htmlstr += displayMethods(condClass, condition.getRExp());
			
			
			htmlstr += "</select></td><td width=\"15\">&nbsp;</td><td><select name=\"condition:operator["+i+"]\">\n";
			
			// Display operator
			String[] operators = {"==", ">", "<", "!="};
			for(int x=0;x<operators.length;x++){
				
				if(operator.equals(operators[x]))
					htmlstr += "<option value=\""+operators[x]+"\" SELECTED>"+operators[x]+"</option>\n";
				else
					htmlstr += "<option value=\""+operators[x]+"\">"+operators[x]+"</option>\n";
			}
			
			htmlstr += "</select></td><td width=\"15\">&nbsp;</td>";
			
			// Check if both exp are methods
			if(condition.isLExpMethod()){
				if(condition.isRExpMethod()){
					
					htmlstr += "<td><select name=\"condition:exp2:class["+i+"]\">";
					
					// Display classes for exp 2
					condClass = displayClasses(condition.getRClass(), factClasses);
					
					htmlstr += "</select></td><td width=\"15\">&nbsp;</td><td><select name=\"condition:exp2:method["+i+"]\">";

					// Display methods for exp2
					htmlstr += displayMethods(condClass, condition.getRExp());

	 			// Right exp is not method
				}else{
					htmlstr += "<td><input type=\"text\" name=\"condition:value["+i+"]\" size=\"7\" value=\""+condition.getRExp()+"\"></td>";
				}
			
			// Left exp is not method
			}else{
				htmlstr += "<td><input type=\"text\" name=\"condition:value["+i+"]\" size=\"7\" value=\""+condition.getLExp()+"\"></td>";
			} 	
		
			htmlstr += "</tr>";
			
			i++;
		
		}
		
		// Number of conditions
		htmlstr += "<tr><td><input type=\"hidden\" name=\"condition:count\" value=\""+i+"\"></td></tr>";
		
		return htmlstr;
		
	}
	
	public int displayAction(Set operationset, String operation, HashMap selects, int start){
		
		Iterator it = operationset.iterator();
		
		int i=start;
		while(it.hasNext()){

			htmlstr += "<tr><td>&nbsp;</td><td width=\"15\">&nbsp;</td><td><select name=\"actions:classid["+i+"]\">";
			String classid = (String) it.next();
			
			// Display class ids
			Iterator iter = selects.keySet().iterator();
			while(iter.hasNext()){
				String key = (String) iter.next();
				
				if(key.equals(classid))
					htmlstr += "<option value=\""+key+"\" SELECTED>"+key;
				else
					htmlstr += "<option value=\""+key+"\">"+key;
			}
			
			htmlstr += "</select></td><td width=\"15\">&nbsp;</td>";
			
			// Display operation
			htmlstr += "<td><select name=\"actions:operation["+i+"]\">";
			
			String[] operations = {"insert", "update", "remove"};
			for(int x=0;x<operations.length;x++){
				
				if(operations[x].equals(operation))
					htmlstr += "<option value=\""+operations[x]+"\" SELECTED>"+operations[x];
				else
					htmlstr += "<option value=\""+operations[x]+"\">"+operations[x];
			}
	
			htmlstr +="</select></td></tr>";
			i++;		
		}
		
		return i;
		
	}
	
	public String buildActions(Actions actions, HashMap selects){
		
		htmlstr = "";
		int start = 0;
		
		Set inserts = actions.getInserts();
		start = displayAction(inserts, "insert", selects, start);
		
		Set updates = actions.getUpdates();
		start = displayAction(updates, "update", selects, start);
		
		Set removes = actions.getRemoves();
		start = displayAction(removes, "remove", selects, start);
		
		// Number of operations of type
		htmlstr += "<tr><td><input type=\"hidden\" name=\"actions:count\" value=\""+start+"\"></td></tr>";
		
		return htmlstr;
		
	}
	
	
	public Rule processFormData(HttpServletRequest request) throws Exception{
		
		// Get rule name
		String rname 			= request.getParameter("rule:name");
		
		Rule rule = new Rule(rname);
		
		// Get rule properties
		String loop 			= request.getParameter("rule:loop");
		String order			= request.getParameter("rule:order");
		
		// Set rule properties
		rule.setLoop(loop);
		rule.setOrder(order);	
	
		// Get counts
		int selectCount=0, nselectCount=0, conditionCount=0, nconditionCount=0, actionCount=0, nactionCount=0;
		String scount			= request.getParameter("selects:count");
		if(scount != null)		selectCount = new Integer(scount).intValue();
		String nscount			= request.getParameter("nselect:count");
		if(nscount != null)		nselectCount = new Integer(nscount).intValue();
		String ccount			= request.getParameter("condition:count");
		if(ccount != null)		conditionCount = new Integer(ccount).intValue();
		String nccount			= request.getParameter("ncondition:count");
		if(nccount != null)		nconditionCount = new Integer(nccount).intValue();
		String acount			= request.getParameter("actions:count");
		if(acount != null)		actionCount = new Integer(acount).intValue();
		String nacount			= request.getParameter("nactions:count");
		if(nacount != null)		nactionCount = new Integer(nacount).intValue();
		
		// HashMap with mappings from class --> id
		HashMap<String, String> classMap = new HashMap<String, String>();
		
		// Generate selects
		for(int i=0;i<selectCount;i++){
			
			// Must use "selects" name instead of "select" because of firefox html bug
			String sclass 	= request.getParameter("selects:class["+i+"]");
			String sid		= request.getParameter("selects:id["+i+"]");
			
			// Add new select to rule
			rule.addSelect(sid, sclass);
			
			// Add mapping
			classMap.put(sclass, sid);
			
		}
		
		// Generate new selects
		for(int i=0;i<nselectCount;i++){
			
			String sclass 	= request.getParameter("nselect:class["+i+"]");
			String sid		= request.getParameter("nselect:id["+i+"]");
			
			// Check if class not already defined
			if(!classMap.containsKey(sclass)){
				// Add new select to rule
				rule.addSelect(sid, sclass);
			
				// Add mapping
				classMap.put(sclass, sid);
			}else{
				throw new RuleFormatException("Two select statements cannot refer to the same class");
			}
			
		}
		
		// Generate conditions
		for(int i=0;i<conditionCount;i++){

			String exp1Class 	= request.getParameter("condition:exp1:class["+i+"]");
			String exp1Method 	= request.getParameter("condition:exp1:method["+i+"]");
			String operator		= request.getParameter("condition:operator["+i+"]");
			String exp2Class 	= request.getParameter("condition:exp2:class["+i+"]");
			String exp2Method 	= request.getParameter("condition:exp2:method["+i+"]");
			String value	 	= request.getParameter("condition:value["+i+"]");
			
			String condition = "";
			
			// Create condition string
			if(exp1Class != null){
				String exp1classid = classMap.get(exp1Class);
				if(exp2Class != null){
					
					String exp2classid = classMap.get(exp2Class);
					
					condition = exp1classid+"."+exp1Method+" "+operator+" "+exp2classid+"."+exp2Method;
				}else{
					condition = exp1classid+"."+exp1Method+" "+operator+" "+value;
				}
			}else{
				String exp2classid = classMap.get(exp2Class);
				condition = exp2classid+"."+exp2Method+" "+operator+" "+value;
			}

			// Create new condition object
			Condition cond = new Condition(condition);
			
			// Add new condition to rule
			rule.addCondition(cond);
				
		}
		
		// Generate new conditions
		for(int i=0;i<nconditionCount;i++){
			String exp1Class 	= request.getParameter("ncondition:exp1:class["+i+"]");
			String exp1Method 	= request.getParameter("ncondition:exp1:method["+i+"]");
			String operator		= request.getParameter("ncondition:operator["+i+"]");
			String exp2Class 	= request.getParameter("ncondition:exp2:class["+i+"]");
			String exp2Method 	= request.getParameter("ncondition:exp2:method["+i+"]");
			String value	 	= request.getParameter("ncondition:value["+i+"]");
			
			String condition = "";
			
			// Create condition string
			if(exp1Class != null){
				String exp1classid = classMap.get(exp1Class);
				if(exp2Class != null){
					String exp2classid = classMap.get(exp2Class);
					
					condition = exp1classid+"."+exp1Method+" "+operator+" "+exp2classid+"."+exp2Method;
				}else{
					condition = exp1classid+"."+exp1Method+" "+operator+" "+value;
				}
			}else{
				String exp2classid = classMap.get(exp2Class);
				condition = exp2classid+"."+exp2Method+" "+operator+" "+value;
			}
			
			// Create new condition object
			Condition cond = new Condition(condition);	
			
			// Add new condition to rule
			rule.addCondition(cond);
				
		}
		
		// Generate action content
		Actions actions = new Actions();
	
		String content	= request.getParameter("actions:content");
		actions.setContent(content);
		
		// Generate actions
		for(int i=0;i<actionCount;i++){

			String actionid = request.getParameter("actions:classid["+i+"]");
			String operation = request.getParameter("actions:operation["+i+"]");
			
			if(operation.equalsIgnoreCase("insert"))
				actions.addInsert(actionid);
			else if(operation.equalsIgnoreCase("update"))
				actions.addUpdate(actionid);
			else if(operation.equalsIgnoreCase("remove"))
				actions.addRemove(actionid);
		}
		
		// Generate new actions
		for(int i=0;i<nactionCount;i++){

			String actionid = request.getParameter("nactions:classid["+i+"]");
			String operation = request.getParameter("nactions:operation["+i+"]");
			
			if(operation.equalsIgnoreCase("insert"))
				actions.addInsert(actionid);
			else if(operation.equalsIgnoreCase("update"))
				actions.addUpdate(actionid);
			else if(operation.equalsIgnoreCase("remove"))
				actions.addRemove(actionid);
		}
		
		// Set actions
		rule.setActions(actions);
		
		return rule;
	}
	
	
	public String buildNewSelects(Hashtable factClasses, HttpServletRequest request, String form1){
	
		String nhtml = "";
		int i=-1;
		int j=-1;
		
		while(true){
			i++;j++;
			String sel = request.getParameter("nselect:class["+j+"]");
			String selid = request.getParameter("nselect:id["+j+"]");
			
			if(sel != null){
				if(sel.equals("removeFact") || sel.equals("nofactselected")){
					j++;
					sel = request.getParameter("nselect:class["+j+"]");
					selid = request.getParameter("nselect:id["+j+"]");
				}
			}
				

			if(selid == null) selid = "";

			if(sel == null)
				break;
				
			nhtml += "<tr><td><b>Select:</b></td><td width=\"15\">&nbsp;</td>"+
					 "<td><select name=\"nselect:class["+i+"]\" onChange=\"submitForm('ruleform', '"+form1+"')\">";
			
			nhtml += buildFactClasses(factClasses, sel);
			
			nhtml += "<option value=\"removeFact\">Remove fact</option></select></td><td width=\"15\">&nbsp;</td>";
			nhtml += "<td><b>ID: </b></td><td width=\"15\">&nbsp;</td><td>";
			nhtml += "<input type=\"text\" name=\"nselect:id["+ i +"]\" value=\""+selid+"\" size=\"8\"></td></tr>";

		}
				
		String sel = request.getParameter("nselect:class");
		if(sel != null){
			if (!sel.equals("removeFact") && !sel.equals("nofactselected")){
		
				nhtml += "<tr><td><b>Select:</b></td><td width=\"15\">&nbsp;</td>";
				nhtml += "<td><select name=\"nselect:class["+ i +"]\" onChange=\"submitForm('ruleform', '"+form1+"')\">";
				
				nhtml += buildFactClasses(factClasses, sel);
				
				nhtml += "<option value=\"removeFact\">Remove fact</option></select></td><td width=\"15\">&nbsp;</td>";
				nhtml += "<td><b>ID: </b></td><td width=\"15\">&nbsp;</td><td><input type=\"text\" name=\"nselect:id["+i+"]\" value=\"\" size=\"8\">";
				i++;
					
				nhtml += "<input type=\"hidden\" name=\"nselect:count\" value=\""+ i +"\"></td></tr>";
				
			}else{
				nhtml += "<input type=\"hidden\" name=\"nselect:count\" value=\""+ i +"\">";
			}
		}else{
			nhtml += "<input type=\"hidden\" name=\"nselect:count\" value=\""+ i +"\">";
		}
		
		nhtml += "<tr><td><b>New:</b></td><td width=\"15\">&nbsp;</td><td>";
		nhtml += "<select name=\"nselect:class\" onChange=\"submitForm('ruleform', '"+form1+"')\">";
		nhtml += "<option value=\"nofactselected\" SELECTED>New Fact</option>";
		
		nhtml += buildFactClasses(factClasses, "noselected");
		
		nhtml += "</select></td></tr>";
		
		return nhtml;		
	}
	
	
	
	public String buildNewConditions(Hashtable factClasses, HttpServletRequest request, String form1) throws ClassNotFoundException{
	
		String nhtml = "";
		int i=-1;
		int j=-1;
		
		while(true){
			i++;j++;
			String condClass1 	= request.getParameter("ncondition:exp1:class["+j+"]");
			String exp1Method 	= request.getParameter("ncondition:exp1:method["+j+"]");
			String operator 	= request.getParameter("ncondition:operator["+j+"]");
			String condClass2 	= request.getParameter("ncondition:exp2:class["+j+"]");
			String exp2Method 	= request.getParameter("ncondition:exp2:method["+j+"]");
			String value		= request.getParameter("ncondition:value["+j+"]");
			
			if(condClass1 != null){
				if(condClass1.equals("removeCondition") || condClass1.equals("nocondselected")){
					j++;
					condClass1 	= request.getParameter("ncondition:exp1:class["+j+"]");
					exp1Method 	= request.getParameter("ncondition:exp1:method["+j+"]");
					operator 	= request.getParameter("ncondition:operator["+j+"]");
					condClass2 	= request.getParameter("ncondition:exp2:class["+j+"]");
					exp2Method 	= request.getParameter("ncondition:exp2:method["+j+"]");
					value		= request.getParameter("ncondition:value["+j+"]");
				}
			}
				

			if(exp1Method == null) exp1Method = "";
			if(exp2Method == null) exp2Method = "";
			if(value == null) value = "";

			if(condClass1 == null)
				break;
			
			// Display Condition class exp1
			nhtml += "<tr><td><b>Condition:</b></td><td width=\"15\">&nbsp;</td>"+
					 "<td><select name=\"ncondition:exp1:class["+i+"]\" onChange=\"submitForm('ruleform', '"+form1+"')\">";
			nhtml += buildFactClasses(factClasses, condClass1);
			nhtml += "<option value=\"removeCondition\">Remove condition</option></select></td><td width=\"15\">&nbsp;</td>";
			
			Class exp1Class = Class.forName(condClass1);
			
			// Display methods for exp1
			nhtml += "<td><select name=\"ncondition:exp1:method["+i+"]\">\n";
			nhtml += displayMethods(exp1Class, exp1Method);
			nhtml += "</select></td>";
			
			// Display operator
			nhtml += "<td width=\"15\">&nbsp;</td><td><select name=\"ncondition:operator["+i+"]\">\n";
			String[] operators = {"==", ">", "<", "!="};
			for(int x=0;x<operators.length;x++){
				if(operator.equals(operators[x]))
					nhtml += "<option value=\""+operators[x]+"\" SELECTED>"+operators[x]+"</option>\n";
				else
					nhtml += "<option value=\""+operators[x]+"\">"+operators[x]+"</option>\n";
			}
			
			nhtml += "</select></td><td width=\"15\">&nbsp;</td>";
			
			// Display value or exp2
			if(condClass2 != null){

				// Display Condition class exp2
				nhtml += "<td><select name=\"ncondition:exp2:class["+i+"]\" onChange=\"submitForm('ruleform', '"+form1+"')\">";
				nhtml += buildFactClasses(factClasses, condClass2);
				nhtml += "<option value=\"removeCondition\">Remove condition</option></select></td><td width=\"15\">&nbsp;</td>";
				
				Class exp2Class = Class.forName(condClass2);
			
				// Display methods for exp1
				nhtml += "<td><select name=\"ncondition:exp2:method["+i+"]\">\n";
				nhtml += displayMethods(exp2Class, exp2Method);
				nhtml += "</select></td>";
				
			//.. display value
			}else{
				nhtml += "<td><input type=\"text\" name=\"ncondition:value["+i+"]\" size=\"7\" value=\""+value+"\"></td>";
			}
			
			nhtml += "</tr>";
		
		}
				
		String condClass1 	= request.getParameter("ncondition:exp1:class");
		String choice 		= request.getParameter("ncondition:choice");
		if(condClass1 != null){
			if (!condClass1.equals("removeCondition") && !condClass1.equals("nocondselected")){
		
				// Display Condition class exp1
				nhtml += "<tr><td><b>Condition:</b></td><td width=\"15\">&nbsp;</td>"+
						 "<td><select name=\"ncondition:exp1:class["+i+"]\" onChange=\"submitForm('ruleform', '"+form1+"')\">";
				nhtml += buildFactClasses(factClasses, condClass1);
				nhtml += "<option value=\"removeCondition\">Remove condition</option></select></td><td width=\"15\">&nbsp;</td>";
				
				Class exp1Class = Class.forName(condClass1);	
				
				// Display methods for exp1
				nhtml += "<td><select name=\"ncondition:exp1:method["+i+"]\">\n";
				nhtml += displayMethods(exp1Class, "notselecte");
				nhtml += "</select></td>";
				
				// Display operator
				nhtml += "<td width=\"15\">&nbsp;</td><td><select name=\"ncondition:operator["+i+"]\">\n";
				String[] operators = {"==", ">", "<", "!="};
				for(int x=0;x<operators.length;x++){
						nhtml += "<option value=\""+operators[x]+"\">"+operators[x]+"</option>\n";
				}
			
				nhtml += "</select></td><td width=\"15\">&nbsp;</td>";
				
				// If choice is exp2
				if(choice.equals("<exp>:<operator>:<exp>")){
					// Display Condition class exp2
					nhtml += "<td><select name=\"ncondition:exp2:class["+i+"]\" onChange=\"submitForm('ruleform', '"+form1+"')\">";
					nhtml += buildFactClasses(factClasses, condClass1);
					nhtml += "<option value=\"removeCondition\">Remove condition</option></select></td><td width=\"15\">&nbsp;</td>";
					
					Class exp2Class = Class.forName(condClass1);
					
					// Display methods for exp2
					nhtml += "<td><select name=\"ncondition:exp2:method["+i+"]\">\n";
					nhtml += displayMethods(exp2Class, "notselected");
					nhtml += "</select></td>";
				
				// ... if choice is value
				}else{
					nhtml += "<td><input type=\"text\" name=\"ncondition:value["+i+"]\" size=\"7\" value=\"\"></td>";
				}
	
				i++;
					
				nhtml += "<input type=\"hidden\" name=\"ncondition:count\" value=\""+ i +"\"></td></tr>";
				
			}else{
				nhtml += "<input type=\"hidden\" name=\"ncondition:count\" value=\""+ i +"\">";
			}
		}else{
			nhtml += "<input type=\"hidden\" name=\"ncondition:count\" value=\""+ i +"\">";
		}
		
		nhtml += "<tr><td><b>New:</b></td><td width=\"15\">&nbsp;</td><td>";
		nhtml += "<select name=\"ncondition:exp1:class\" onChange=\"submitForm('ruleform', '"+form1+"')\">";
		nhtml += "<option value=\"nocondselected\" SELECTED>New Condition</option>";
		
		nhtml += buildFactClasses(factClasses, "noselected");
		
		nhtml += "</select></td><td width=\"15\">&nbsp;</td>";
		
		nhtml += "<td><b>Type:</b></td><td width=\"15\">&nbsp;</td>";
		nhtml += "<td colspan=\"3\"><select name=\"ncondition:choice\">";
		nhtml += "<option value=\"<exp>:<operator>:<exp>\" SELECTED>&lt;exp&gt;:&lt;operator&gt;:&lt;exp&gt;</option>";
		nhtml += "<option value=\"<exp>:<operator>:<value>\">&lt;exp&gt;:&lt;operator&gt;:&lt;value&gt;</option>";
		nhtml += "</select></td></tr>";
		
		return nhtml;		
	}
	
	
	public String buildNewActions(HttpServletRequest request, HashMap selects, String form1){
		String nhtml = "";
		
		int i=-1;
		int j=-1;
		
		while(true){
			i++;j++;
			String actionid = request.getParameter("nactions:classid["+j+"]");
			String operation = request.getParameter("nactions:operation["+j+"]");
			
			if(actionid != null){
				if(actionid.equals("removeAction") || actionid.equals("noactionselected")){
					j++;
					actionid = request.getParameter("nactions:classid["+j+"]");
					operation = request.getParameter("nactions:operation["+j+"]");
				}
			}else{
				// Break loop
				break;
			}
			
				
			nhtml += "<tr><td>&nbsp;</td><td width=\"15\">&nbsp;</td><td><select name=\"nactions:classid["+i+"]\">";
			
			// Display saved class ids
			if(selects != null){
				Iterator iter = selects.keySet().iterator();
				while(iter.hasNext()){
					String key = (String) iter.next();
					if(actionid.equals(key))
						nhtml += "<option value=\""+key+"\" SELECTED>"+key;
					else
						nhtml += "<option value=\""+key+"\">"+key;
				}
			}
			
			// Display non saved class ids
			int selCount = 0;
			String sCount = request.getParameter("nselect:count");
			if(sCount != null) selCount = new Integer(sCount).intValue();
			
			for(int x=0;x<selCount;x++){
				String sid		= request.getParameter("nselect:id["+x+"]");
				
				if(actionid.equals(sid))
					nhtml += "<option value=\""+sid+"\" SELECTED>"+sid;
				else
					nhtml += "<option value=\""+sid+"\">"+sid;
			}
			nhtml += "<option value=\"removeAction\">Remove action</option>";
			nhtml += "</select></td><td width=\"15\">&nbsp;</td>";
			
			// Display operation
			nhtml += "<td><select name=\"nactions:operation["+i+"]\">";
			
			String[] operations = {"insert", "update", "remove"};
			for(int x=0;x<operations.length;x++){		
				if(operation.equalsIgnoreCase(operations[x]))
					nhtml += "<option value=\""+operations[x]+"\" SELECTED>"+operations[x];
				else
					nhtml += "<option value=\""+operations[x]+"\">"+operations[x];
			}
	
			nhtml +="</select></td></tr>";		

		}
				
		String actionid = request.getParameter("nactions:classid");
		if(actionid != null){
			if (!actionid.equals("removeAction") && !actionid.equals("noactionselected")){
		
				nhtml += "<tr><td>&nbsp;</td><td width=\"15\">&nbsp;</td><td><select name=\"nactions:classid["+i+"]\">";
				
				// Display saved class ids
				if(selects != null){
					Iterator iter = selects.keySet().iterator();
					while(iter.hasNext()){
						String key = (String) iter.next();
						if(actionid.equals(key))
							nhtml += "<option value=\""+key+"\" SELECTED>"+key;
						else
							nhtml += "<option value=\""+key+"\">"+key;
					}
				}

				// Display non saved class ids
				int selCount = 0;
				String sCount = request.getParameter("nselect:count");
				if(sCount != null) selCount = new Integer(sCount).intValue();
				
				for(int x=0;x<selCount;x++){
					String sid		= request.getParameter("nselect:id["+x+"]");
					
					if(actionid.equals(sid))
						nhtml += "<option value=\""+sid+"\" SELECTED>"+sid;
					else
						nhtml += "<option value=\""+sid+"\">"+sid;
				}
				
				nhtml += "<option value=\"removeAction\">Remove action</option>";
				nhtml += "</select></td><td width=\"15\">&nbsp;</td>";
				
				// Display operation
				nhtml += "<td><select name=\"nactions:operation["+i+"]\">";
				
				String[] operations = {"insert", "update", "remove"};
				for(int x=0;x<operations.length;x++){		
					nhtml += "<option value=\""+operations[x]+"\">"+operations[x];
				}
		
				nhtml +="</select></td></tr>";	
				i++;
					
				nhtml += "<input type=\"hidden\" name=\"nactions:count\" value=\""+ i +"\"></td></tr>";
				
			}else{
				nhtml += "<input type=\"hidden\" name=\"nactions:count\" value=\""+ i +"\">";
			}
		}else{
			nhtml += "<input type=\"hidden\" name=\"nactions:count\" value=\""+ i +"\">";
		}
		
		nhtml += "<tr><td>&nbsp;</td><td width=\"15\">&nbsp;</td><td><select name=\"nactions:classid\" onChange=\"submitForm('ruleform', '"+form1+"')\">";
		nhtml += "<option value=\"noactionselected\" SELECTED>New action</option>";
		
		// Display saved class ids
		if(selects != null){
			Iterator iter = selects.keySet().iterator();
			while(iter.hasNext()){
				String key = (String) iter.next();
				nhtml += "<option value=\""+key+"\">"+key;
			}
		}
		
		// Display non saved class ids
		int selCount = 0;
		String sCount = request.getParameter("nselect:count");
		if(sCount != null) selCount = new Integer(sCount).intValue();

		for(int x=0;x<selCount;x++){
			String sid		= request.getParameter("nselect:id["+x+"]");
			nhtml += "<option value=\""+sid+"\">"+sid;
		}
		
		nhtml += "</select></td><td width=\"15\">&nbsp;</td></tr>";
		
		return nhtml;
	}
	
	
	


%>