package coms;

import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Iterator;
import javax.management.AttributeNotFoundException;
import javax.management.InstanceNotFoundException;
import javax.management.MBeanException;
import javax.management.MBeanServer;
import javax.management.MBeanServerFactory;
import javax.management.ObjectName;
import javax.management.ReflectionException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.xmlrpc.XmlRpcServer;

public class RPC2 extends HttpServlet implements RPC2MBean {
	private static MBeanServer server;
//	TODO Remove me
	//private String moduleDomain;
	//private String componentDomain;
	XmlRpcServer xmlrpc;

	public RPC2() {
		server = null;
		xmlrpc = new XmlRpcServer();
	}

	/**
	 * Sets the component domain this module will use
	 * 
	 * @param String
	 *            with the component domain
	 */
//	TODO Remove me
	public void setComponentDomain(String d) {
		//componentDomain = d;
	}

	/**
	 * Sets the module domain this module will use
	 * 
	 * @param String
	 *            with the module domain
	 */
//	TODO Remove me
	public void setModuleDomain(String d) {
		//moduleDomain = d;
	}

	/**
	 * Gets the handlers used by xmlrpchandler from the xmlrpcmbean
	 */
	public XmlRpcServer getHandler() {
		return xmlrpc;
	}

	/**
	 * This method gets the xmlrpc input stream and uses a handler to decide
	 * further action
	 */
	protected void doPost(HttpServletRequest request,
			HttpServletResponse response) {
		try {
			xmlrpc = _getHandler();
			byte[] result = xmlrpc.execute(request.getInputStream());
			response.setContentType("text/xml");
			response.setContentLength(result.length);
			OutputStream out = response.getOutputStream();
			out.write(result);
			out.flush();
		}
		catch (Exception e) {
			System.out.println(e.toString());
		}
	}

	/**
	 * Adds a new handler to the list of handlers
	 */
	public void addHandler(String handler, Object handlerobj) {
		try {
			xmlrpc.addHandler(handler, handlerobj);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Private method which get the handlers from the registered xmlrpchandler
	 * mbean
	 */
	private XmlRpcServer _getHandler() {
		try {
			getServerHandle("Module_Domain");
			ObjectName xmlrpc = new ObjectName(
					"Module_Domain:Name=XmlRpcHandler, Type=Core");
			return (XmlRpcServer) getAttribute(xmlrpc, "Handler",
					"Module_Domain");
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}

	/**
	 * Gets an attribute from a mbean
	 * 
	 * @param ObjectName
	 *            describing the module, String describing which attribute,
	 *            String describing the domain
	 * @return An Object with the attribute
	 */
	public Object getAttribute(ObjectName module, String attr, String domain) {
		try {
			getServerHandle(domain);
			Object result = server.getAttribute(module, attr);
			return result;
		}
		catch (MBeanException e) {
			log("getAttribute(): Module " + module + " doesn't exist\nModule: "
					+ module.toString());
		}
		catch (AttributeNotFoundException e) {
			log("getAttribute(): Attribute \"" + attr
					+ "\" was not found\nModule: " + module.toString());
		}
		catch (InstanceNotFoundException e) {
			log("getAttribute(): Instance not found exception\nModule: "
					+ module.toString());
		}
		catch (ReflectionException e) {
			log("getAttribute(): Reflection exception \nModule: "
					+ module.toString());
		}
		return null;
	}

	/**
	 * Gets the server handle for the domain specified
	 * 
	 * @param String
	 *            describing the domain
	 */
	public void getServerHandle(String domain) {
		ArrayList mbeanservers = MBeanServerFactory.findMBeanServer(null);
		Iterator iter = mbeanservers.iterator();
		while (iter.hasNext()) {
			server = (MBeanServer) iter.next();
			if (server.getDefaultDomain().equals(domain))
				break;
		}
		if (server == null) {
			System.out.println("Could not find mbeanserver handle");
			System.exit(0);
		}
	}
}
