package coms;

import java.io.File;
import java.util.Iterator;
import java.util.List;
import javax.management.MalformedObjectNameException;
import javax.management.ObjectName;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.fileupload.DiskFileUpload;
import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.FileUpload;
import org.apache.commons.fileupload.FileUploadException;

public class Upload extends HttpServlet {
	private final int MaxMemorySize = 1000000;
	private final int MaxRequestSize = 1000000;
	private final String TempDirectory = "/";
	private final String RMIServer = "localhost";
	private final String RMIPort = "9999";
	private final String RMIBindName = "server";
//	TODO Remove me
	//private final String MainPageURL = "http://localhost:8080/index.jsp";

	protected void doPost(HttpServletRequest request,
			HttpServletResponse response) {
		try {
			// first check if the upload request coming in is a multipart
			// request
			boolean isMultipart = FileUpload.isMultipartContent(request);
			if (isMultipart) {
				DiskFileUpload fileupload = new DiskFileUpload();
				// Set upload parameters
				fileupload.setSizeThreshold(MaxMemorySize);
				fileupload.setSizeMax(MaxRequestSize);
				fileupload.setRepositoryPath(TempDirectory);
				List fileitems = null;
				try {
					fileitems = fileupload.parseRequest(request);
					Iterator iterator = fileitems.iterator();
					while (iterator.hasNext()) {
						FileItem fileitem = (FileItem) iterator.next();
						// check if the current item is a form field or an
						// uploaded file
						if (!fileitem.isFormField()) {
							File file = new File(fileitem.getName());
							// Send file to CoMS
							byte[] bytes = fileitem.get();
							Byte[] data = new Byte[bytes.length];
							for (int i = 0; i < data.length; i++)
								data[i] = bytes[i];
							// Try connecting and sending the file to the CoMS
							try {
								RMIConnector rmicon = new RMIConnector();
								rmicon.connect(RMIServer, RMIPort, RMIBindName);
								ObjectName jUploader = createObjectName(
										"JarUploader", "Core", "Module_Domain");
								String result = (String) rmicon.invoke(
										jUploader, "uploadFile", new Object[] {
												data, file.getName() },
										new String[] { Byte[].class.getName(),
												String.class.getName() });
								response.getWriter().println(
										"<span class=\"text\">" + result
												+ "</span>");
							}
							catch (Exception e) {
								response
										.getWriter()
										.println(
												"<span class=\"text\"><span style=\"color:red\">Error: </span>Could not connect to the CoMS<br>Caused by: "
														+ e.toString()
														+ "</span>");
							}
						}
					}
				}
				catch (FileUploadException e) {
					e.printStackTrace();
				}
			}
			else {
				response
						.getWriter()
						.println(
								"<span class=\"text\"><span style=\"color:red\">Error: </span>No multipart upload found.</span>");
			}
		}
		catch (Exception e) {
			System.out.println(e.toString());
		}
	}

	/**
	 * Creates a object name
	 * 
	 * @param String
	 *            name of mbean, type of mbean, domain of mbean
	 */
	public ObjectName createObjectName(String name, String type, String domain) {
		try {
			return new ObjectName(domain + ":Name=" + name + ", Type=" + type);
		}
		catch (MalformedObjectNameException e) {
			System.out.println("Malformed object name: " + domain + ":Name="
					+ name + ", Type=" + type);
			e.printStackTrace(System.out);
			System.exit(3);
		}
		return null;
	}
}
