package coms.component;

import javax.management.MBeanServer;
import javax.management.MalformedObjectNameException;
import javax.management.NotificationFilter;
import javax.management.NotificationListener;
import javax.management.ObjectName;

public abstract class AbstractBinding implements NotificationFilter,
		NotificationListener {
	private MBeanServer server;
	private ObjectName mbean;

	public AbstractBinding() {
		super();
	}

	public AbstractBinding(MBeanServer server, String mbean)
			throws MalformedObjectNameException {
		this();
		this.server = server;
		this.mbean = new ObjectName(mbean);
	}

	protected boolean deliver(String method, Object... params) {
		String[] signature = new String[params.length];
		for (int i = 0; i < params.length; i++) {
			signature[i] = params[i].getClass().getName();
		}
		try {
			server.invoke(mbean, method, params, signature);
			return true;
		}
		catch (Exception e) {
			e.printStackTrace();
			return false;
		}
	}

	protected boolean deliver(Object param) {
		Object[] params = { param };
		return deliver(params);
	}

	public String getMbean() {
		return mbean.toString();
	}

	public void setMbean(String mbean) throws MalformedObjectNameException {
		this.mbean = new ObjectName(mbean);
	}
}
