/*
 * @(#)file      ComponentMBean.java
 * @(#)author    Mats Mortensen
 * @(#)version   0.9
 * @(#)lastedit  29.4.2005
 * 
 */
package coms.component;

import javax.management.NotificationFilter;
import javax.management.NotificationListener;
import coms.metadata.MetaData;

/**
 * Defines the interface which the class Component must implement These methods
 * will be accesible through jmx (mbeanserver)
 */
public interface ComponentMBean {
	public MetaData getMetaData();

	public void run();

	public void start();

	public void stop();

	public void initialize(MetaData data);

	public void onEvent(String table);

	public String getExtDir();

	public String getWebDir();

	public void setExtDir(String dir);

	public void setWebDir(String dir);

	public void addNotificationListener(NotificationListener listener,
			NotificationFilter filter, Object handback);

	public void removeNotificationListener(NotificationListener listener);
	
	public boolean isVerbose();
	
	public void setVerbose(boolean verbose);
}
