package coms.component;

import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.UnknownHostException;

public class UDPBinding extends Binding {
	private DatagramSocket socket;
	private DatagramPacket packet;
	private String host;
	private int port;
	private int timeout;
	private int packetSize = 1024;

	public UDPBinding() {}

	public void connect(String host, int port, int timeout) {
		this.host = host;
		this.port = port;
		this.timeout = timeout;
	}

	public void write(String msg) throws IOException, UnknownHostException {
		doWrite(msg.getBytes());
	}

	public void write(Object msg) throws IOException, UnknownHostException {
		;
		doWrite(objectToBytes(msg));
	}

	private void doWrite(byte[] bytes) throws IOException, UnknownHostException {
		InetAddress addr = InetAddress.getByName(host);
		if (socket == null)
			socket = new DatagramSocket();
		byte[] data = new byte[packetSize];
		int i = 0;
		int x = 0;
		while (true) {
			if (x == bytes.length) {
				packet = new DatagramPacket(data, i, addr, port);
				socket.send(packet);
				break;
			}
			if (i == data.length) {
				packet = new DatagramPacket(data, data.length, addr, port);
				socket.send(packet);
				i = 0;
			}
			data[i] = bytes[x];
			i++;
			x++;
		}
		socket.close();
		return;
	}

	public DataInputStream read() throws IOException, UnknownHostException {
		if (socket != null)
			socket.close();
		socket = new DatagramSocket(port);
		byte[] buf = new byte[packetSize];
		packet = new DatagramPacket(buf, buf.length);
		socket.setSoTimeout(timeout);
		socket.receive(packet);
		ByteArrayInputStream bstream = new ByteArrayInputStream(packet
				.getData());
		socket.close();
		return new DataInputStream(bstream);
	}
}
