package coms.core;

import java.util.ArrayList;
import java.util.List;

public abstract class GraphNode {
	protected List<GraphNode> IdependOn; // The components this component
	// depend on
	protected List<GraphNode> dependOnMe; // The components that depends on

	// this component
	public GraphNode() {
		IdependOn = new ArrayList<GraphNode>();
		dependOnMe = new ArrayList<GraphNode>();
	}

	public void addDependency(GraphNode node) {
		IdependOn.add(node);
		node.setDependsOnMe(this);
	}

	public void removeIDependOn(GraphNode node) {
		if (IdependOn.remove(node)) {
			node.removeDependsOnMe(this);
		}
	}

	public void removeDependsOnMe(GraphNode node) {
		dependOnMe.remove(node);
	}

	public boolean dependsOn(GraphNode node) {
		return IdependOn.contains(node);
	}

	public void setDependsOnMe(GraphNode node) {
		dependOnMe.add(node);
	}

	public List<GraphNode> getIDependOn() {
		return IdependOn;
	}

	public List<GraphNode> getDependOnMe() {
		return dependOnMe;
	}
}
