/*
 * @(#)file      JarValidityException.java
 * @(#)author    Mats Mortensen
 * @(#)version   0.9
 * @(#)lastedit  29.4.2005
 * 
 */
package coms.core;

/**
 * Describes an exception that can happen while checking the uniqueness,
 * structural or other validity concerning the components in a jar file
 */
public class JarValidityException extends Exception {
	private static final long serialVersionUID = 1L;
	String error;

	/**
	 * Constructor sets the error attribute
	 * 
	 * @param err
	 *            String of error
	 */
	public JarValidityException(String err) {
		super();
		error = err;
	}

	/**
	 * Returns the errormessage
	 * 
	 * @return error
	 */
	public String getMessage() {
		return error;
	}
}
