package coms.core.inference;
import org.xml.sax.SAXException;
import java.util.regex.Pattern;
import java.util.regex.Matcher;


public class Condition{
	private String cond;
	private String operator;
	private String lexp;
	private String rexp;
	private String lclassid;
	private String rclassid;
	private String lclass;
	private String rclass;
	
	private boolean islexpm = false;
	private boolean isrexpm = false;
	
	public Condition(String str) throws SAXException{
		this.cond = str;
		parseCondition(str);
	}
	
	public void setLClass(String cls){
		this.lclass = cls;
	}
	
	public void setRClass(String cls){
		this.rclass = cls;
	}
	
	private boolean hasNumber(String s) {
	  for (int j = 0;j < s.length();j++) {
	    if (!Character.isDigit(s.charAt(j))) {
	      return false;
	    }
	  }
	  return true;
	}
	
	private boolean isValue(String s){
		Pattern p = Pattern.compile("true");
	 	Matcher m = p.matcher(s);
	 	if(m.find())
	 		return true;
	 		
		p = Pattern.compile("false");
	 	m = p.matcher(s);
	 	if(m.find())
	 		return true;
	 		
	 	return hasNumber(s);
	 		
	}

	
	private void parseCondition(String condition) throws SAXException{
		String[] parts = null;
		boolean found = false;
		
		String[] operators = {"==", ">", "<", "!="};
		
		// Check each operator
		for(int i=0;i<operators.length;i++){
			
	 		Pattern p = Pattern.compile(operators[i]);
	 		Matcher m = p.matcher(condition);
			
			// Find operator if any
			if(m.find()){
				found = true;
				
				//Split the string to obtain the method(s)
				parts = condition.split(operators[i]);
				
				// If left exp is method
				if(!isValue(parts[0].trim())){
				
					// Get left method
					String[] tmp = parts[0].split("\\.");
					this.lclassid = tmp[0].trim();
					this.lexp = tmp[1].trim();
					islexpm = true;
				}else{
					
					// Save left value
					this.lexp = parts[0];
					islexpm = false;
				}
				
				// If right exp is method
				if(!isValue(parts[1].trim())){
					// Get right method
					String[] tmp = parts[1].split("\\.");
					this.rclassid = tmp[0].trim();
					this.rexp = tmp[1].trim();
					isrexpm = true;
				}else{
					
					// Save right value
					this.rexp = parts[1].trim();
					isrexpm = false;
				}
				
				// Save the operator
				this.operator = operators[i].trim();
				
			}
		}
		
		if(found == false)
			throw new SAXException("Conditions must be on the form: <exp> <operator> <exp>");
	}
	
	public String getCond(){
		return this.cond;
	}
	
	public String getOperator(){
		return this.operator;
	}
	
	public boolean isLExpMethod(){
		return this.islexpm;
	}
	
	public boolean isRExpMethod(){
		return this.isrexpm;
	}
	
	public String getLExp(){
		return this.lexp;
	}
	
	public String getRExp(){
		return this.rexp;
	}
	
	public String getLClassid(){
		return this.lclassid;
	}
	
	public String getRClassid(){
		return this.rclassid;
	}
	
	public String getLClass(){
		return this.lclass;
	}
	
	public String getRClass(){
		return this.rclass;
	}
	
	
}