/*
 * @(#)file      ComponentAgentMBean.java
 * @(#)author    Mats Mortensen
 * @(#)version   0.9
 */
package coms.mbeans;

import coms.metadata.MetaData;

/**
 * An interface which specifies what methods the ComponentAgent class must
 * implement. It is also these methods who are exposed through JMX (the
 * mbeanserver)
 */
public interface ComponentAgentMBean {
	public void registerComponent(MetaData data, Class componentClass)
			throws Exception;

	public void unRegisterComponent(MetaData data);

	public void createRMIConnector(String listenURL);

	public Boolean startRMIServer();

	public void stopRMIServer();
}
