/**
 *This class is an interface for the ComponentManager class
 *@author Mats Mortensen
 *@see ComponentManager.java
 */
package coms.mbeans;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Set;
import coms.metadata.ComponentInfo;
import coms.metadata.MetaData;

public interface ComponentManagerMBean {
	public void addComponent(MetaData data);

	public Boolean removePackage(String pkg);

	public LinkedHashSet<ComponentInfo> getComponentList();

	public Set getComponentObjectNames();

	public Boolean changeComponentConfig(String comID,
			HashMap<String, String> param);

	public HashMap<String, String> _getComponentConfig(String comID);

	public void _setComponentStatus(String comID, Boolean status);

	public Boolean _getComponentStatus(String comID);

	public void startComponent(String comID);

	public void stopComponent(String comID);

	public LinkedHashMap<String, ArrayList<String>> getPackageList();

	public void removeComponent(MetaData data);
}
