package coms.mbeans;

import java.sql.SQLException;
import coms.database.ConnectionException;
import coms.database.DatabaseConnection;
import coms.metadata.Table;

/**
 * Interface for the Derby class
 * 
 * @author Tom Arild Jakobsen & Mats Mortensen
 */
public interface DerbyMBean {
	DatabaseConnection getConnection() throws ConnectionException;

	void terminateConnection(DatabaseConnection con);

	Integer getConnections();

	Boolean createTable(Table tbl) throws SQLException, ConnectionException;

	Boolean validateTable(Table tbl) throws SQLException, ConnectionException;

	Boolean dropTable(Table tbl) throws SQLException, ConnectionException;

	void shutdown() throws SQLException, ConnectionException;
}
