package coms.metadata;

import java.util.LinkedHashMap;

public class DeploymentDescription {
	private String jarPackage;
	private ServiceDescription serviceDesc;
	private LinkedHashMap<String, MetaData> componentMap;

	public DeploymentDescription(String name) {
		this.jarPackage = name;
		this.componentMap = new LinkedHashMap<String, MetaData>();
	}

	public String getJarPackage() {
		return this.jarPackage;
	}

	public void setJarPackage(String pkg) {
		this.jarPackage = pkg;
	}

	public String getServiceVersion() {
		return this.serviceDesc.getService().getVersion();
	}

	public ServiceDescription getServiceDescription() {
		return this.serviceDesc;
	}

	public void setServiceDescription(ServiceDescription s) {
		this.serviceDesc = s;
	}

	public void setComponentMap(LinkedHashMap<String, MetaData> map) {
		componentMap.putAll(map);
	}

	public LinkedHashMap<String, MetaData> getComponentMap() {
		return this.componentMap;
	}
}
