package coms.metadata;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import coms.core.DeploymentException;

public class MetaDataWriter {
	public static void write(MetaData data, File folder)
			throws DeploymentException {
		FileWriter file = null;
		try {
			File metadataFile;
			metadataFile = new File(folder, data.getName() + ".xml");
			metadataFile.createNewFile();
			file = new FileWriter(metadataFile);
			// FINDS WRITER TYPE
			// String dtd = "";
			if (data.getType().equalsIgnoreCase("input"))
				ICMetaDataWriter.write(data, file);
			else if (data.getType().equalsIgnoreCase("processing"))
				PCMetaDataWriter.write(data, file);
			else if (data.getType().equalsIgnoreCase("output"))
				OCMetaDataWriter.write(data, file);
			else if (data.getType().equalsIgnoreCase("config"))
				IConfigMetaDataWriter.write(data, file);
			else {
				file.close();
				throw new DeploymentException("Unknown component type: "
						+ data.getType());
			}
			file.close();
		}
		catch (IOException e) {
			try {
				file.close();
			}
			catch (Exception e2) {}
			throw new DeploymentException(e.toString());
		}
	}
}
