package coms.metadata;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class Service {
	private String name;
	private String version;
	private String dbType;
	private ArrayList<Service> depOnMe;
	private ArrayList<Service> iDepOn;
	private ArrayList<String> componentList;
	private String description;
	private HashMap<String, ServiceOperation> operationMap;
	private boolean isEnabled;

	public Service() {
		depOnMe = new ArrayList<Service>();
		iDepOn = new ArrayList<Service>();
		componentList = new ArrayList<String>();
		operationMap = new HashMap<String, ServiceOperation>();
		isEnabled = true;
	}

	public void setDbType(String v) {
		this.dbType = v;
	}

	public String getDbType() {
		return this.dbType;
	}

	public void setVersion(String v) {
		this.version = v;
	}

	public String getVersion() {
		return this.version;
	}

	public boolean isEnabled() {
		return isEnabled;
	}

	public void setEnabled(boolean isEnabled) {
		this.isEnabled = isEnabled;
	}

	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public List getIDependOn() {
		return this.iDepOn;
	}

	public void addIDependOn(Service dep) {
		iDepOn.add(dep);
		dep.addDependsOnMe(this);
	}

	public void addDependsOnMe(Service dep) {
		depOnMe.add(dep);
	}

	public List getDependOnMe() {
		return this.depOnMe;
	}

	public void addComponent(String com) {
		componentList.add(com);
	}

	public String getDescription() {
		return this.description;
	}

	public void setDescription(String desc) {
		this.description = desc;
	}

	public ArrayList getComponentList() {
		return this.componentList;
	}

	public void addOperation(ServiceOperation op) {
		this.operationMap.put(op.getName(), op);
	}

	public HashMap getOperationMap() {
		return this.operationMap;
	}
}
