package coms.metadata;

import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

/* 
 Error handler that decides what is going to happen when the xml metadata
 file does not validate.
 */
public class ValidityErrorHandler implements ErrorHandler {
	private String xmlfile;

	public ValidityErrorHandler(String xmlfile) {
		this.xmlfile = xmlfile;
	}

	public void error(SAXParseException e) throws SAXException {
		String msg = "<span style=\"color:red\">Error: </span> The metadata file \""
				+ xmlfile
				+ "\" did not validate. <br> Caused by: "
				+ e.getMessage();
		throw new SAXException(msg);
	}

	public void fatalError(SAXParseException e) throws SAXException {
		String msg = "<span style=\"color:red\">Fatal error: </span> The metadata file \""
				+ xmlfile
				+ "\" did not validate. <br> Caused by: "
				+ e.getMessage();
		throw new SAXException(msg);
	}

	public void warning(SAXParseException e) throws SAXException {
		String msg = "<span style=\"color:red\">Warning: </span> The metadata file \""
				+ xmlfile
				+ "\" did not validate. <br> Caused by: "
				+ e.getMessage();
		throw new SAXException(msg);
	}
}
