package coms.tools.inference;
import org.drools.*;
import org.drools.io.*;
import org.xml.sax.SAXException;
import java.io.IOException;
import java.sql.SQLException;
import coms.database.ConnectionException;
import java.util.List;
import coms.core.inference.NoRuleSetLoadedException;
import coms.core.inference.LoadException;

public interface Engine{
	
	public void loadRules(String rulefile) throws SAXException, IOException, IntegrationException, FactException, LoadException;
	public FactHandle getFactHandle(Object obj) throws FactException, NoRuleSetLoadedException;
	public Object getObject(FactHandle handle) throws FactException, NoRuleSetLoadedException;
	public FactHandle assertObject(Object obj) throws FactException, SQLException, ConnectionException, NoRuleSetLoadedException;
	public void retractObject(FactHandle handle) throws FactException, NoRuleSetLoadedException;
	public void modifyObject(FactHandle handle, Object obj) throws FactException, NoRuleSetLoadedException;
	public List getObjects() throws FactException, NoRuleSetLoadedException;
	public void fireRules() throws FactException, NoRuleSetLoadedException;
}