package com.telenor.apms.fifamos.client.j2se.gui;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

public class AboutDialog extends Dialog {
	private Shell shell;
	
	public AboutDialog(Shell parent, int style) {
		super(parent, style);
		shell = new Shell(parent);
		shell.setImage(new Image(parent.getDisplay(), "fish_small.png"));
		shell.setLayout(new GridLayout(2, false));
		shell.setText("Om FiFaMoS");
		shell.setSize(600,600);
		
		Label logoLabel = new Label(shell, 0);
		logoLabel.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		logoLabel.setImage(new Image(shell.getDisplay(), "logo.png"));
		
		StyledText aboutText = new StyledText(shell, SWT.NONE|SWT.READ_ONLY);
		aboutText.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		String heading = "FiFaMoS - the Fish Farm Monitoring System";
		StyleRange style1 = new StyleRange();
		style1.start = 0;
		style1.length = heading.length();
		style1.fontStyle = SWT.BOLD;
		aboutText.setText(heading);
		aboutText.setStyleRange(style1);
		aboutText.setBackground(new Color(shell.getDisplay(), 225,225,225));
		aboutText.append("\n==============================\n\nCreated by Jon Arne Grdal and Frank Paaske \n\nas a part of a master thesis. \n\nThe project was carried out at Telenor R & D \n\nTyholt, spring 2006. \n");
		
		Label emptySpace = new Label(shell, 0);
		emptySpace.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		
		Button okButton = new Button(shell, SWT.PUSH);
		okButton.setText("OK");
		okButton.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, false, 1, 1));
		okButton.setImage(new Image(parent.getDisplay(), "button_ok.png"));
		okButton.setToolTipText("OK");
		okButton.addSelectionListener(new SelectionListener() {
			public void widgetDefaultSelected(SelectionEvent e) {
			}
		
			public void widgetSelected(SelectionEvent e) {
				shell.dispose();
			}
		});
		shell.pack();
		shell.open();
		shell.setActive();
	
        while (!shell.isDisposed())
            if (!shell.getDisplay().readAndDispatch()) shell.getDisplay().sleep();
		
	}
}
