package com.telenor.apms.fifamos.client.j2se.gui;
/**
 * JavaClient.java
 * 
 * GUI class
 * 
 * @author JAG
 * @copyright JAG  2006
 * @version 1.0
 */

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.sql.Timestamp;
import java.util.Date;
import java.util.Iterator;
import java.util.Stack;
import java.util.Timer;
import java.util.TimerTask;
import java.util.Vector;


import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.CoolBar;
import org.eclipse.swt.widgets.CoolItem;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;
import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import com.sun.org.apache.xerces.internal.jaxp.SAXParserFactoryImpl;
import com.telenor.apms.fifamos.client.j2se.objects.Alarm;
import com.telenor.apms.fifamos.client.j2se.objects.Frame;
import com.telenor.apms.fifamos.client.j2se.objects.SeaCage;
import com.telenor.apms.fifamos.client.j2se.objects.Sensor;
import com.telenor.apms.fifamos.client.j2se.objects.SensorValue;
import com.telenor.apms.fifamos.client.j2se.utils.Constants;
import com.telenor.apms.fifamos.client.j2se.utils.RPCHandler;
import com.telenor.apms.fifamos.client.j2se.utils.RpcHandlerResult;
import com.telenor.apms.fifamos.client.j2se.utils.SaveFile;
import com.telenor.apms.fifamos.client.j2se.utils.SensorInfo;
import com.telenor.apms.fifamos.client.j2se.utils.SettingsIO;
import com.telenor.apms.fifamos.client.j2se.utils.StringVector;

public class FiFaMoS extends DefaultHandler implements RpcHandlerResult {
	private Frame frame;
	private SensorInfo si;
	private long period = Constants.PERIOD_HOUR;//sets history period to one hour as default
	private SeaCage currentSeaCage;
	private Sensor currentSensor;
	
	private Display display;
	private Shell shell;
	private Group sensorValueGroup;
	private Composite sensorValueComposite;
	private Composite radioComposite;
	private Composite graphComposite;
	private Canvas graphCanvas;
	private Composite statusComposite;
	private StyledText statusText;
	private final Tree tree;
	private Vector<String> receivedAlarms = new Vector<String>();
	
	private Timer timer;
	private RPCHandler rpc = new RPCHandler();
	private int[][] toBeDrawn;
	private int height = 0;
	private int width = 0;
	private long maxY;
	private long maxX;
	private long minX;
	private double factorX;
	private double factorY;
	private long minY = 0;
	private Stack<String> qNames = new Stack<String>();
	private TreeItem fItem;
	private StringBuffer sb;
	private TreeItem scItem;
	private TreeItem sItem;
	private SensorValue currentSensorValue;
	private Label t;
	private Button b;
	private Label seperator;
	private Text gpsText;
	private String longitude;
	private String latitude;
	private Sensor sensor;
	private String lastStatus = "";
	private boolean first;


	public FiFaMoS() {

		display = new Display ();
		shell = new Shell(display);
		shell.setLayout(new GridLayout(2, true));
		shell.setText("FiFaMoS client");
		shell.setSize (1024,768);
		shell.setImage(new Image(display, "fish_small.png"));
		shell.setMaximized(true);
		
		Composite toolBarComposite = new Composite(shell, SWT.NONE);
		toolBarComposite.setLayoutData(new GridData(SWT.TOP, SWT.LEFT, false, false, 2, 1));
		toolBarComposite.setLayout(new GridLayout(1, true));
		
		ToolBar bar = new ToolBar(toolBarComposite, SWT.NONE);
		
		//Tree for navigation
		tree = new Tree (shell, SWT.BORDER);
		tree.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		tree.setFont(new Font(display, "arial", 12, SWT.BOLD));
		
		//Composite for textboxes, buttons 
		sensorValueComposite = new Composite (shell, 0);
		sensorValueComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		sensorValueComposite.setLayout(new GridLayout(1, false));
		
		//comosite for statusbox
		statusComposite = new Composite (shell, 0);
		statusComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		statusComposite.setLayout(new GridLayout(4, false));
		
		//composite for graph
		graphComposite = new Composite (shell, 0);
		graphComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		graphComposite.setLayout(new GridLayout(1, false));

		//Listener for status-knapper
		Listener statusListener = new Listener() {
			public void handleEvent(Event e) {
				if(((ToolItem)e.widget).getText().equals("Lagre logg")) {
					debug("lagrer til fil..");
					try {
						new SaveFile(statusText.getText());
						updateStatus("Logg lagret til fil", 0);
					} catch (Exception ex) {
						updateStatus("Noe gikk galt under skriving til fil: "+ex.getMessage(), 1);
						ex.printStackTrace();
					}
				}
				else if(((ToolItem)e.widget).getText().equals("Visk ut logg")) {
					debug("visker ut");
					statusText.setText("");
					receivedAlarms.removeAllElements();
					initialize();
				}
				else if(((ToolItem)e.widget).getText().equals("Konfigurasjon")) {
					debug("Innstillinger");
					Settings settings = new Settings(shell, SWT.NONE);
					try {
						timer.cancel();
					}
					catch (Exception ex) {
						// ignored
					}
					if(settings.openSettings()) {
						initialize();//settings windows returns true when it is closed
					}
				}
				else if(((ToolItem)e.widget).getText().equals("Kvittr alarmer")) {
					debug("Kvittr alarmer");
					String res = "";
					try {
						res = rpc.confirmAlarms();
						debug("res: "+res);
						if(res.equalsIgnoreCase("ok")) {
							updateStatus("Alarmer kvittert", 0);
						} else updateStatus(res, 1);
						receivedAlarms.removeAllElements();
					} catch (Exception e1) {
						debug("feil: "+res);
						e1.printStackTrace();
					}
				}
				else if(((ToolItem)e.widget).getText().equals("Avslutt")) {
					shell.dispose();
				}
				else if(((ToolItem)e.widget).getText().equals("Om programmet")) {
					new AboutDialog(shell, SWT.NONE);
				}
				
			}
		};
		
		//Listener for radiobuttons
		Listener radioListener = new Listener () {
			public void handleEvent (Event event) {
				debug("event."+event.toString());
				Control [] children = radioComposite.getChildren ();
				for (int j=0; j<children.length; j++) {
					Control child = children [j];
					if (child instanceof Button) {
						Button button = (Button) child;
						if ((button.getStyle () & SWT.RADIO) != 0) button.setSelection (false);
					}
				}
				Button button = (Button) event.widget;
				period = Long.parseLong((String)button.getData());
				debug("periode satt til: "+period);
				if(currentSensor!=null) {
					showGraph();
				}
				button.setSelection (true);
			}
		};
		

		//Listener for the tree
		tree.addListener (SWT.Selection, new Listener () {
			public void handleEvent (Event event) {
				//something is fishy round here
				try {
					System.out.println ("getSel: "+ tree.getSelection()[0].getText());
					Object o = tree.getSelection()[0].getData();
					if (o instanceof SeaCage) {
						currentSeaCage = (SeaCage) o;
						getSensorInfo();
						updateStatus("Henter sensorinfo for sea-cage: "+currentSeaCage.getId(), 0);
					}
				}
				catch(Exception e) {
					e.printStackTrace();
				}
			}
		});
		
//		Buttons for the toolbar:
		
		//Settings button
		ToolItem settingsButton = new ToolItem(bar, SWT.PUSH);
		settingsButton.setText("Konfigurasjon");
		settingsButton.addListener(SWT.Selection, statusListener);
		settingsButton.setImage(new Image(display, "advancedsettings.png"));
		settingsButton.setToolTipText("pner dialogen for innstillinger");

		//save button
		ToolItem saveToFileButton  = new ToolItem(bar, SWT.PUSH);
		saveToFileButton.setText("Lagre logg");
		saveToFileButton.addListener(SWT.Selection, statusListener);
		saveToFileButton.setImage(new Image(display, "filesave.png"));
		saveToFileButton.setToolTipText("Lagrer loggen til en fil p disken");
		
		//Clear status button
		ToolItem clearStatusButton = new ToolItem(bar, SWT.PUSH);
		clearStatusButton.setText("Visk ut logg");
		clearStatusButton.addListener(SWT.Selection, statusListener);
		clearStatusButton.setImage(new Image(display, "erase.png"));
		clearStatusButton.setToolTipText("Visker ut statusvinduet");
		
		//Clear alarms button
		ToolItem clearAlarmsButton = new ToolItem(bar, SWT.PUSH);
		clearAlarmsButton.setText("Kvittr alarmer");
		clearAlarmsButton.addListener(SWT.Selection, statusListener);
		clearAlarmsButton.setImage(new Image(display, "alert2.png"));
		clearAlarmsButton.setToolTipText("Kvitterer alarmer");
		
//		About button
		ToolItem aboutButton = new ToolItem(bar, SWT.PUSH);
		aboutButton.setText("Om programmet");
		aboutButton.addListener(SWT.Selection, statusListener);
		aboutButton.setImage(new Image(display, "fish.png"));
		aboutButton.setToolTipText("Om programmet");

//		Close button
		ToolItem exitButton = new ToolItem(bar, SWT.PUSH);
		exitButton.setText("Avslutt");
		exitButton.addListener(SWT.Selection, statusListener);
		exitButton.setImage(new Image(display, "exit.png"));
		exitButton.setToolTipText("Gr ut av programmet");

		//		bar.pack ();
		
		//Textarea for statusinfo
		statusText = new StyledText(statusComposite, SWT.V_SCROLL|SWT.BORDER|SWT.READ_ONLY|SWT.MULTI|SWT.WRAP);
		statusText.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 4, 1));
		statusText.setBackground(new Color(display, 225,225,225));

		//Canvas for graph
		graphCanvas = new Canvas(graphComposite, SWT.BORDER);
		graphCanvas.setSize(SWT.FILL,SWT.FILL);
		graphCanvas.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		graphCanvas.addListener(SWT.Paint, new Listener() {
		
			public void handleEvent(Event event) {
				height = graphCanvas.getBounds().height - (int)(graphCanvas.getBounds().height*0.1);
				width = graphCanvas.getBounds().width - (int)(graphCanvas.getBounds().width*0.1);
				//tegner graph	
				if(toBeDrawn!=null) {
					// Tegner akser
					GC gc = event.gc;
					gc.setBackground(new Color(display, 255,255,255));
					gc.fillRectangle(0,0,graphCanvas.getBounds().width,graphCanvas.getBounds().height);
					gc.drawLine(20,height,width,height);
					gc.drawLine(20,height,20,20);
					gc.drawString("Graf for "+ currentSensor.getTypeName() +" p sea-cage "+currentSeaCage.getId(), 40,1);

					
//					Tegner alarmgrenser 
					gc.setForeground(new Color(display, 255, 0, 0));
					int maxValueInt = (int)currentSensor.getMaxValue();
					int minValueInt = (int)currentSensor.getMinValue();
					
					maxValueInt = (int)(((maxValueInt-minY)*factorY));
					minValueInt = (int)(((minValueInt-minY)*factorY));
//					System.out.println("etter  *********       "+maxValueInt);
					
					gc.drawLine(20, turn(maxValueInt), width, turn(maxValueInt));
					gc.drawLine(20, turn(minValueInt), width, turn(minValueInt));
					
					// Tegner kurve
					gc.setForeground(new Color(display, 0, 0, 255));
					gc.setLineWidth(2);
					for(int i =0;i<(toBeDrawn.length-1);i++) {
						//debug("tegner: "+ toBeDrawn[i][1]+","+ turn(toBeDrawn[i][0])+","+ toBeDrawn[i+1][1]+","+ turn(toBeDrawn[i+1][0]));
						gc.drawLine(toBeDrawn[i][1], turn(toBeDrawn[i][0]), toBeDrawn[i+1][1], turn(toBeDrawn[i+1][0]));
					}
					
					gc.setForeground(new Color(display, 0, 0, 0));

					int startPoint = height-10; // starting point for drawing values on Y-axis
					int axisDy = ((height+17)/9)+1; // Distance between y-values. 9 is number of values on Y-axis
					double yValueDy = (double) ((double)(maxY-minY)/8.0);
					
					// draw Yaxis-values
					if(maxY>10) {
						for (int i = 0; i < 9; i++) {
							long yValue = Math.round(minY+(double)i*yValueDy);
							gc.drawString(String.valueOf(yValue), 0, startPoint-i*axisDy);
						}
					}
//					if values are under 10, decimals are drawn
					else {
						for (int i = 0; i < 9; i++) {
							double yValue = (double)(minY+(double)i*yValueDy);
							gc.drawString(String.valueOf(yValue).substring(0,3), 0, startPoint-i*axisDy);
						}
					}
					Date start = new Date((long)minX*1000);
					Date end = new Date((long)maxX*1000);
					if(period==Constants.PERIOD_HOUR|period==Constants.PERIOD_MINUTE) {
						
						String startMinutes = String.valueOf(start.getMinutes());
						if(startMinutes.length()==1) startMinutes = "0"+startMinutes;
						
						String endMinutes = String.valueOf(end.getMinutes());
						if(endMinutes.length()==1) endMinutes = "0"+endMinutes;
						
						String startString = start.getHours()+":"+startMinutes;
						String endString = end.getHours()+":"+endMinutes;
						
						gc.drawString(startString, 15 ,(height+2));
						gc.drawString(endString, (width-30) ,(height+2));
					}
					else {
						String endString = end.toString();
						String startString = start.toString();
						endString = endString.substring(0,10);
						startString = startString.substring(0,10);
						
						gc.drawString(startString, 15 ,(height+2));
						gc.drawString(endString, (width-30) ,(height+2));
					}
				}
			}
		});
		//composite for radioButtons
		radioComposite = new Composite (graphComposite, 0);
		radioComposite.setLayoutData(new GridData(SWT.FILL, SWT.BOTTOM, false, false, 1, 1));
		radioComposite.setLayout(new GridLayout(3, true));
		
		
		//Radio buttons for choosing history period
		
//		Button minute = new Button(radioComposite, SWT.RADIO);
//		minute.setText("Siste minutt");
//		minute.setData(String.valueOf(Constants.PERIOD_MINUTE));
//		minute.addListener(SWT.MouseUp, radioListener);
		
		Button hour = new Button(radioComposite, SWT.RADIO);
		hour.setText("Siste time");
		hour.setSelection(true);
		hour.setData(String.valueOf(Constants.PERIOD_HOUR));
		hour.addListener(SWT.MouseUp, radioListener);

		Button day = new Button(radioComposite, SWT.RADIO);
		day.setText("Siste dgn");
		day.setData(String.valueOf(Constants.PERIOD_DAY));
		day.addListener(SWT.MouseUp, radioListener);
		
		Button week = new Button(radioComposite, SWT.RADIO);
		week.setText("Siste uke");
		week.setData(String.valueOf(Constants.PERIOD_WEEK));
		week.addListener(SWT.MouseUp, radioListener);
		
	
		if(Constants.displaySplash) {
			final Splash splash = new Splash(shell, SWT.NONE);
			splash.setSteps(20);
			splash.setImage(new Image(display, "aqua_sogn.jpg"));
			splash.open();
		}
		
		shell.open ();
		initialize();
		
		
		
		while (!shell.isDisposed() ) {
			if (!display.readAndDispatch() ) display.sleep ();
		}
		if(si!=null)
			timer.cancel();
		display.dispose ();
	}
	public void selectFirst() {
		//get sensor data from the first sea cage
		try {
			currentSeaCage = (SeaCage)tree.getSelection()[0].getData();
			getSensorInfo(	);
			
			//TODO: Could probably be done in a more smooth way...
			Vector<Sensor> result = new Vector<Sensor>();
			result = rpc.getAllSensors(""+currentSeaCage.getId());
			currentSensor = result.get(0); 
			showGraph();
		} catch(Exception e) {
		}
	}
	
	public void initialize() {
		String welcomeString = "Velkommen til FiFaMoS - the Fish Farm Monitoring System\n***********************************************\n\n";
		StyleRange style1 = new StyleRange();
		style1.start = 0;
		style1.length = welcomeString.length();
		style1.fontStyle = SWT.BOLD;
		style1.foreground = new Color(display, 0,0,255);
		statusText.setText(welcomeString);
		statusText.setStyleRange(style1);
		
//		statusText.append("Henter alle frames og seacages fra databasen...");
		
		updateStatus("Henter alle frames og seacages fra databasen...",0);
		statusText.append("\n");
		//get settings
		SettingsIO sio = new SettingsIO();
		sio.readSettings();	
		
		loadTree();
		selectFirst();
	}
	
	private void getSensorInfo() {
		if(si!=null)
			timer.cancel();
		
		//schedule RPC-call for updating sensorinfo
		si = new SensorInfo(String.valueOf(currentSeaCage.getId()), this);
		timer = new Timer();
		timer.scheduleAtFixedRate(new TimerTask() {
			public void run() {
				display.asyncExec(si);
			}
		}, 50, Constants.REFRESH_INTERVAL);
	}
	
	public void passResult(Vector<Sensor> sensorInfo, Vector<Alarm> alarmInfo, String gpsData) {
		//Group for textboxes and buttons
		if(sensorValueGroup!=null) 
			sensorValueGroup.dispose();
		sensorValueGroup = new Group(sensorValueComposite, SWT.NONE);
		sensorValueGroup.setLayout(new GridLayout(2,false));
		sensorValueGroup.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		sensorValueGroup.setText("Nvrende sensorverdier for sea-cage: " + currentSeaCage.getId());
		
		//add  textboxes and buttons for sensorinfo dynamically
		for (Iterator iter = sensorInfo.iterator(); iter.hasNext();) {
			sensor = (Sensor) iter.next();

			t = new Label (sensorValueGroup, SWT.SHADOW_ETCHED_IN);
			t.setBounds (10, 10, 400, 20);
			t.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
			t.setText(sensor.toString()/* + ": "+sensor.getCurrentValue() */);
			t.setFont(new Font(display, "arial", 12, SWT.BOLD));
			
			b = new Button(sensorValueGroup, SWT.PUSH);
			b.setText("Vis graf for "+sensor.getTypeName());
			b.setData(sensor);
			b.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
			b.setImage(new Image(display, "graph.png"));
			b.setToolTipText("Vis graf for "+sensor.getTypeName());
			
			//Listener for graph buttons
			b.addSelectionListener(new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					currentSensor = (Sensor)((Button)e.widget).getData();
					showGraph();
				}
			});
			
			seperator = new Label (sensorValueGroup, SWT.SEPARATOR | SWT.HORIZONTAL);
			seperator.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 2, 1));
		}
		if(alarmInfo!=null) {
			for(int i=0;i<alarmInfo.size();i++) {
				
				if(!receivedAlarms.contains(alarmInfo.get(i).getID())) {
					receivedAlarms.add(alarmInfo.get(i).getID());
					updateStatus(alarmInfo.get(i).toString(), 1);		
				}
			}
		}
		
//		new Label (sensorValueGroup, SWT.SEPARATOR | SWT.HORIZONTAL);
//		new Label (shell, SWT.SEPARATOR | SWT.VERTICAL);
		
		//Update GPS-info
		gpsText = new Text(sensorValueGroup, SWT.READ_ONLY|SWT.MULTI|SWT.WRAP);
		gpsText.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		gpsText.setText("Lokasjon: \n");
		
		//Map button
		b = new Button(sensorValueGroup, SWT.PUSH);
		b.setText("Vis lokasjon i kart");
		b.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		b.setImage(new Image(display, "map.png"));
		b.setToolTipText("Vis lokasjon i kart");
		
		StringVector sv = new StringVector(gpsData, ':');
		latitude = sv.stringElementAt(0);
		longitude = sv.stringElementAt(1);
		gpsText.append("\nBreddegrad: "+latitude);
		gpsText.append("\nLengdegrad: "+longitude);
		
		//Listener for graph buttons
		b.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				showMap(latitude, longitude);				
			}
		});

		

//		Make the sensorvalues fill width of composite
		sensorValueGroup.setSize (sensorValueComposite.getBounds().width, sensorValueComposite.getBounds().height);

	}

	private void showGraph() {

		Runnable r = new Runnable() {
			public void run() {
				maxY = (long) currentSensor.getMaxRange();
				minY = (long) currentSensor.getMinRange();
				maxX = new Date().getTime()/1000;
				minX = maxX-period;
				toBeDrawn = normalize(rpc.getHistoryForSensor(currentSensor.getId(), period)); 
				graphCanvas.redraw();
			}
		};
		updateStatus("Tegner graf for sensor: "+currentSensor.getId(), 0);
		display.asyncExec(r);					
	}
	
	private void showMap(String latitude, String longitude) {
		if(!latitude.equalsIgnoreCase("no gps")) {
			InputBox ib = new InputBox(shell, SWT.BORDER);
			ib.setMessage("Skriv inn nsket zoom (tall fra 1 til 10");
			ib.setText("Zoom");
			ib.setDefaultText("5");
			MapDialog md = new MapDialog(shell, SWT.NONE);
			int zoom = 5;
			try {
				String zoomString = ib.open();
				if(zoomString!=null) {
					zoom = Integer.parseInt(zoomString);
				updateStatus("Et yeblikk, henter kart...", 0);
				md.showMap(latitude, longitude, zoom);
				}
				
			} catch (Exception e) {
				updateStatus("Et yeblikk, henter kart...", 0);
				md.showMap(latitude, longitude, zoom);
			}

		}
		else
			updateStatus("GPS-data ikke tilgjengelig, kart vil ikke bli vist.", 1);
	}
	
	public void updateStatus(String newStatus, int type) {

		if(type>0)
			System.err.println(newStatus);
		else
			System.out.println(newStatus);
		switch (type) {
		case 0:
			statusText.append(new Date().toLocaleString()+": "+newStatus+"\n");
			lastStatus = newStatus;
			break;
		case 1:
			statusText.append(new Date().toLocaleString()+": ");
			StyleRange style1 = new StyleRange();
			style1.start = statusText.getText().length();
			style1.length = newStatus.length();
			style1.fontStyle = SWT.BOLD;
			style1.foreground = new Color(display, 255,0,0);
			
			statusText.append(newStatus+"\n");
			statusText.setStyleRange(style1);
			break;
		case 2:
			statusText.append(new Date().toLocaleString()+": ");
			StyleRange style2 = new StyleRange();
			style2.start = statusText.getText().length();
			style2.length = newStatus.length();
			style2.fontStyle = SWT.BOLD|SWT.ITALIC;
			style2.foreground = new Color(display, 255,0,0);
			
			statusText.append(newStatus+"\n");
			statusText.setStyleRange(style2);
			System.out.println("Alvorlig feil, stopper timer!");
			timer.cancel();
			break;
		default:
			break;
		}
	}
	private int[][] normalize(long [][] values) {	//Normalize Y and X graph values to composite size:
		debug("normalizing");
		int[][] res = new int[values.length][2];
				
//		//Find Y and X factors
		factorY = (height-20)/(double)(maxY-minY);
		factorX = (width-width*0.03)/(maxX-minX);
		
		//Normalize to screen size
		for (int i = 0; i < values.length; i++) {
			values[i][1] = (values[i][1] - minX);
			values[i][0] = (values[i][0] - minY);
			res[i][1] = (int)(values[i][1]*factorX+20);	
			res[i][0] = (int)(values[i][0]*factorY);
		}
		return res;
	}
	
	private int turn(int i) {
		return height-i;
	}

	private void debug(String string) {
		System.out.println("JavaClient debug***" +string);
	}

	public static void main(String[] args) {
		new FiFaMoS();
	}
	
	private void loadTree() {
		tree.removeAll();
		try {
			SAXParser parser = SAXParserFactoryImpl.newInstance().newSAXParser();
			parser.parse(
					new InputSource(
							new ByteArrayInputStream(
									rpc.getFishFarmAsXml().getBytes())), this);
			updateStatus("Ferdig... Velg en sea cage for  se sensorinformasjon." , 0);
			
		} catch (ParserConfigurationException e) {
			updateStatus("Noe gikk galt med parsing av resultat: "+e.getMessage()+"\nDet er sannsynligvis noe feil med konfigurasjonen av parseren. Vennligst henvend deg til systemansvarlig.", 1);
			e.printStackTrace();
		} catch (SAXException e) {
			updateStatus("Noe gikk galt med parsing av resultat: "+e.getMessage(), 1);
			e.printStackTrace();
		} catch (IOException e) {
			updateStatus("Noe gikk galt: "+e.getMessage()+"\nSjekk serverinnstillingen",1);
			e.printStackTrace();
		} catch (Exception e) {
			updateStatus("Noe gikk galt: "+e.getMessage()+"\nKontakt systemansvarlig", 1);
			e.printStackTrace();
		}
		
	}
	
	@Override
	public void startDocument() throws SAXException {
		first = true;
	}

	@Override
	public void startElement(String uri, String localName, String qName, Attributes attributes) throws SAXException {
		qNames.push(qName);
		sb = new StringBuffer();
		
		if(qName.equals("frame")) {
//			starting on the frame
			frame = new Frame();
		} else if(qName.equals("seacage")) {
			
//			starting on the sea cage
			currentSeaCage = new SeaCage();
		} else if(qName.equals("sensor")) {
			
//			starting with the sensor
			currentSensor = new Sensor();
		} else if(qName.equals("sensorvalue")) {
			
//			starting with the sensor value
			currentSensorValue = new SensorValue();
		}
	}

	
	@Override
	public void characters(char[] ch, int start, int length) throws SAXException {
		String s = new String(ch, start, length).trim();
//		System.out.println(s);
		sb.append(s.trim());
	}

	@Override
	public void endDocument() throws SAXException {
		System.out.println("ferdig med parsing");
	}

	@Override
	public void endElement(String uri, String localName, String qName) throws SAXException {
		qNames.pop();
		if(qName.equals("xml")) {
			
		} else if(qName.equals("frame")) {

		} else if(qName.equals("seacage")) {

		} else if(qName.equals("sensor")) {
//			if(frame.isOk()) {
//				System.out.println("Added a frame " + frame.getId());
//				System.out.println(frame);
//				fItem = new TreeItem (tree, 0);
//				fItem.setText(frame.getId() + ": " + frame.getLocation());
//			}
//			if(seaCage.isOk()) {
//				System.out.println("Added a seacage " + seaCage.getId());
//				System.out.println(seaCage);
//				scItem = new TreeItem (fItem, 0);
//				scItem.setText(seaCage.getId() + ": " + seaCage.getDescription());
//			}
//			if(sensor.isOk()) {
//				System.out.println("Added a sensor " + sensor.getId());
//				System.out.println(sensor);
//				sItem = new TreeItem (scItem, 0);
//				sItem.setText(sensor.getId() + ": " + sensor.getTypeAsText());
//			}
		} else if(qName.equals("sensorvalue")) {
			
		} else if(qNames.peek().equals("frame")) {
			if(qName.equals("id")) {
				frame.setId(Integer.parseInt(sb.toString()));
			} else if(qName.equals("location")) {
				frame.setLocation(sb.toString());
			} else if(qName.equals("description")) {
				frame.setDescription(sb.toString());
			} else if(qName.equals("mobile")) {
				frame.setMobile(sb.toString());
			} else if(qName.equals("email")) {
				frame.setEmail(sb.toString());
				fItem = new TreeItem (tree, 0);
				fItem.setData(frame);
				fItem.setText(frame.getId() + ": " + frame.getLocation());
				fItem.setImage(new Image(display,"frame.png"));
			
			}
		} else if(qNames.peek().equals("seacage")) {
			if(qName.equals("id")) {
				currentSeaCage.setId(Integer.parseInt(sb.toString()));
			} else if(qName.equals("latitude")) {
				currentSeaCage.setLatitude(sb.toString());
			} else if(qName.equals("longitude")) {
				currentSeaCage.setLongitude(sb.toString());
			} else if(qName.equals("description")) {
				currentSeaCage.setDescription(sb.toString());
			} else if(qName.equals("imei")) {
				currentSeaCage.setImei(sb.toString());
			} else if(qName.equals("frameid")) {
				currentSeaCage.setFrameId(Integer.parseInt(sb.toString()));

				scItem = new TreeItem (fItem, 0);
				scItem.setData(currentSeaCage);
				scItem.setText(currentSeaCage.getId() + ": " + currentSeaCage.getDescription());
				fItem.setExpanded(true);
				//add icons
				scItem.setImage(new Image(display,"seacage.png"));

				if(first) {
					tree.setSelection(new TreeItem[]{tree.getTopItem().getItem(0)});
					first = false;
					
				}
				
			}
		} /*else if(qNames.peek().equals("sensor")) {
			if(qName.equals("id")) {
				currentSensor.setId(Integer.parseInt(sb.toString()));
			} else if(qName.equals("type")) {
				currentSensor.setTypeName(sb.toString());
			} else if(qName.equals("sensortypeid")) {
				currentSensor.setType(Integer.parseInt(sb.toString()));
			} else if(qName.equals("maxrange")) {
				currentSensor.setMaxRange(Integer.parseInt(sb.toString()));
			} else if(qName.equals("minrange")) {
				currentSensor.setMinRange(Integer.parseInt(sb.toString()));
			} else if(qName.equals("maxvalue")) {
				currentSensor.setMaxValue(Integer.parseInt(sb.toString()));
			} else if(qName.equals("minvalue")) {
				currentSensor.setMinValue(Integer.parseInt(sb.toString()));
			} else if(qName.equals("sacageid")) {
				currentSensor.setSeaCageID(Integer.parseInt(sb.toString()));
//			} else if(qName.equals("wstationid")) {
//				currentSensor.setWeatherID(Integer.parseInt(sb.toString()));
				sItem = new TreeItem (scItem, 0);
				sItem.setData(currentSensor);
				sItem.setText(currentSensor.getId() + ": " + currentSensor.getTypeName());
			
			}
		} else if(qNames.peek().equals("sensor")) {
			if(qName.equals("value")) {
				currentSensorValue.setValue(Integer.parseInt(sb.toString()));
			} else if(qName.equals("received")) {
				currentSensorValue.setReceived(new Timestamp(Long.parseLong(sb.toString())));
				sItem.setText(sItem.getText() + ": " + currentSensorValue.getValue());
			} 
		}*/
	}
}
