package com.telenor.apms.fifamos.client.j2se.gui;


import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.telenor.apms.fifamos.client.j2se.objects.Frame;

public class FrameDialog extends Dialog {
	private Shell shell;
	private Frame newFrame;
	private Text location;
	private Text description;
	private Text mobile;
	private Text email;
	
	public FrameDialog(Shell parent, int style) {
		super(parent, style);
		shell = new Shell(parent);
		shell.setImage(new Image(parent.getDisplay(), "fish_small.png"));
		shell.setLayout(new GridLayout(2, true));
		shell.setSize(600,600);
		
		Label locationLabel = new Label(shell, 0);
		locationLabel.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		locationLabel.setText("Skriv inn lokasjon: ");
		
		location = new Text(shell, SWT.BORDER);
		location.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		
		Label descriptionLabel = new Label(shell, 0);
		descriptionLabel.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		descriptionLabel.setText("Skriv inn beskrivelse: ");
		
		description = new Text(shell, SWT.BORDER);
		description.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		
		Label mobileLabel = new Label(shell, 0);
		mobileLabel.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		mobileLabel.setText("Skriv inn mobilnummer til operatr: ");
		
		mobile = new Text(shell, SWT.BORDER);
		mobile.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		
		Label emailLabel = new Label(shell, 0);
		emailLabel.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		emailLabel.setText("Skriv e-mail til operatr: ");
		
		email = new Text(shell, SWT.BORDER);
		email.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		
		//
		Button okButton = new Button(shell, SWT.PUSH);
		okButton.setText("OK");
		okButton.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, false, 1, 1));
		okButton.setImage(new Image(parent.getDisplay(), "button_ok.png"));
		okButton.setToolTipText("OK");
		okButton.addSelectionListener(new SelectionListener() {
			
		
			public void widgetDefaultSelected(SelectionEvent e) {
			}
		
			public void widgetSelected(SelectionEvent e) {
				if(mobile.getText().length()>0&&email.getText().length()>0)
				newFrame = new Frame(location.getText(), description.getText(), mobile.getText(), email.getText());		
				shell.dispose();
			}
		});
		
		Button cancelButton = new Button(shell, SWT.PUSH);
		cancelButton.setText("Avbryt");
		cancelButton.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, false, 1, 1));
		cancelButton.setImage(new Image(parent.getDisplay(), "button_cancel.png"));
		cancelButton.setToolTipText("Avbryt");
		cancelButton.addSelectionListener(new SelectionListener() {
		
			public void widgetDefaultSelected(SelectionEvent e) {
			}
		
			public void widgetSelected(SelectionEvent e) {
				shell.dispose();
			}
		});
		
		shell.pack();
	}
	public Frame newFrame() {
		shell.open();
		shell.setActive();
		shell.setText("Ny frame");
	
        while (!shell.isDisposed())
            if (!shell.getDisplay().readAndDispatch()) shell.getDisplay().sleep();
			return newFrame; //return new frame when finished
	}
	public Frame updateFrame(Frame frame) {
		shell.open();
		shell.setActive();
		shell.setText("Oppdater frame");
		
		location.setText(String.valueOf(frame.getLocation()));
		description.setText(String.valueOf(frame.getDescription()));
		mobile.setText(String.valueOf(frame.getMobile()));
		email.setText(String.valueOf(frame.getEmail()));
	
        while (!shell.isDisposed())
            if (!shell.getDisplay().readAndDispatch()) shell.getDisplay().sleep();
        if(newFrame!=null)	
        	newFrame.setId(frame.getId());
			return newFrame; //return new frame when finished
	}	
}
