package com.telenor.apms.fifamos.client.j2se.gui;


import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

import org.eclipse.swt.SWT;
import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.browser.ProgressEvent;
import org.eclipse.swt.browser.ProgressListener;
import org.eclipse.swt.browser.StatusTextEvent;
import org.eclipse.swt.browser.StatusTextListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import com.telenor.apms.fifamos.client.j2se.utils.GpsUtil;


public class MapDialog extends Dialog {
	Shell shell;
	Label map;
	Display display;
	
	public MapDialog(Shell parent, int style) {
		super(parent, style);
		shell = new Shell(parent, SWT.DIALOG_TRIM | style);
		shell.setText("Kart som viser lokasjon til sea cage");
		shell.setImage(new Image(shell.getDisplay(), "fish_small.png"));
		shell.setLayout(new FillLayout());
		display = shell.getDisplay();
		map = new Label(shell, SWT.SHADOW_ETCHED_OUT);

	}
	
	public void showMap(final String latitude, final String longitude, int zoom) {
		
		final Shell bShell = new Shell(this.getParent());
		final Browser browser = new Browser(bShell, SWT.NONE);
		
		browser.addStatusTextListener(new StatusTextListener() {
			public void changed(StatusTextEvent event) {
				browser.setData("event", event.text);
			}
		});
		
		browser.addProgressListener(new ProgressListener() {
			public void changed(ProgressEvent event) {}
			public void completed(ProgressEvent event) {
				try {
//					delete all cookies
					boolean result = browser.execute(
							"var date = new Date().getTime()-1000000;" +
							"document.cookie = 'mapArray=null;expires=date';" +
							"document.cookie = 'zoom=null;expires=date';" +
							"document.cookie = 'JSEnabled=null;expires=date';" +
							"document.cookie = 'dcisid=null;expires=date';" +
							"document.cookie = 'userpoidata=null;expires=date';" +
							"document.cookie = 'search=null;expires=date';" +
							"document.cookie = 's_sq=null;expires=date';" +
							"document.cookie = 's_cc=null;expires=date';" +
							"document.cookie = 'noRefreshMessageUrl=null;expires=date';" +
							"document.cookie = 'mqs_s=null;expires=date';" +
							"document.cookie = 'mqs_p=null;expires=date';" +
							"document.cookie = 'did=null;expires=date';" +
							"document.cookie = 'locationhistory=null;expires=date';"
					
					);
					if(!result)
						System.out.println("Error!");
					
					result = 
						browser.execute(
							"window.status=document.getElementById('map1').href;"); 
					if (!result) {
						/* Script may fail or may not be supported on certain platforms. */
						System.out.println("Script was not executed.");
						return;
					}
					String map_url = (String)browser.getData("event");
					System.out.println("Map URL - " + map_url);
					Image img = new Image(display, new URL(map_url).openStream());

					map.setText("Kart over " + latitude + "/" + longitude);
					map.setImage(img);
				
					shell.pack();
					shell.open();
					browser.dispose();
					bShell.dispose();
				} catch (MalformedURLException e) {
					e.printStackTrace();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		});
		
		String url = GpsUtil.getMapUrlByLatLongAsString(latitude, longitude, zoom);
		System.out.println("Web URL - " + url);
		
		browser.setUrl(url);
		while (!shell.isDisposed ()) {
			if (!display.readAndDispatch ()) display.sleep ();
		}
		shell.dispose ();
	}
}
