package com.telenor.apms.fifamos.client.j2se.gui;


import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.telenor.apms.fifamos.client.j2se.objects.SeaCage;

public class SeaCageDialog extends Dialog {
	private Shell shell;
	private SeaCage newSeaCage;
	private Text imeiText;
	private Text descriptionText;
	private Text refreshText;
	
	public SeaCageDialog(Shell parent, int style) {
		super(parent, style);
		shell = new Shell(parent);
		shell.setImage(new Image(parent.getDisplay(), "fish_small.png"));
		shell.setLayout(new GridLayout(2, true));
		shell.setSize(600,600);
		
		// imei
		Label imeiLabel = new Label(shell, 0);
		imeiLabel.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		imeiLabel.setText("IMEI-nummer: ");
		
		imeiText = new Text(shell, SWT.BORDER);
		imeiText.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		
		// description
		Label descriptionLabel = new Label(shell, 0);
		descriptionLabel.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		descriptionLabel.setText("Beskrivelse: ");
		
		descriptionText = new Text(shell, SWT.BORDER);
		descriptionText.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		
		// Refresh interval
		Label refreshLabel = new Label(shell, 0);
		refreshLabel.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		refreshLabel.setText("Oppdateringsinterval: ");
		
		refreshText = new Text(shell, SWT.BORDER);
		refreshText.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		
		//Buttons
		Button okButton = new Button(shell, SWT.PUSH);
		okButton.setText("OK");
		okButton.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, false, 1, 1));
		okButton.setImage(new Image(parent.getDisplay(), "button_ok.png"));
		okButton.setToolTipText("OK");
		okButton.addSelectionListener(new SelectionListener() {
		
			public void widgetDefaultSelected(SelectionEvent e) {
			}
		
			public void widgetSelected(SelectionEvent e) {
				if(imeiText.getText().length()>0&&descriptionText.getText().length()>0)
				newSeaCage = new SeaCage(imeiText.getText(), descriptionText.getText(), Integer.parseInt(refreshText.getText()), -1);		
				shell.dispose();
			}
		});
		
		Button cancelButton = new Button(shell, SWT.PUSH);
		cancelButton.setText("Avbryt");
		cancelButton.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, false, 1, 1));
		cancelButton.setImage(new Image(parent.getDisplay(), "button_cancel.png"));
		cancelButton.setToolTipText("Avbryt");
		cancelButton.addSelectionListener(new SelectionListener() {
		
			public void widgetDefaultSelected(SelectionEvent e) {
			}
		
			public void widgetSelected(SelectionEvent e) {
				shell.dispose();
			}
		});
		
		shell.pack();
	}
	public SeaCage newSeaCage() {
		shell.open();
		shell.setActive();
		shell.setText("Ny seaCage");
	
        while (!shell.isDisposed())
            if (!shell.getDisplay().readAndDispatch()) shell.getDisplay().sleep();
			return newSeaCage; //return new seaCage when finished
	}
	public SeaCage updateSeaCage(SeaCage seaCage) {
		shell.open();
		shell.setActive();
		shell.setText("Oppdater seaCage");
		
		imeiText.setText(String.valueOf(seaCage.getImei()));
		descriptionText.setText(String.valueOf(seaCage.getDescription()));
		refreshText.setText(String.valueOf(seaCage.getRefresh()));
		
        while (!shell.isDisposed())
            if (!shell.getDisplay().readAndDispatch()) shell.getDisplay().sleep();
        	if(newSeaCage!=null)
        	newSeaCage.setId(seaCage.getId());
			return newSeaCage; //return new seaCage when finished
	}	
}
