package com.telenor.apms.fifamos.client.j2se.gui;

import java.util.Iterator;
import java.util.Vector;


import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.telenor.apms.fifamos.client.j2se.objects.Sensor;
import com.telenor.apms.fifamos.client.j2se.objects.SensorType;
import com.telenor.apms.fifamos.client.j2se.objects.SensorValue;
import com.telenor.apms.fifamos.client.j2se.utils.RPCHandler;
import com.telenor.apms.fifamos.client.j2se.utils.StringVector;

public class SensorDialog extends Dialog {
	private Shell shell;
	private Sensor newSensor;
	private String type;
	private Text maxValueText;
	private Text minValueText;
	private Combo combo;
	Vector<SensorType> sensorTypes;
	
	public SensorDialog(Shell parent, int style) {
		super(parent, style);
		shell = new Shell(parent);
		shell.setImage(new Image(parent.getDisplay(), "fish_small.png"));
		shell.setLayout(new GridLayout(2, true));
		shell.setSize(600,600);
		
		Label sensortypeLabel = new Label(shell, 0);
		sensortypeLabel.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		sensortypeLabel.setText("Velg sensortype: ");
		
		RPCHandler rpc = new RPCHandler();
		sensorTypes = new Vector<SensorType>();
		try {
			String res = rpc.getSensorTypes();
			StringVector sv = new StringVector(res, ';');
			
			for(int i = 0;i<sv.size();i++) {
				SensorType sensorType = new SensorType(sv.stringElementAt(i));
				sensorTypes.add(sensorType);
			}
		}
		catch(Exception e) {
			
		}
		combo = new Combo (shell, SWT.READ_ONLY);
		combo.setSize (200, 200);
		combo.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		combo.addListener (SWT.Selection, new Listener () {
			public void handleEvent (Event e) {
				type = String.valueOf(combo.getSelectionIndex());
				
			}
		});
		
		for (int i = 0; i < sensorTypes.size(); i++) {
			System.out.println(sensorTypes.get(i));
			combo.add(sensorTypes.get(i).getType());
			combo.setData(""+i, sensorTypes.get(i));
		}
		
				
		// alarm bounds
		Label maxValueLabel = new Label(shell, 0);
		maxValueLabel.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		maxValueLabel.setText("Skriv vre alarmgrense: ");
		
		maxValueText = new Text(shell, SWT.BORDER);
		maxValueText.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		
		Label minValueLabel = new Label(shell, 0);
		minValueLabel.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		minValueLabel.setText("Skriv inn nedre alarmgrense: ");
		
		minValueText = new Text(shell, SWT.BORDER);
		minValueText.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		
		//
		Button okButton = new Button(shell, SWT.PUSH);
		okButton.setText("OK");
		okButton.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, false, 1, 1));
		okButton.setImage(new Image(parent.getDisplay(), "button_ok.png"));
		okButton.setToolTipText("OK");
		okButton.addSelectionListener(new SelectionListener() {
		
			public void widgetDefaultSelected(SelectionEvent e) {
			}
		
			public void widgetSelected(SelectionEvent e) {
				
				String maxRange = String.valueOf(sensorTypes.get(combo.getSelectionIndex()).getMaxRange());
				String minRange = String.valueOf(sensorTypes.get(combo.getSelectionIndex()).getMinRange());
				
				if(maxValueText.getText().length()>0&&minValueText.getText().length()>0) {
					int index = combo.getSelectionIndex();
					System.out.println("index: " + index);
					SensorType st = (SensorType)combo.getData(""+index);
					int sensorTypeId = st.getId();
					System.out.println("SensorTypeId = " + sensorTypeId);
					
					newSensor = new Sensor("-1", 
							String.valueOf(sensorTypeId), 
							maxRange, minRange, 
							maxValueText.getText(), 
							minValueText.getText(), 
							"-1");		
					newSensor.setTypeName(combo.getText());
					System.out.println("TYPE: " + type + " -> " + newSensor.getTypeName());
				}
				
				
				shell.dispose();
			}
		});
		
		Button cancelButton = new Button(shell, SWT.PUSH);
		cancelButton.setText("Avbryt");
		cancelButton.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, false, 1, 1));
		cancelButton.setImage(new Image(parent.getDisplay(), "button_cancel.png"));
		cancelButton.setToolTipText("Avbryt");
		cancelButton.addSelectionListener(new SelectionListener() {
		
			public void widgetDefaultSelected(SelectionEvent e) {
			}
		
			public void widgetSelected(SelectionEvent e) {
				shell.dispose();
			}
		});
		
		shell.pack();
	}
	public Sensor newSensor() {
		shell.open();
		shell.setActive();
		shell.setText("Ny sensor");
	
        while (!shell.isDisposed())
            if (!shell.getDisplay().readAndDispatch()) shell.getDisplay().sleep();
			return newSensor; //return new sensor when finished
	}
	public Sensor updateSensor(Sensor sensor) {
		shell.open();
		shell.setActive();
		shell.setText("Oppdater sensor");
		System.out.println("Sensor type: "+sensor.getType());
		int index = 0;
		for (Iterator sentyp = sensorTypes.iterator(); sentyp.hasNext();) {
			SensorType element = (SensorType) sentyp.next();
			if(element.getId() == sensor.getType())
				combo.select(index);
			index++;
		}
		
		
		maxValueText.setText(String.valueOf(sensor.getMaxValue()));
		minValueText.setText(String.valueOf(sensor.getMinValue()));
	
        while (!shell.isDisposed())
            if (!shell.getDisplay().readAndDispatch()) shell.getDisplay().sleep();
        	if(newSensor!=null)
        		newSensor.setId(sensor.getId());
			return newSensor; //return new sensor when finished
	}	
}
