package com.telenor.apms.fifamos.client.j2se.gui;

import java.io.IOException;
import java.util.Properties;
import java.util.Vector;

import org.apache.xmlrpc.XmlRpcException;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;

import com.telenor.apms.fifamos.client.j2se.objects.Frame;
import com.telenor.apms.fifamos.client.j2se.objects.SeaCage;
import com.telenor.apms.fifamos.client.j2se.objects.Sensor;
import com.telenor.apms.fifamos.client.j2se.utils.Constants;
import com.telenor.apms.fifamos.client.j2se.utils.RPCHandler;
import com.telenor.apms.fifamos.client.j2se.utils.SettingsIO;

public class Settings extends Dialog{
	
	private Text oppdateringsText;
	private Text serverText;
	private Shell shell;
	Properties properties = new Properties();
	SettingsIO sio = new SettingsIO();
	RPCHandler rpc = new RPCHandler();
	private Table frameTable;
	private Table seaCageTable;
	private Table sensorTable;
	private String frameID;
	private String seaCageID = null;
	private Button splashButton;
	
	public Settings(Shell parent, int style) {
		super(parent, style);
        shell = new Shell(parent, SWT.DIALOG_TRIM | style);
		shell.setImage(new Image(parent.getDisplay(), "fish_small.png"));
		shell.setLayout(new GridLayout(4, false));
		shell.setText("Innstillinger");
		shell.setSize(500,650);

		//		read settings from properties-file. 
		sio.readSettings();
		
		//Label image and text and text input
		Label serverImage = new Label (shell, SWT.NONE);
		serverImage.setImage(new Image(parent.getDisplay(), "network.png"));
		
		Label serverLabel = new Label (shell, SWT.NONE);
		serverLabel.setText("Server-adresse: ");
		
		serverText = new Text(shell, SWT.BORDER);
		serverText.setText(Constants.SERVER_URL);
		serverText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 2, 1));
		
//		Label image and text and text input
		Label oppdateringsImage = new Label (shell, SWT.NONE);
		oppdateringsImage.setImage(new Image(parent.getDisplay(), "clock.png"));
	
		Label oppdateringsLabel = new Label(shell, 0);
		oppdateringsLabel.setText("Oppdateringsfrekvens (s): ");
		
		oppdateringsText = new Text(shell, SWT.BORDER); 
		oppdateringsText.setText(String.valueOf(Constants.REFRESH_INTERVAL/1000));
		oppdateringsText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 2, 1));
		
//		Label image and text and text input
		Label splashImage = new Label (shell, SWT.NONE);
		splashImage.setImage(new Image(parent.getDisplay(), "splash.png"));
		
		Label splashLabel = new Label (shell, SWT.NONE);
		splashLabel.setText("Vis splash-screen: ");
		
		splashButton = new Button(shell, SWT.CHECK);
		splashButton.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, true, 2, 1));
		splashButton.setSelection(Constants.displaySplash);
		
//		Listener for buttons		
		SelectionAdapter listener = new SelectionAdapter() {

			public void widgetSelected(SelectionEvent e) {
				if(((Button)e.widget).getText().equals("Lagre")) {
					setSettings();
					sio.saveSettings();
					closeSettings();
				}
				else if(((Button)e.widget).getText().equals("Avbryt")) {
					closeSettings();
				}
				else if(((Button)e.widget).getText().equals("Legg til fish frame")) {
					newFrameDialog();
					fillFrameTable();
					frameTable.select(0);
				}
				else if(((Button)e.widget).getText().equals("Fjern fish frame")&&frameID!=null) {
					TableItem item = frameTable.getSelection()[0];
					try {
						rpc.removeFrame(String.valueOf(((Frame)item.getData()).getId()));
						fillFrameTable();
						seaCageTable.removeAll();
						sensorTable.removeAll();
					} catch (Exception e1) {
						e1.printStackTrace();
					}
				}
				else if (((Button)e.widget).getText().equals("Oppdater fish frame")&&frameID!=null) {
					TableItem item = frameTable.getSelection()[0];
					Frame frame = (Frame)item.getData();
					System.out.println("Oppdaterer frame: "+frame);
					updateFrameDialog(frame);
					fillFrameTable();
					fillSeaCageTable(frameID);
				}
				else if(((Button)e.widget).getText().equals("Legg til sea cage")) {
					try {
						TableItem item = frameTable.getSelection()[0];
						frameID = (String.valueOf(((Frame)item.getData()).getId()));
					}
					catch (Exception ex) {
						InputBox ib1 = new InputBox(shell, SWT.ICON_QUESTION);
						ib1.setText("Ny sea cage");
						ib1.setMessage("Skriv inn ID til frame");
						frameID = ib1.open();
					}
					newSeaCageDialog();
					fillSeaCageTable(frameID);
				}
				else if(((Button)e.widget).getText().equals("Fjern sea cage")&&seaCageID!=null) {
					TableItem item = seaCageTable.getSelection()[0];
					try {
						rpc.removeSeaCage(String.valueOf(((SeaCage)item.getData()).getId()));
						fillSeaCageTable(frameID);
						sensorTable.removeAll();
					} catch (Exception e1) {
						e1.printStackTrace();
					}
				}
				
				else if (((Button)e.widget).getText().equals("Oppdater sea cage")&&seaCageID!=null) {
					try {
						TableItem item = seaCageTable.getSelection()[0];
						SeaCage seaCage = (SeaCage) item.getData();
						System.out.println("Oppdaterer seacage: " + seaCage);
						updateSeaCageDialog(seaCage);
						fillSeaCageTable(frameID);
						fillSensorTable(seaCageID);
					} catch (Exception e1) {
					}
				}
				
				else if(((Button)e.widget).getText().equals("Legg til sensor")) {
					try {
						TableItem item = seaCageTable.getSelection()[0];
						seaCageID = (String.valueOf(((SeaCage)item.getData()).getId()));
					}
					catch (Exception ex) {
						InputBox ib1 = new InputBox(shell, SWT.ICON_QUESTION);
						ib1.setText("Ny sensor");
						ib1.setMessage("Skriv inn ID til sea cage");
						seaCageID = ib1.open();
					}
					newSensorDialog();
					fillSensorTable(seaCageID);
				}
				else if(((Button)e.widget).getText().equals("Fjern sensor")) {
					try {
						System.out.println("yeah");
						TableItem item = sensorTable.getSelection()[0];
						rpc.removeSensor(String.valueOf(((Sensor)item.getData()).getId()));
						fillSensorTable(seaCageID);
					} catch (Exception e1) {
						e1.printStackTrace();
					}
				}
				else if (((Button)e.widget).getText().equals("Oppdater sensor")) {
					try {
					TableItem item = sensorTable.getSelection()[0];
					Sensor sensor = (Sensor)item.getData();
					System.out.println("Oppdaterer sensor: "+sensor);
					updateSensorDialog(sensor);
					}
					catch(Exception exc) {
					}
					fillSensorTable(seaCageID);
				}
				else if(((Button)e.widget).getText().equals("Tm")) {
					try {
						rpc.cleanDB();
						fillFrameTable();
						seaCageTable.removeAll();
						sensorTable.removeAll();
					} catch (Exception e1) {
						e1.printStackTrace();
					}
				}
				else if(((Button)e.widget).getText().equals("Fyll")) {
					try {
						InputBox ib1 = new InputBox(shell, SWT.ICON_QUESTION);
						ib1.setText("Klargjr database");
						ib1.setMessage("Skriv inn hvor mange frames det er i fish farmen");
						String numberOfFrames = ib1.open();
						
						InputBox ib2 = new InputBox(shell, SWT.ICON_QUESTION);
						ib2.setText("Klargjr database");
						ib2.setMessage("Skriv inn hvor mange sea cages det er i fish farmen");
						String numberOfSeaCages = ib2.open();
						
						rpc.fillDB(Integer.parseInt(numberOfFrames),Integer.parseInt(numberOfSeaCages));
						fillFrameTable();
						seaCageTable.removeAll();
						sensorTable.removeAll();
					} catch (Exception e1) {
						e1.printStackTrace();
					}
				}
			}
		};
		
		//tableListener
		Listener tableListener = new Listener () {
			public void handleEvent (Event event) {

				if (event.item.getData() instanceof Frame) {
					Frame frame = (Frame) event.item.getData();
					frameID = String.valueOf(frame.getId());
					fillSeaCageTable(frameID);
					seaCageTable.select(0);
					sensorTable.removeAll();
				}
				
				else if (event.item.getData() instanceof SeaCage) {
					SeaCage seaCage = (SeaCage) event.item.getData();
					seaCageID = String.valueOf(seaCage.getId());
					fillSensorTable(seaCageID);
					sensorTable.select(0);
				}
			}
		};
		
		//Frame table
		Label frameLabel = new Label(shell, 0);
		frameLabel.setText("Liste over fish frames");
		frameLabel.setLayoutData(new GridData(SWT.LEFT, SWT.TOP, false, false, 4, 1));
		frameTable = new Table (shell, SWT.BORDER | SWT.V_SCROLL | SWT.H_SCROLL);
		frameTable.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 3, 3));
		frameTable.addListener(SWT.Selection, tableListener);
		frameTable.setToolTipText("Id, Description, Location");
		fillFrameTable();
		
		//frameButtons
		Button addFrameButton = new Button(shell, SWT.PUSH);
		addFrameButton.setText("Legg til fish frame");
		addFrameButton.setLayoutData(new GridData(SWT.CENTER, SWT.TOP, false, false, 1, 1));
		addFrameButton.addSelectionListener(listener);
		addFrameButton.setImage(new Image(parent.getDisplay(), "db_add.png"));
		addFrameButton.setToolTipText("Legg til fish frame");

		Button updateFrameButton = new Button(shell, SWT.PUSH);
		updateFrameButton.setText("Oppdater fish frame");
		updateFrameButton.setLayoutData(new GridData(SWT.CENTER, SWT.TOP, false, false, 1, 1));
		updateFrameButton.addSelectionListener(listener);
		updateFrameButton.setImage(new Image(parent.getDisplay(), "db_update.png"));
		updateFrameButton.setToolTipText("Oppdater fish frame");
		
		Button removeFrameButton = new Button(shell, SWT.PUSH);
		removeFrameButton.setText("Fjern fish frame");
		removeFrameButton.setLayoutData(new GridData(SWT.CENTER, SWT.TOP, false, false, 1, 1));
		removeFrameButton.addSelectionListener(listener);
		removeFrameButton.setImage(new Image(parent.getDisplay(), "db_remove.png"));
		removeFrameButton.setToolTipText("Fjern fish frame");
		
		//SeaCageTable
		Label seaCageLabel = new Label(shell, 0);
		seaCageLabel.setText("Liste over sea cages");
		seaCageLabel.setLayoutData(new GridData(SWT.LEFT, SWT.TOP, false, false, 4, 1));
		seaCageTable = new Table (shell, SWT.BORDER | SWT.V_SCROLL | SWT.H_SCROLL);
		seaCageTable.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 3, 3));
		seaCageTable.addListener(SWT.Selection, tableListener);
		seaCageTable.setToolTipText("ID, description, location");
		
//		seaCageButtons
		Button addSeaCageButton = new Button(shell, SWT.PUSH);
		addSeaCageButton.setText("Legg til sea cage");
		addSeaCageButton.setLayoutData(new GridData(SWT.CENTER, SWT.TOP, false, false, 1, 1));
		addSeaCageButton.addSelectionListener(listener);
		addSeaCageButton.setImage(new Image(parent.getDisplay(), "db_add.png"));
		addSeaCageButton.setToolTipText("Legg til sea cage");

		Button updateSeaCageButton = new Button(shell, SWT.PUSH);
		updateSeaCageButton.setText("Oppdater sea cage");
		updateSeaCageButton.setLayoutData(new GridData(SWT.CENTER, SWT.TOP, false, false, 1, 1));
		updateSeaCageButton.addSelectionListener(listener);
		updateSeaCageButton.setImage(new Image(parent.getDisplay(), "db_update.png"));
		updateSeaCageButton.setToolTipText("Oppdater sea cage");
		
		Button removeSeaCageButton = new Button(shell, SWT.PUSH);
		removeSeaCageButton.setText("Fjern sea cage");
		removeSeaCageButton.setLayoutData(new GridData(SWT.CENTER, SWT.TOP, false, false, 1, 1));
		removeSeaCageButton.addSelectionListener(listener);
		removeSeaCageButton.setImage(new Image(parent.getDisplay(), "db_remove.png"));
		removeSeaCageButton.setToolTipText("Fjern sea cage");
				
		//SensorTable
		Label sensorLabel = new Label(shell, 0);
		sensorLabel.setText("Liste over sensorer");
		sensorLabel.setLayoutData(new GridData(SWT.LEFT, SWT.TOP, false, false, 4, 1));
		sensorTable = new Table (shell, SWT.BORDER | SWT.V_SCROLL | SWT.H_SCROLL);
		sensorTable.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 3, 3));
		sensorTable.addListener(SWT.Selection, tableListener);
		sensorTable.setToolTipText("ID, type");
		
		//sensorButtons
		Button 	addSensorButton = new Button(shell , SWT.PUSH);
		addSensorButton.setText("Legg til sensor");
		addSensorButton.setLayoutData(new GridData(SWT.CENTER, SWT.TOP, false, false, 1, 1));
		addSensorButton.addSelectionListener(listener);
		addSensorButton.setImage(new Image(parent.getDisplay(), "db_add.png"));
		addSensorButton.setToolTipText("Legg til sensor");
		
		Button updateSensorButton = new Button(shell, SWT.PUSH);
		updateSensorButton.setText("Oppdater sensor");
		updateSensorButton.setLayoutData(new GridData(SWT.CENTER, SWT.TOP, false, false, 1, 1));
		updateSensorButton.addSelectionListener(listener);
		updateSensorButton.setImage(new Image(parent.getDisplay(), "db_update.png"));
		updateSensorButton.setToolTipText("Oppdater sensor");
		
		Button 	removeSensorButton = new Button(shell, SWT.PUSH);
		removeSensorButton.setText("Fjern sensor");
		removeSensorButton.setLayoutData(new GridData(SWT.CENTER, SWT.TOP, false, false, 1, 1));
		removeSensorButton.addSelectionListener(listener);
		removeSensorButton.setImage(new Image(parent.getDisplay(), "db_remove.png"));
		removeSensorButton.setToolTipText("Fjern sensor");
		
//		Label emptyspace = new Label(shell, SWT.NONE);
//		emptyspace.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 2, 1));
		
		//OK and cancel buttons + buttons for deleting and filling the database
		Composite buttonComposite = new Composite(shell, SWT.NONE);
		buttonComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 4, 1));
		buttonComposite.setLayout(new GridLayout(3, false));

		Button fillButton = new Button(buttonComposite, SWT.PUSH);
		fillButton.setText("Fyll");
		fillButton.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		fillButton.addSelectionListener(listener);
		fillButton.setImage(new Image(parent.getDisplay(), "trashcan_empty.png"));
		fillButton.setToolTipText("Klargjr databasen. Alle data vil bli slettet! (demoforml)");
		
//		Button emptyButton = new Button(buttonComposite, SWT.PUSH);
//		emptyButton.setText("Tm");
//		emptyButton.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
//		emptyButton.addSelectionListener(listener);
//		emptyButton.setImage(new Image(parent.getDisplay(), "trashcan_empty.png"));
//		emptyButton.setToolTipText("Tm databasen. Alle data vil bli slettet!");
//				
		Button lagreButton = new Button(buttonComposite, SWT.PUSH);
		lagreButton.setText("Lagre");
		lagreButton.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		lagreButton.addSelectionListener(listener);
		lagreButton.setImage(new Image(parent.getDisplay(), "button_ok.png"));
		lagreButton.setToolTipText("OK");
		
		Button avbrytButton = new Button(buttonComposite, SWT.PUSH);
		avbrytButton.setText("Avbryt");
		avbrytButton.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		avbrytButton.addSelectionListener(listener);
		avbrytButton.setImage(new Image(parent.getDisplay(), "button_cancel.png"));
		avbrytButton.setToolTipText("Avbryt");

	}
	public boolean openSettings() {
		System.err.println("1_____________________");
		shell.pack();
		shell.open();
//		serverText.setSize(200,20);
//		oppdateringsText.setSize(200,20);
		shell.setActive();
		
		  
        while (!shell.isDisposed())
            if (!shell.getDisplay().readAndDispatch()) shell.getDisplay().sleep();
        return true; //return true when finished
	}
	
	private void closeSettings() {
		shell.dispose();
	}
	
	private void setSettings() {
		Constants.SERVER_URL = serverText.getText();
		Constants.REFRESH_INTERVAL = 1000*Integer.parseInt(oppdateringsText.getText());
		Constants.displaySplash = splashButton.getSelection();
	}
	private void fillFrameTable() {
		Vector<Frame> frames;
		frameTable.removeAll();
		try {
			frames = rpc.getAllFrames();
			for (int i=0; i<frames.size(); i++) {
				TableItem item = new TableItem (frameTable, 0);
				item.setData(frames.elementAt(i));
				item.setText (frames.elementAt(i).toString());
			}
		} catch (Exception e1) {
			e1.printStackTrace();
		}
	}
	
	private void fillSeaCageTable(String frameID) {
		Vector<SeaCage> seaCages;
		seaCageTable.removeAll();
		try {
			seaCages = rpc.getAllSeaCages(frameID);
			for (int i=0; i<seaCages.size(); i++) {
				TableItem item = new TableItem (seaCageTable, 0);
				item.setData(seaCages.elementAt(i));
				item.setText (seaCages.elementAt(i).toString());
			}
		} catch (Exception e1) {
			e1.printStackTrace();
		}
	}
	
	private void fillSensorTable(String seaCageID) {
		Vector<Sensor> sensors;
		sensorTable.removeAll();
		try {
			sensors = rpc.getAllSensors(seaCageID);
			for (int i=0; i<sensors.size(); i++) {
				TableItem item = new TableItem (sensorTable, 0);
				item.setData(sensors.elementAt(i));
				item.setText (sensors.elementAt(i).toString());
			}
		} catch (Exception e1) {
			e1.printStackTrace();
		}
	}
	
	//sensor dialogs:
	private void newSensorDialog() {
		try {
			if(seaCageID!=null) {
				SensorDialog sd = new SensorDialog(shell, SWT.BORDER);//TODO seacageid
				Sensor sensor = sd.newSensor();
			
				if(sensor!=null) {
					sensor.setSeaCageID(Integer.parseInt(seaCageID));
					System.out.println(sensor+"scid: "+seaCageID);
					rpc.addSensor(sensor);
					System.out.println("Sensor lagt til!");
				}
			}
		} catch (XmlRpcException e) {
			System.out.println("Sensor ikke lagt til "+ e.getMessage());
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private void updateSensorDialog(Sensor sensor) {
		try {
			if(seaCageID!=null) {
				SensorDialog sd = new SensorDialog(shell, SWT.BORDER);//TODO seacageid
				sensor = sd.updateSensor(sensor);
			
				if(sensor!=null /* && sensor.isOk() */) {
					sensor.setSeaCageID(Integer.parseInt(seaCageID));
					rpc.updateSensor(sensor);
					System.out.println("Sensor oppdatert!");
				}
			}
		} catch (XmlRpcException e) {
			System.out.println("Sensor ikke oppdatert "+ e.getMessage());
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	
	//sea cage dialogs:
	private void newSeaCageDialog() {
		try {
			if(frameID!=null) {
				SeaCageDialog scd = new SeaCageDialog(shell, SWT.BORDER);//TODO seacageid
				SeaCage seaCage = scd.newSeaCage();
			
				if(seaCage!=null) {
					seaCage.setFrameId(Integer.parseInt(frameID));
					rpc.addSeaCage(seaCage);
					System.out.println("Sea cage lagt til!");
				}
			}
		} catch (XmlRpcException e) {
			System.out.println("sea cage ikke lagt til "+ e.getMessage());
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private void updateSeaCageDialog(SeaCage seaCage) {
		try {
			if(seaCageID!=null) {
				SeaCageDialog sd = new SeaCageDialog(shell, SWT.BORDER);//TODO seacageid
				System.out.println("IMEI fr:   "+seaCage.getImei());
				seaCage = sd.updateSeaCage(seaCage);
			
				if(seaCage!=null /* && seaCage.isOk() */) {
					seaCage.setFrameId(Integer.parseInt(frameID));
					rpc.updateSeaCage(seaCage);
					System.out.println("SeaCage oppdatert!");
				}
			}
		} catch (XmlRpcException e) {
			System.out.println("SeaCage ikke oppdatert "+ e.getMessage());
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	//Frame dialogs
	private void newFrameDialog() {
		try {
			FrameDialog scd = new FrameDialog(shell, SWT.BORDER);//TODO seacageid
			Frame frame = scd.newFrame();
			
			if(frame!=null) {
				rpc.addFrame(frame);
				System.out.println("Sea cage lagt til!");
			}
		} catch (XmlRpcException e) {
			System.out.println("sea cage ikke lagt til "+ e.getMessage());
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private void updateFrameDialog(Frame frame) {
		try {
			FrameDialog sd = new FrameDialog(shell, SWT.BORDER);
			System.out.println("fr pning");
			frame = sd.updateFrame(frame);
			
			if(frame!=null /* && frame.isOk() */) {
				frame.setId(Integer.parseInt(frameID));
				rpc.updateFrame(frame);
				System.out.println("Frame oppdatert!");
			}
		} catch (XmlRpcException e) {
			System.out.println("Frame ikke oppdatert "+ e.getMessage());
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}