package com.telenor.apms.fifamos.client.j2se.gui;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.widgets.Shell;

public class Splash {

	private Display display;
	private Shell splash;
	private ProgressBar bar;
	private int[] count;
	private Image image;
	private int steps;

	public Splash(final Shell parent, int style) {
		
		display = parent.getDisplay();
		splash = new Shell(SWT.ON_TOP);

	}
	
	public void setSteps(int steps) {
		this.steps = steps;
	}
	
	public void setImage(Image image) {
		this.image = image;
	}
	
	public boolean open() {

//		number of steps
		count = new int [] {steps};
		
		bar = new ProgressBar(splash, SWT.NONE);
		bar.setMaximum(count[0]);
		
		Label label = new Label(splash, SWT.NONE);
		label.setImage(image);
		
		FormLayout layout = new FormLayout();
		splash.setLayout(layout);
		
		FormData labelData = new FormData ();
		labelData.right = new FormAttachment (100, 0);
		labelData.bottom = new FormAttachment (100, 0);
		label.setLayoutData(labelData);
		
		FormData progressData = new FormData ();
		progressData.left = new FormAttachment (0, 5);
		progressData.right = new FormAttachment (100, -5);
		progressData.bottom = new FormAttachment (100, -5);
		bar.setLayoutData(progressData);
		
		splash.pack();

		Rectangle splashRect = splash.getBounds();
		Rectangle displayRect = display.getBounds();
		int x = (displayRect.width - splashRect.width) / 2;
		int y = (displayRect.height - splashRect.height) / 2;
		splash.setLocation(x, y);
		splash.open();
		
		/*************************************
		 * 
		 * This takes some time, and shows as
		 * a progress bar on the splash screen
		 * 
		 *************************************/
		
		display.asyncExec(new Runnable() {
			public void run() {
				
				for (int i=0; i<count[0]; i++) {
					bar.setSelection(i+1);
					try {Thread.sleep(100);} catch (Throwable e) {}
					
				}
				splash.close();
				image.dispose();
				splash.dispose();
				System.out.println("Splash is disposed here...");
				
			}
		});
		
//		while (count [0] != 0) {
//			if (!display.readAndDispatch ()) display.sleep ();
//		}
		
		/*************************************
		 * 
		 * Splash screen closed, main
		 * window opened. Should have done 
		 * all the work by now..
		 * 
		 *************************************/
		
		while (!splash.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		return true;
	}
}
