package com.telenor.apms.fifamos.client.j2se.objects;

import com.telenor.apms.fifamos.client.j2se.utils.StringVector;

public class Frame {
	private int id;
	private String location, description, mobile, email = "";

	public Frame(int id, String location, String description, String mobile, String email) {
		this.id = id;
		this.location = location;
		this.description = description;
		this.mobile = mobile;
		this.email = email;
	}

	public Frame(String location, String description, String mobile, String email) {
		this.location = location;
		this.description = description;
		this.mobile = mobile;
		this.email = email;
	}
	
	public Frame(String input) {
		StringVector sv = new StringVector(input, ':');
		id = Integer.parseInt(sv.stringElementAt(0));
		location = sv.stringElementAt(1);
		description = sv.stringElementAt(2);
		mobile = sv.stringElementAt(3);
		email = sv.stringElementAt(4);
	}

	public Frame() {
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getLocation() {
		return location;
	}

	public void setLocation(String location) {
		this.location = location;
	}

	public String getMobile() {
		return mobile;
	}

	public void setMobile(String mobile) {
		this.mobile = mobile;
	}
	
	public boolean isOk() {
		return (
				location.trim().length() > 0 &&
				description.trim().length() > 0 &&
				mobile.trim().length() > 0 &&
				email.trim().length() > 0
		);
			
	}
	
	public String getXml() {
		StringBuffer xml = new StringBuffer();
		
		xml.append("<frame>\n");
		xml.append("<id>" + id + "</id>\n");
		xml.append("<location >" + location + "</location >\n");
		xml.append("<description>" + description + "</description>\n");
		xml.append("<mobile>" + mobile + "</mobile>\n");
		xml.append("<email>" + email + "</email>\n");
		xml.append("</frame>\n");
		
		
		return xml.toString();
	}
	
	public String toString() {
		return ("ID: "+id+": "+description+", located at "+location);
	}
	
}
