package com.telenor.apms.fifamos.client.j2se.objects;

import com.telenor.apms.fifamos.client.j2se.utils.StringVector;

public class SeaCage {
	private String latitude = "", longitude = "", description, imei = "";
	private int id, frameid, refresh;
	
	public SeaCage() {
	}

	public SeaCage(String imei, String description, int refresh, int frameid) {
		this.imei = imei;
		this.refresh = refresh;
		this.description = description;
		this.frameid = frameid;
	}
	
	public SeaCage(int id, String latitude, String longitude, String description, String imei, int frameid) {
		this.id = id;
		this.latitude = latitude;
		this.longitude = longitude;
		this.description = description;
		this.imei = imei;
		this.frameid = frameid;
	}
	
	public SeaCage(String latitude, String longitude, String description, String imei, int frameid) {
		this.latitude = latitude;
		this.longitude = longitude;
		this.description = description;
		this.imei = imei;
		this.frameid = frameid;
	}
	
	public SeaCage(String input) {
		System.out.println(input);
		StringVector sv = new StringVector(input, ':');
		id = Integer.parseInt(sv.stringElementAt(0));
		latitude = sv.stringElementAt(1);
		longitude = sv.stringElementAt(2);
		description = sv.stringElementAt(3);
		imei = sv.stringElementAt(4);
		refresh = Integer.parseInt(sv.stringElementAt(5));
		frameid = Integer.parseInt(sv.stringElementAt(6));
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public int getFrameId() {
		return frameid;
	}
	public void setFrameId(int frameid) {
		this.frameid = frameid;
	}
	public String getImei() {
		return imei;
	}
	public int getRefresh() {
		return refresh;
	}
	public void setImei(String imei) {
		this.imei = imei;
	}
	public String getLatitude() {
		return latitude;
	}
	public void setLatitude(String latitude) {
		this.latitude = latitude;
	}
	public String getLongitude() {
		return longitude;
	}
	public void setLongitude(String longitude) {
		this.longitude = longitude;
	}
	
	public String getXml() {
		StringBuffer xml = new StringBuffer();
		
		xml.append("<seacage>\n");
		xml.append("<id>" + id + "</id>\n");
		xml.append("<latitude>" + latitude + "</latitude>\n");
		xml.append("<longitude>" + longitude+ "</longitude>\n");
		xml.append("<description>" + description + "</description>\n");
		xml.append("<imei>" + imei+ "</imei>\n");
		xml.append("<interval>" + refresh+ "</interval>\n");
		xml.append("<frameid>" + frameid+ "</frameid>\n");
		xml.append("</seacage>\n");
		
		return xml.toString();
	}

	public String toString() {
		return ("ID: "+id+": "+description);
	}

	public boolean isOk() {
		return (imei.trim().length()>0 && 
				description.trim().length()>0 && 
				frameid != 0);
	}
}
