package com.telenor.apms.fifamos.client.j2se.objects;

import java.util.HashMap;

import com.telenor.apms.fifamos.client.j2se.utils.StringVector;

/**
 * @author Frank
 * 
 */
public class Sensor {

	public final static int SENSOR_TEMP = 0;
	public final static int SENSOR_WIND = 1;
	public final static int SENSOR_PH = 2;
	public final static int SENSOR_O2 = 3;
	public final static int SENSOR_LUX = 4;
	
	int id, typeId, seaCageId;
	double currentValue, maxRange, minRange, maxValue, minValue;
	private String typeName, unit;

	/**
	 * @param id
	 * @param typeId
	 * @param maxRange
	 * @param minRange
	 * @param maxValue
	 * @param minValue
	 * @param seaCageID
	 */
	public Sensor(int id, int typeId, String typeName,  int maxRange, int minRange, int maxValue, int minValue, int seaCageID) {
		this.id = id;
		this.typeId = typeId;
		this.typeName = typeName;
		this.maxRange = maxRange;
		this.minRange = minRange;
		this.maxValue = maxValue;
		this.minValue = minValue;
		this.seaCageId = seaCageID;
	}

	public Sensor(String input) {
		StringVector sv = new StringVector(input,':');
		id = Integer.parseInt(sv.stringElementAt(0));
		typeId = Integer.parseInt(sv.stringElementAt(1));
		typeName = sv.stringElementAt(2);
		unit = sv.stringElementAt(3);
		maxRange = Double.parseDouble(sv.stringElementAt(4));
		minRange = Double.parseDouble(sv.stringElementAt(5));
		maxValue = Double.parseDouble(sv.stringElementAt(6));
		minValue = Double.parseDouble(sv.stringElementAt(7));
		currentValue = Double.parseDouble(sv.stringElementAt(8));
		seaCageId = Integer.parseInt(sv.stringElementAt(9));
	}
	
	public Sensor(String id, String type, String maxRange, String minRange, String maxValue, String minValue, String seaCageID) {
		this.id = Integer.parseInt(id);
		this.typeId = Integer.parseInt(type);
		this.maxRange = Double.parseDouble(maxRange);
		this.minRange = Double.parseDouble(minRange);
		this.maxValue = Double.parseDouble(maxValue);
		this.minValue = Double.parseDouble(minValue);
		this.seaCageId = Integer.parseInt(seaCageID);
	}
	
	/**
	 * @param sensor
	 */
	public Sensor(HashMap sensor) {
		id = (Integer) sensor.get("id");
		typeId = (Integer) sensor.get("typeid");
		typeName = (String) sensor.get("typename");
		maxRange = (Integer) sensor.get("maxrange");
		minRange = (Integer) sensor.get("minrange");
		maxValue = (Integer) sensor.get("maxvalue");
		minValue = (Integer) sensor.get("minvalue");
		seaCageId = (Integer) sensor.get("seacageid");
	}

	public Sensor() {
	}

	/**
	 * @return Returns the id.
	 */
	public int getId() {
		return id;
	}

	/**
	 * @param id The id to set.
	 */
	public void setId(int id) {
		this.id = id;
	}

	/**
	 * @return Returns the maxRange.
	 */
	public double getMaxRange() {
		return maxRange;
	}

	/**
	 * @param maxRange The maxRange to set.
	 */
	public void setMaxRange(double maxRange) {
		this.maxRange = maxRange;
	}

	/**
	 * @return Returns the maxValue.
	 */
	public double getMaxValue() {
		return maxValue;
	}

	/**
	 * @param maxValue The maxValue to set.
	 */
	public void setMaxValue(double maxValue) {
		this.maxValue = maxValue;
	}

	/**
	 * @return Returns the minRange.
	 */
	public double getMinRange() {
		return minRange;
	}

	/**
	 * @param minRange The minRange to set.
	 */
	public void setMinRange(double minRange) {
		this.minRange = minRange;
	}

	/**
	 * @return Returns the minValue.
	 */
	public double getMinValue() {
		return minValue;
	}

	/**
	 * @param minValue The minValue to set.
	 */
	public void setMinValue(int minValue) {
		this.minValue = minValue;
	}

	/**
	 * @return Returns the seaCageID.
	 */
	public int getSeaCageID() {
		return seaCageId;
	}

	/**
	 * @param seaCageID The seaCageID to set.
	 */
	public void setSeaCageID(int seaCageID) {
		this.seaCageId = seaCageID;
	}

	/**
	 * @return Returns the type.
	 */
	public int getType() {
		return typeId;
	}

	/**
	 * @param type The type to set.
	 */
	public void setType(int type) {
		this.typeId = type;
	}

	/**
	 * @return
	 */
	public String getTypeName() {
		return typeName;
	}

	public void setTypeName(String typeName) {
		this.typeName = typeName;
	}

	public String getXml() {
		StringBuffer xml = new StringBuffer();
		
		xml.append("<sensor>\n");
		xml.append("<id>" + id + "</id>\n");
		xml.append("<sensortypeid>" + typeId + "</sensortypeid>\n");
		xml.append("<maxrange>" + maxRange + "</maxrange>\n");
		xml.append("<minrange>" + minRange+ "</minrange>\n");
		xml.append("<maxvalue>" + maxValue+ "</maxvalue>\n");
		xml.append("<minvalue>" + minValue+ "</minvalue>\n");
		xml.append("<seacageid>" + seaCageId+ "</seacageid>\n");
		xml.append("</sensor>\n");
		
		return xml.toString();
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "Id: " + id + " - " + typeName + " (" + maxValue + "/" + minValue + ") verdi: "+currentValue+" "+unit;
	}

	public boolean isOk() {
		return id != 0;
	}
}
