package com.telenor.apms.fifamos.client.j2se.utils;

import java.util.StringTokenizer;
import java.util.Vector;


import org.apache.xmlrpc.XmlRpcClient;

import com.telenor.apms.fifamos.client.j2se.objects.Alarm;
import com.telenor.apms.fifamos.client.j2se.objects.Sensor;

/**
 * SensorInfo.java
 * 
 * Class that gets the current sensor data from the context manager and returns it as a Vector
 * 
 * @author JAG
 * @copyright JAG  2006
 * @version 1.0
 */

public class SensorInfo implements Runnable {
	
	private String seaCage;
	private Vector<Sensor> sensorInfo;
	private Vector<Alarm> alarmInfo;
	private RpcHandlerResult listener;
	
	public SensorInfo(String seaCage, RpcHandlerResult listener) {
		this.seaCage = seaCage;
		this.listener = listener;
	}
	
	public void getSensorData() {
		Vector<String> params = new Vector<String>();
		params.addElement(seaCage);
		String response;
		sensorInfo = new Vector<Sensor>();
		try {
			debug("Contacting web service..");
			XmlRpcClient client = new XmlRpcClient (Constants.SERVER_URL);
			
			//hent sensorInfo
			response = (String)client.execute ("Output.getSensorsForSeaCage", params);
			
			StringTokenizer st = new StringTokenizer(response, ";");
			while(st.hasMoreTokens()) {
				Sensor sensor = new Sensor(st.nextToken());
				sensorInfo.addElement(sensor);
//				System.out.println("sensorverdi: "+sensor);
			}

			//hent gps-data
			String gpsData = "GPS data currently not avaliable..";
			gpsData = (String)client.execute ("Output.getGpsData", params);
			System.out.println("GPSinfo: "+gpsData);

			//hent alarmer
			params = new Vector<String>();
			alarmInfo = new Vector<Alarm>();
			response = (String)client.execute ("Output.getAlarms", params);
			System.out.println("alarm response: "+response);
//			response = "1:1:1:1:1:1:1";
			st = new StringTokenizer(response, ";");
			while(st.hasMoreTokens()) {
				Alarm al = new Alarm(st.nextToken());
				alarmInfo.addElement(al);
				System.out.println("alarm: "+al);
			}
			listener.passResult(sensorInfo, alarmInfo, gpsData);
			
		} catch (Exception e) {
			debug(e.toString());
			listener.updateStatus("Feil i timerlkke: "+e.getMessage(), 2);
			e.printStackTrace();
		}
	}
	
	private void debug(String message) {
		if(Constants.DEBUG) {
			System.out.println("SensorInfo debug*** "+message) ;	
		}
	}
	
	public void run() {
		getSensorData();
	}
}


