package com.telenor.apms.fifamos.client.j2se.utils;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

public class SettingsIO {
	
	private Properties properties = new Properties();
	
	public void readSettings() {
//		 Read properties file.
	    try {
	        properties.load(new FileInputStream("settings.properties"));
	        Constants.SERVER_URL = properties.getProperty("SERVER_URL");
	        Constants.REFRESH_INTERVAL = Integer.parseInt(properties.getProperty("REFRESH_INTERVAL"));
	        Constants.displaySplash = Boolean.parseBoolean(properties.getProperty("DISPLAY_SPLASH"));
	    } catch (FileNotFoundException e) {
	    	saveSettings(); 
	    } catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public void saveSettings() {
		properties.setProperty("SERVER_URL", Constants.SERVER_URL);
	    properties.setProperty("REFRESH_INTERVAL", String.valueOf(Constants.REFRESH_INTERVAL));
	    properties.setProperty("DISPLAY_SPLASH", String.valueOf(Constants.displaySplash));
	    try {
			properties.store(new FileOutputStream("settings.properties"), null);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
