<html>
<head>
<link rel="StyleSheet" href="/services/Fifamos/fifamos.css" type="text/css" />
<title>FiFaMoS :: Fish Farm Monitoring System</title>

<script type="text/javascript">
var prevAction = "frame";
var prevId = "-1";
var curSeaCage = "-1";
var curSensor = "-1";

var secs
var timerID = null
var timerRunning = false
var delay = 1000

function startAll() {
	startClock();
	initTimer();
}

function startClock() {
	var today=new Date()
	var h=today.getHours()
	var m=today.getMinutes()
	var s=today.getSeconds()
	// add a zero in front of numbers<10
	m=checkTime(m)
	s=checkTime(s)
	h=checkTime(h)
	document.getElementById('time').innerHTML=h+":"+m+":"+s
	t=setTimeout('startClock()',500)
}

function checkTime(i) {
	if (i<10) 
		{i="0" + i}
	return i
}

function initTimer() {
    // Set the length of the timer, in seconds
    secs = 10
    perform(prevAction, prevId);
    stopTheTimer()
    startTheTimer()
}


function stopTheTimer() {
    if(timerRunning)
        clearTimeout(timerID)
    timerRunning = false
}

function startTheTimer() {
    if (secs==0) {
		initTimer();
    } else {
//        self.status = secs
//		document.getElementById("status").innerHTML = "Time to next update: " + secs;
        secs = secs - 1
        timerRunning = true
        timerID = self.setTimeout("startTheTimer()", delay)
    }
}


function perform(action, id) {
	if(action != "alarm") {
		prevAction = action;
		prevId = id;    
	}
    var url = '/services/Fifamos/fifamos.jsp?action=' + action + '&id=' + id;
    if (window.XMLHttpRequest) {
        req = new XMLHttpRequest();
    } else if (window.ActiveXObject) {
        req = new ActiveXObject("Microsoft.XMLHTTP");
    } else {
		document.getElementById("status").innerHTML = "AJAX not supported";
	}
    req.onreadystatechange = processRequest;
    req.open("GET", url, true);
    req.send(null);
}


function processRequest() {
    if (req.readyState == 4) {
        if (req.status == 200) {
   			parseMessages();
			document.getElementById("status").innerHTML = "OK";
        } else {
        	stopTheTimer();
			document.getElementById("status").innerHTML = "Error getting context" + req.status;
		}
    } else {
	    document.getElementById("status").innerHTML = "Current state: " + req.readyState;
    }
}

function parseMessages() {
	response = req.responseXML.documentElement;
		
	var i;
			
	for(i=0;i<response.getElementsByTagName("frame").length;i++) {

		var frameTable = document.getElementById("frame");	
		if(i==0) {
			for(var j=frameTable.childNodes.length-1; j>0; j--){
				frameTable.removeChild(frameTable.childNodes[j]);
			}
		}
				
		var seaCageTable = document.getElementById("seacage");	
		if(i==0) {
			for(var j=seaCageTable.childNodes.length-1; j>=0; j--){
				seaCageTable.removeChild(seaCageTable.childNodes[j]);
			}
		}

		var sensorTable = document.getElementById("sensor");	
		if(i==0) {
			for(var j=sensorTable.childNodes.length-1; j>=0; j--){
				sensorTable.removeChild(sensorTable.childNodes[j]);
			}
		}

		var id = response.getElementsByTagName("frame")[i].getElementsByTagName("id")[0].firstChild.nodeValue;
		var desc = response.getElementsByTagName("frame")[i].getElementsByTagName("location")[0].firstChild.nodeValue;
		var text = id + ": " + desc;
			
		var tr = document.createElement("TR");
		var td = document.createElement("TD");
		var a = document.createElement("A");
		
		frameTable.appendChild(tr);

		tr.style.backgroundColor = i%2?'#8888FF':'#3535FF';
		tr.appendChild(td);

		td.appendChild(a);
		td.width = "300px";
		
		a.href = "javascript:perform('seacage','"+id+"')";

		a.appendChild(document.createTextNode(text.toString()));

	}

	for(i=0;i<response.getElementsByTagName("seacage").length;i++) {
		
		var seaCageTable = document.getElementById("seacage");	
		if(i==0) {
			for(var j=seaCageTable.childNodes.length-1; j>=0; j--){
				seaCageTable.removeChild(seaCageTable.childNodes[j]);
			}
		}
				
		var sensorTable = document.getElementById("sensor");	
		if(i==0) {
			for(var j=sensorTable.childNodes.length-1; j>=0; j--){
				sensorTable.removeChild(sensorTable.childNodes[j]);
			}
		}
		
		var id = response.getElementsByTagName("seacage")[i].getElementsByTagName("id")[0].firstChild.nodeValue;
		var desc = response.getElementsByTagName("seacage")[i].getElementsByTagName("description")[0].firstChild.nodeValue;
		var lat =  response.getElementsByTagName("seacage")[i].getElementsByTagName("latitude")[0].firstChild.nodeValue;
		var lng =  response.getElementsByTagName("seacage")[i].getElementsByTagName("longitude")[0].firstChild.nodeValue;
		var text = id + ": " + desc + " - (lat/lng) " + lat.substr(0,6) + "/" + lng.substr(0,6);
			
		var tr = document.createElement("TR");
		var td = document.createElement("TD");
		var a = document.createElement("A");
		
		td.width = "300px";
		
		seaCageTable.appendChild(tr);

        tr.style.backgroundColor = i%2?'#8888FF':'#3535FF';
			        
		tr.appendChild(td);

		td.appendChild(a);
		
		a.href = "javascript:perform('sensor','"+id+"')";
		
		a.appendChild(document.createTextNode(text.toString()));
		
	}
	
	for(i=0;i<response.getElementsByTagName("sensor").length;i++) {
	
		var sensorTable = document.getElementById("sensor");	
		if(i==0) {
			for(var j=sensorTable.childNodes.length-1; j>=0; j--){
				sensorTable.removeChild(sensorTable.childNodes[j]);
			}
		}
		
		var id = response.getElementsByTagName("sensor")[i].getElementsByTagName("id")[0].firstChild.nodeValue;
		var type = response.getElementsByTagName("sensor")[i].getElementsByTagName("type")[0].firstChild.nodeValue;
		var value = response.getElementsByTagName("sensor")[i].getElementsByTagName("sensorvalue")[0].firstChild.nodeValue;
		var unit = response.getElementsByTagName("sensor")[i].getElementsByTagName("unit")[0].firstChild.nodeValue;
		var max = response.getElementsByTagName("sensor")[i].getElementsByTagName("maxvalue")[0].firstChild.nodeValue;
		var min = response.getElementsByTagName("sensor")[i].getElementsByTagName("minvalue")[0].firstChild.nodeValue;						
		
		var sensorText = id + ": " + type + " - " + value + "" + unit + " (" + min + "/" + max + ")";
			
			
		var tr = document.createElement("TR");
		var td = document.createElement("TD");
		td.width = "300px";	
        tr.style.backgroundColor = i%2?'#8888FF':'#3535FF';
		
		sensorTable.appendChild(tr);

		tr.appendChild(td);

		td.appendChild(document.createTextNode(sensorText.toString()));
		
	} 
		
	/** ALARM **/
	for(i=0;i<response.getElementsByTagName("alarm").length;i++) {
	
		var alarmIdTable = document.getElementById("alarm");	
		if(i==0) {
			for(var j=alarmIdTable.childNodes.length-1; j>=0; j--){
				alarmIdTable.removeChild(alarmIdTable.childNodes[j]);
			}
		}
				
		
		if(response.getElementsByTagName("alarm")[i].getElementsByTagName('id').length > 0) {
			var id = response.getElementsByTagName("alarm")[i].getElementsByTagName("id")[0].firstChild.nodeValue;
			var msg = response.getElementsByTagName("alarm")[i].getElementsByTagName("msg")[0].firstChild.nodeValue;
				
			var tr = document.createElement("TR");
			var td1 = document.createElement("TD");
	
			td1.width = "900px";
			tr.style.backgroundColor = i%2?'#8888FF':'#3535FF';
			
			alarmIdTable.appendChild(tr);
	
			tr.appendChild(td1);
	
			td1.appendChild(document.createTextNode(id + ": " + msg));

		}
	}
}


</script>
</head>

<body onload="startAll()">
<center>
<a href="index.jsp"><img src="babelfish.png" border="0"></a>
<h5>Fish Farm Monitoring System</h5>
</center>
<table align=center width=900px class="tblBrdr">
	<tbody id="mytable">
		<tr>
			<th colspan="3">Alarms</th>
		</tr>
		<tr>
			<td valign="top" colspan="3" id="alarm">
			</td>
		</tr>

		<tr>
			<td valign="top" align="right" colspan="3">
			<a href="javascript:perform('alarm', '-1')">Confirm all alarms</a>
			</td>
		</tr>
		
		<tr>
			<th width="300px">Frames</th>
			<th width="300px">Sea Cages</th>
			<th width="300px">Sensors</th>
		</tr>
		<tr>
			<td valign="top" width="300px" id="frame">
			</td>
			<td valign="top" width="300px" id="seacage">
			</td>
			<td valign="top" width="300px" id="sensor">
			</td>
		</tr>
		<tr>
			<td></td>
			<th>Time</th>
			<th>Status</th>
		</tr>
		<tr>
			<td></td>
			<td align="center" valign="top" id=time>
			</td>
			<td align="center" valign="top">
				<div style="font-size: small;" id="status"></div>
			</td>
		</tr>
	</tbody>
</table>



<br>
<br>
<center>
<p>	 Select a frame to see its sea cages, then select a sea cage to see its sensors
<p><div style="font-size: small;"><a href="/services/Fifamos/index_noajax.jsp">For a reduced non-AJAX-version; Click here</a></div>
</center>
</body>
</html>
