package com.telenor.apms.fifamos;

import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import coms.component.OutputComponent;
import coms.database.ConnectionException;
import coms.tools.relational.Select;

/**
 * @author JAG & FGP
 * @copyright JAG & FGP  2006
 * @version 1.0
 */
/**
 * @author Frank
 *
 */
public class Output extends OutputComponent implements OutputMBean {

	// private ByteArrayInputStream bais;
	// private XmlPullParser xpp;

	@Override
	public void unload() {
	}

	@Override
	public void init() {
	}

	@Override
	public void onEvent(String event) {
	}

	public String getFrames(String loc, String desc, String mobile, String email) {

		StringBuffer temp = new StringBuffer();

		try {
			Select sel = new Select("frame", getMetaData().getDbType());
			sel.and("location", Select.LIKE, loc.length() > 0 ? loc : "%");
			sel.and("description", Select.LIKE, desc.length() > 0 ? desc : "%");
			sel.and("mobile", Select.LIKE, mobile.length() > 0 ? mobile : "%");
			sel.and("email", Select.LIKE, email.length() > 0 ? email : "%");

			List list = sel.execute();

			dbg("List size: " + list.size());

			Iterator it = list.iterator();
			while (it.hasNext()) {
				HashMap frame = (HashMap) it.next();
				temp.append(String.valueOf((Integer) frame.get("id")) + ":");
				temp.append((String) frame.get("location") + ":");
				temp.append((String) frame.get("description") + ":");
				temp.append((String) frame.get("mobile") + ":");
				temp.append((String) frame.get("email"));

				temp.append(";");
			}
			if (temp.length() > 0)
				temp.deleteCharAt(temp.lastIndexOf(";"));
		} catch (SQLException e) {
			dbg(e.toString());
		} catch (ConnectionException e) {
			dbg(e.toString());
		}

		return temp.toString();
	}

	public String getSeaCagesForFrame(String frameid) {
		dbg("getSeaCagesForFrame: " + frameid);
		StringBuffer temp = new StringBuffer();

		try {
			Select sel = new Select("seacage", getMetaData().getDbType());
			sel.and("frameid", Select.EQUAL, Integer.parseInt(frameid));
			List<Map<String, Object>> list = sel.execute();

			dbg("List size: " + list.size());

			Iterator it = list.iterator();
			while (it.hasNext()) {
				HashMap seacage = (HashMap) it.next();
				temp.append((Integer) seacage.get("id") + ":");
				temp.append((String) seacage.get("latitude") + ":");
				temp.append((String) seacage.get("longitude") + ":");
				temp.append((String) seacage.get("description") + ":");
				temp.append((String) seacage.get("imei") + ":");
				temp.append((Integer) seacage.get("interval") + ":");
				temp.append((Integer) seacage.get("frameid"));
				temp.append(";");
			}
			if (temp.length() > 0)
				temp.deleteCharAt(temp.lastIndexOf(";"));
		} catch (SQLException e) {
			dbg(e.toString());
		} catch (ConnectionException e) {
			dbg(e.toString());
		}

//		dbg("Result: " + temp.toString());

		return temp.toString();
	}

	public String getGpsData(String seaCageId) {
		StringBuffer temp = new StringBuffer();

		try {
			Select sel = new Select("seacage", getMetaData().getDbType());
			sel.and("id", Select.EQUAL, seaCageId);
			sel.column("latitude");
			sel.column("longitude");
			List<Map<String, Object>> list = sel.execute();

			Iterator it = list.iterator();
			while (it.hasNext()) {
				HashMap gps = (HashMap) it.next();

				temp.append((String) gps.get("latitude") + ":");
				temp.append((String) gps.get("longitude"));
				temp.append(";");
			}
			if (temp.length() > 0)
				temp.deleteCharAt(temp.lastIndexOf(";"));
		} catch (SQLException e) {
			dbg(e.toString());
		} catch (ConnectionException e) {
			dbg(e.toString());
		}

//		dbg("Result: " + temp.toString());

		return temp.toString();
	}

	public String getSensorsForSeaCage(String seaCageId) {
		
		Date d1 = new Date();
		StringBuffer temp = new StringBuffer();

		try {
//			select the sensor
			Select selSensor = new Select("sensor", getMetaData().getDbType());
			selSensor.and("seacageid", Select.EQUAL, Integer.parseInt(seaCageId));
			List<Map<String, Object>> list = selSensor.execute();

			dbg("getSensorsForSeaCage() " + seaCageId + " List size: " + list.size());

			Iterator it = list.iterator();
			while (it.hasNext()) {
				HashMap sensor = (HashMap) it.next();
				int sensorId = (int) (Integer) sensor.get("id");

				//				prepare for string -->
//				sensor id
				temp.append(sensorId + ":");

//				sensor type id
				int sensortypeid = (Integer) sensor.get("sensortypeid");
				temp.append(sensortypeid + ":");

//				select type (in text), max- and min range for the sensor type
				Select selSensorType = new Select("sensortype", getMetaData().getDbType());
				selSensorType.and("id", Select.EQUAL, sensortypeid);

				HashMap sensortype = (HashMap) selSensorType.execute().iterator().next();
				temp.append((String) sensortype.get("type") + ":");
				temp.append((String) sensortype.get("unit") + ":");
				temp.append((Double) sensortype.get("maxrange") + ":");
				temp.append((Double) sensortype.get("minrange") + ":");

//				max allowed value
				temp.append((Double) sensor.get("maxvalue") + ":");
//				min allowed value
				temp.append((Double) sensor.get("minvalue") + ":");


//				 select the current value for the current sensor
				Select selSensorValue = new Select("sensorvalue", getMetaData().getDbType());
				selSensorValue.orderBy("received", Select.DESCENDING);
				selSensorValue.and("sensorid", Select.EQUAL, sensorId);

//				in case there are no sensor values
				double sensorvalue = 0;
				try {
					HashMap sensorValue = (HashMap) selSensorValue.execute().iterator().next();
					sensorvalue = (Double) sensorValue.get("value");
				} catch(Exception e) {
//					dbg("no values here...");
				}

				temp.append(sensorvalue + ":");

//				sea cage id (FK)
				temp.append((Integer) sensor.get("seacageid"));
				temp.append(";");
			}

			if (temp.length() > 0)
				temp.deleteCharAt(temp.lastIndexOf(";"));
		} catch (SQLException e) {
			dbg(e.toString());
		} catch (ConnectionException e) {
			dbg(e.toString());
		}

//		dbg("Result: " + temp.toString());

		Date d2 = new Date();
		dbg("Time used: " + (d2.getTime() - d1.getTime()) + "ms");
		
		return temp.toString();
	}


	/* (non-Javadoc)
	 * @see com.telenor.apms.fifamos.OutputMBean#getHistoryForSensor(java.lang.String, java.lang.String)
	 */
	public String getHistoryForSensor(String sensorid, String period) {
		/*
		 *  FIXME: Due to some J2ME-problems involving large numbers, the period
		 *  passed to this method must be in SECONDS, _NOT_ milliseconds..
		 *
		 */

		Date d1 = new Date();
		
		dbg("getHistoryForSensor: " + sensorid);
		StringBuffer temp = new StringBuffer();

		try {
			long now = new Date().getTime();
			Timestamp t = new Timestamp(now - (Long.parseLong(period) * 1000));

			Select sel = new Select("sensorvalue", getMetaData().getDbType());
			sel.and("sensorid", Select.EQUAL, Integer.parseInt(sensorid));
			sel.and("received", Select.GREATER, t);
			sel.orderBy("received", Select.ASCENDING);

			List<Map<String, Object>> list = sel.execute();

			dbg("List size: " + list.size());

//			to avoid time differences in the system, add context managers time here 
			temp.append(t.getTime() / 1000 + ":" + now / 1000 + ";");
//			temp.append(":;"); // use for no cm time..

			Iterator it = list.iterator();
			while (it.hasNext()) {
				HashMap sensorValue = (HashMap) it.next();
				temp.append( (Double) sensorValue.get("value") + ":");
				temp.append(((Timestamp) sensorValue.get("received")).getTime() / 1000);
				temp.append(";");
			}
			if (temp.length() > 0)
				temp.deleteCharAt(temp.lastIndexOf(";"));
		} catch (SQLException e) {
			dbg(e.toString());
		} catch (ConnectionException e) {
			dbg(e.toString());
		}

		
//		//XXX: for testing purposes only, remove if not testing!!!
//		Timestamp endtime = new Timestamp(new Date().getTime());
//		Timestamp starttime = new Timestamp(endtime.getTime() - (Long.parseLong(period)*1000));
//		temp.delete(0, temp.length());
//		temp.append(starttime.getTime() / 1000 + ":" + (endtime.getTime() / 1000) + ";");
//		for(int i=0; i<Integer.parseInt(period)/60;i++) {
//			temp.append("50:" + new Timestamp(new Date().getTime()).getTime()/1000 + ";");
//		}
//		
//		if (temp.length() > 0)
//			temp.deleteCharAt(temp.lastIndexOf(";"));
//		//XXX: remove till here

		
		Date d2 = new Date();
		dbg("Time used for " + period + ": " + (d2.getTime() - d1.getTime()) + "ms");
		
		// debug("Result: " + temp.toString());

		return temp.toString();
	}

	public String getSensorTypes() {

		StringBuffer sb = new StringBuffer();

		try {
			Select sel = new Select("sensortype", getMetaData().getDbType());
			List<Map<String, Object>> list = sel.execute();

			dbg("getSensorTypes() - List size: " + list.size());

			Iterator it = list.iterator();

			while (it.hasNext()) {
				HashMap map = (HashMap) it.next();
				sb.append(map.get("id") + ":");
				sb.append(map.get("maxrange") + ":");
				sb.append(map.get("minrange") + ":");
				sb.append(map.get("unit") + ":");
				sb.append(map.get("type") + ":");
				sb.append(map.get("description"));

				sb.append(";");
			}
			if (sb.toString().length() > 0)
				sb.deleteCharAt(sb.lastIndexOf(";"));

		} catch (SQLException e) {
			dbg(e.toString());
		} catch (ConnectionException e) {
			dbg(e.toString());
		}

		return sb.toString();
	}

	public String getAlarms() {
		StringBuffer sb = new StringBuffer();
		sb.append("");
		try {
			Select sel = new Select("alarm", getMetaData().getDbType());
			sel.and("confirmed", Select.EQUAL, new Timestamp(0));

			List<Map<String, Object>> list = sel.execute();

			dbg("getAlarms() list size: " + list.size());

			Iterator it = list.iterator();

			while (it.hasNext()) {
				HashMap alarm = (HashMap) it.next();

				sb.append(alarm.get("id") + ",");
				sb.append(alarm.get("seacageid") + ",");
				sb.append((alarm.get("sensorid").equals("-1") ? "" : alarm.get("sensorid")) + ",");
				sb.append(alarm.get("message"));
				sb.append(";");
				
//				Select sel2 = new Select("sensorvalue", getMetaData().getDbType());
//				sel2.and("id", Select.EQUAL, alarm.get("sensorvalueid"));
//				HashMap sensorvalue = (HashMap) sel2.execute().iterator().next();
//
//				Select sel3 = new Select("sensor", getMetaData().getDbType());
//				sel3.and("id", Select.EQUAL, alarm.get("sensorid"));
//				HashMap sensor = (HashMap) sel3.execute().iterator().next();
//
//				Select sel4 = new Select("sensortype", getMetaData().getDbType());
//				sel4.and("id", Select.EQUAL, sensor.get("sensortypeid"));
//				HashMap sensortype = (HashMap) sel4.execute().iterator().next();
//
//				sb.append(alarm.get("id") + ",");
//				sb.append(alarm.get("sensorid") + ",");
//				sb.append(alarm.get("maxvalue") + ",");
//				sb.append(alarm.get("minvalue") + ",");
//				sb.append(sensorvalue.get("value") + ",");
//				sb.append(sensorvalue.get("received") + ",");
//				sb.append(sensortype.get("type"));
//				sb.append(((Timestamp)alarm.get("confirmed")).getTime() + ",");
//				sb.append(";");

			}
			
			if (sb.toString().length() > 0)
				sb.deleteCharAt(sb.lastIndexOf(";"));

			dbg(sb.toString());
		} catch (SQLException e) {
			dbg(e.toString());
		} catch (ConnectionException e) {
			dbg(e.toString());
		}
//		dbg("getAlarms() result: " + sb.toString());
		return sb.toString();
	}


	public String getFishFarmAsXml() {
		StringBuffer xml = new StringBuffer();

		xml.append("<xml>");
		try {

			Select selFrame = new Select("frame", getMetaData().getDbType());
			List<Map<String, Object>> listFrame = selFrame.execute();

			Iterator itFrame = listFrame.iterator();

			while (itFrame.hasNext()) {
				HashMap frame = (HashMap) itFrame.next();
				xml.append("\n\t<frame>\n");
				xml.append("\t\t<id>"+(Integer) frame.get("id") + "</id>\n");
				xml.append("\t\t<location>" + (String) frame.get("location") + "</location>\n");
				xml.append("\t\t<description>" + (String) frame.get("description") + "</description>\n");
				xml.append("\t\t<mobile>" + (String) frame.get("mobile") + "</mobile>\n");
				xml.append("\t\t<email>" + (String) frame.get("email") + "</email>\n");


				Select selSeaCage = new Select("seacage", getMetaData().getDbType());
				selSeaCage.and("frameid", Select.EQUAL, (Integer) frame.get("id"));

				List<Map<String, Object>> listSeaCage = selSeaCage.execute();

				if(listSeaCage.size()<=0)
					xml.append("\t\t<seacage />\n");

				Iterator itSeaCage = listSeaCage.iterator();
				while (itSeaCage.hasNext()) {
					HashMap seacage = (HashMap) itSeaCage.next();
					xml.append("\t\t<seacage>\n");
					xml.append("\t\t\t<id>" + (Integer) seacage.get("id") + "</id>\n");
//					xml.append("\t\t\t<satellites>" + (Integer) seacage.get("satellites") + "</satellites>\n");
//					xml.append("\t\t\t<altitude>" + (Integer) seacage.get("altitude") + "</altitude>\n");
					xml.append("\t\t\t<latitude>" + (String) seacage.get("latitude") + "</latitude>\n");
					xml.append("\t\t\t<longitude>" + (String) seacage.get("longitude") + "</longitude>\n");
					xml.append("\t\t\t<description>" + (String) seacage.get("description") + "</description>\n");
					xml.append("\t\t\t<imei>" + (String) seacage.get("imei") + "</imei>\n");
					xml.append("\t\t\t<frameid>" + (Integer) seacage.get("frameid") + "</frameid>\n");

/******************** Don't want sensors or sensor values in the tree... ***************

					Select selSensor = new Select("sensor", getMetaData().getDbType());
					selSensor.and("seacageid", Select.EQUAL, (Integer)seacage.get("id"));

					List<Map<String, Object>> listSensor = selSensor.execute();

					if(listSensor.size()<=0)
						xml.append("\t\t\t<sensor />\n");

					Iterator itSensor = listSensor.iterator();
					while(itSensor.hasNext()) {
						HashMap sensor = (HashMap)itSensor.next();

						Select selSensorType = new Select("sensortype", getMetaData().getDbType());
						selSensorType.and("id", Select.EQUAL, (Integer) sensor.get("sensortypeid"));

						List<Map<String, Object>> listSensorTypes = selSensorType.execute();
						Iterator itSensorTypes = listSensorTypes.iterator();
						String sensorType = "";
						if(itSensorTypes.hasNext()) {
							HashMap map = (HashMap) itSensorTypes.next();
							sensorType = (String) map.get("type");

						}

						xml.append("\t\t\t<sensor>\n");
						xml.append("\t\t\t\t<id>" + (Integer) sensor.get("id") + "</id>\n");
						xml.append("\t\t\t\t<sensortypeid>" + (Integer) sensor.get("sensortypeid") + "</sensortypeid>\n");
						xml.append("\t\t\t\t<type>" + sensorType + "</type>\n");
//						xml.append("\t\t\t\t<maxrange>" + (Integer) sensor.get("maxrange") + "</maxrange>\n");
//						xml.append("\t\t\t\t<minrange>" + (Integer) sensor.get("minrange") + "</minrange>\n");
						xml.append("\t\t\t\t<maxvalue>" + (Double) sensor.get("maxvalue") + "</maxvalue>\n");
						xml.append("\t\t\t\t<minvalue>" + (Double) sensor.get("minvalue") + "</minvalue>\n");
						xml.append("\t\t\t\t<seacageid>" + (Integer) sensor.get("seacageid") + "</seacageid>\n");


						Select selSensorValue = new Select("sensorvalue", getMetaData().getDbType());
						selSensorValue.and("sensorid", Select.EQUAL, (Integer) sensor.get("id"));
						selSensorValue.column("value");
						selSensorValue.column("received");
						selSensorValue.orderBy("received", Select.ASCENDING);

						List<Map<String, Object>> listSensorValue = selSensorValue.execute();
						if(listSensorValue.size()<=0)
							xml.append("\t\t\t\t\t<sensorvalue />\n");

						Iterator itSensorValue = listSensorValue.iterator();
//						Needs only one sensor value...
						itSensorValue.hasNext()
						HashMap sensorvalue = (HashMap) itSensorValue.next();
						xml.append("\t\t\t\t\t<sensorvalue>\n");
						xml.append("\t\t\t\t\t\t<value>" + (Integer)sensorvalue.get("value") + "</value>\n");
						xml.append("\t\t\t\t\t\t<received>" + ((Timestamp)sensorvalue.get("received")).getTime() + "</received>\n");
						xml.append("\t\t\t\t\t</sensorvalue>\n");

						xml.append("\t\t\t</sensor>\n");
					}
******************************************************************************/
					xml.append("\t\t</seacage>\n");
				}
				xml.append("\t</frame>\n");
			}

		} catch (SQLException e) {
			e.printStackTrace();
			xml = new StringBuffer();
			xml.append("<xml><error type=\"SQLException\">" + e.getMessage() + "</error></xml>");
			return xml.toString();
		} catch (ConnectionException e) {
			e.printStackTrace();
			xml = new StringBuffer();
			xml.append("<xml><error type=\"ConnectionException\">" + e.getMessage() + "</error></xml>");
			return xml.toString();
		} catch (Exception e) {
			e.printStackTrace();
			xml.append("<xml><error type=\"Exception\">" + e.getMessage() + "</error></xml>");
			return xml.toString();
		}

		xml.append("</xml>");
//		dbg(xml.toString());

		return xml.toString();
	}

	public String getConfigAsXml(String imei) {
		String xml = "<xml>";

		try {
			int frameId = 0;
			String mobile = "";
			String email = "";
			int seaCageId = 0;
			int interval = 60;
			int sensorId = 0;

			Select sel = new Select("seacage", getMetaData().getDbType());
			sel.and("imei", Select.EQUAL, imei);
			sel.column("id");
			sel.column("interval");
			sel.column("frameid");
			List<Map<String, Object>> list = sel.execute();

			Iterator it = list.iterator();
			while (it.hasNext()) {
				HashMap seacage = (HashMap) it.next();
				seaCageId = (Integer) seacage.get("id");
				frameId = (Integer) seacage.get("frameid");
				interval = (Integer) seacage.get("interval");
			}

			sel = new Select("frame", getMetaData().getDbType());
			sel.and("id", Select.EQUAL, frameId);
			sel.column("mobile");
			sel.column("email");

			list = sel.execute();

			it = list.iterator();
			while (it.hasNext()) {
				HashMap seacage = (HashMap) it.next();
				mobile = (String) seacage.get("mobile");
				email = (String) seacage.get("email");

			}

			xml += "<frame value=\"" + frameId + "\"/>";
			xml += "<mobile value=\"" + mobile + "\"/>";
			xml += "<email value=\"" + email + "\"/>";
			xml += "<seacage value=\"" + seaCageId + "\"/>";
			xml += "<interval value=\"" + interval + "\"/>";

			sel = new Select("sensor", getMetaData().getDbType());
			sel.column("id");
			sel.and("seacageid", Select.EQUAL, seaCageId);

			list = sel.execute();

			it = list.iterator();

			while (it.hasNext()) {
				HashMap sensor = (HashMap) it.next();
				sensorId = (int) (Integer) sensor.get("id");

				xml += "<sensorid value=\"" + sensorId + "\"/>";

			}

			xml += "</xml>";
			return xml;

		} catch (SQLException e) {
			dbg(e.toString());
		} catch (ConnectionException e) {
			dbg(e.toString());
		}
		return "";
	}

	private void dbg(String msg) {
		System.out.println(msg);
	}
}

