package com.telenor.apms.fifamos.objects;

import java.util.HashMap;

/**
 * @author Frank
 *
 */
public class SensorType {

	private int id;
	double minRange, maxRange;
	private String unit, type, description = "";

	public SensorType() {
	}
	
	/**
	 * @param id
	 * @param maxRange
	 * @param minRange
	 * @param unit 
	 * @param type
	 * @param description
	 */
	public SensorType(int id, int maxRange, int minRange, String unit, String type, String description) {
		this.id = id;
		this.maxRange = maxRange;
		this.minRange = minRange;
		this.unit = unit;
		this.type = type;
		this.description = description;
	}

	/**
	 * @param sensortype
	 */
	public SensorType(HashMap sensortype) {
		this.id = (Integer) sensortype.get("id");
		this.maxRange = (Double) sensortype.get("maxrange");
		this.minRange = (Double) sensortype.get("minrange");
		this.unit = (String) sensortype.get("unit");
		this.type = (String) sensortype.get("type");
		this.description = (String) sensortype.get("description");
	}

	/**
	 * @return Returns the description.
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * @param description The description to set.
	 */
	public void setDescription(String description) {
		this.description = description;
	}

	/**
	 * @return Returns the id.
	 */
	public int getId() {
		return id;
	}

	/**
	 * @param id The id to set.
	 */
	public void setId(int id) {
		this.id = id;
	}

	/**
	 * @return Returns the maxRange.
	 */
	public double getMaxRange() {
		return maxRange;
	}

	/**
	 * @param maxRange The maxrange to set.
	 */
	public void setMaxRange(double maxRange) {
		this.maxRange = maxRange;
	}

	/**
	 * @return Returns the minrange.
	 */
	public double getMinRange() {
		return minRange;
	}

	/**
	 * @param minrange The minrange to set.
	 */
	public void setMinRange(double minRange) {
		this.minRange = minRange;
	}

	/**
	 * @return Returns the type.
	 */
	public String getType() {
		return type;
	}

	/**
	 * @param type The type to set.
	 */
	public void setType(String type) {
		this.type = type;
	}

	public String getUnit() {
		return unit;
	}

	public void setUnit(String unit) {
		this.unit = unit;
	}
}
