package com.telenor.apms.fifamos.objects;

import java.sql.Timestamp;
import java.util.HashMap;

/**
 * @author Frank
 * 
 */
public class SensorValue {
	int id, sensorid;

	double value;

	Timestamp received;

	/**
	 * @param id
	 * @param value
	 * @param outofbounds
	 * @param sensorid
	 * @param received
	 * @param confirmed
	 */
	public SensorValue(int id, double value, Timestamp received, String confirmed, int sensorID) {
		this.id = id;
		this.value = value;
		this.received = received;
		this.sensorid = sensorID;
	}

	public SensorValue(int value, int sensorID) {
		this.value = value;
		this.sensorid = sensorID;
	}
	
	public SensorValue(HashMap sensorvalue) {
		this.id = (Integer) sensorvalue.get("id");
		this.value = (double)(Double)sensorvalue.get("value");
		this.received = (Timestamp) sensorvalue.get("received");
		this.sensorid = (Integer) sensorvalue.get("sensorid");
	}

	public SensorValue() {
	}

	/**
	 * @return Returns the received.
	 */
	public Timestamp getReceived() {
		return received;
	}

	/**
	 * @param received The received to set.
	 */
	public void setReceived(Timestamp received) {
		this.received = received;
	}

	/**
	 * @return Returns the sensorID.
	 */
	public int getSensorID() {
		return sensorid;
	}

	/**
	 * @param sensorID The sensorID to set.
	 */
	public void setSensorID(int sensorID) {
		this.sensorid = sensorID;
	}

	/**
	 * @return Returns the id.
	 */
	public int getId() {
		return id;
	}

	/**
	 * @param id The id to set.
	 */
	public void setId(int id) {
		this.id = id;
	}

	/**
	 * @return Returns the value.
	 */
	public double getValue() {
		return value;
	}

	/**
	 * @param value The value to set.
	 */
	public void setValue(double value) {
		this.value = value;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "SensorValue: " + id + ", " + sensorid + ", " + value;
	}

	

}
