package com.telenor.apms.fifamos.utils;


import java.util.Iterator;
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;



/**
 * @author Frank
 *
 */
public class SensorSim implements Runnable {
	
	private static boolean running = false;
	private Label l1;
	private Text t1;
	private Label l2;
	private Text t2;

	private Vector<SensorSimClass> sims = new Vector<SensorSimClass>();
	
	/**
	 * 
	 */
	public SensorSim() {
		final Display display = new Display();
		Shell shell = new Shell(display);
		shell.setLayout(new GridLayout(2, true));
		
		l1 = new Label(shell, SWT.NONE);
		l1.setText("Sea cages: ");
		
		t1 = new Text(shell, SWT.SINGLE);
		t1.setText("24");
		
		l2 = new Label(shell, SWT.NONE);
		l2.setText("Sensors: ");
		
		t2 = new Text(shell, SWT.SINGLE);
		t2.setText("6");
		
		Listener listener = new Listener() {
		
			public void handleEvent(Event event) {
				if(((Button)event.widget).getText().trim().equalsIgnoreCase("start")) {
					display.asyncExec(getInstance());
				} else 
					stopSimulation();
			}
		}; 
		
		Button b1 = new Button(shell, SWT.PUSH);
		b1.setText("  Stop  ");
		b1.addListener(SWT.Selection, listener);
		
		Button b2 = new Button(shell, SWT.PUSH);
		b2.setText("  Start ");
		b2.addListener(SWT.Selection, listener);
		shell.setDefaultButton(b2);
		
		shell.pack();
		shell.open();
		
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
		running = false;
	}
	
	public SensorSim getInstance() {
		return this;
	}

	public void run() {
		running = true;
		int numOfSeaCages = Integer.parseInt(t1.getText());
		int numOfSensors = Integer.parseInt(t2.getText());
				
		for (int i = 0; i < numOfSeaCages; i++) {
//			new Thread(new SensorSimThread(i, numOfSensors)).start();
			sims.add(new SensorSimClass(i, numOfSensors));
		}
		
		while(running) {
			for (Iterator iter = sims.iterator(); iter.hasNext();) {
				SensorSimClass element = (SensorSimClass) iter.next();
				element.pulse();

				try { Thread.sleep(500);
				} catch (InterruptedException e) {}
			}
			try { Thread.sleep(1000);
			} catch (InterruptedException e) {}
		}
	}

	
	/**
	 * 
	 */
	public void stopSimulation() {
		running = false;
	}


	/**
	 * @return
	 */
	public static boolean isRunning() {
		return running ;
	}

	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new SensorSim();
	}
}
