package com.telenor.apms.fifamos.utils;

import java.io.ByteArrayInputStream;
import java.net.URL;
import java.util.Vector;

import org.apache.xmlrpc.XmlRpcClient;
import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;


public class SensorSimClass extends DefaultHandler {
//	private static final String _URL = "http://129.241.219.164:8081/RPC2";
	private static final String _URL = "http://localhost:8080/RPC2";
//	private static final String _URL = "http://81.191.34.98:80/RPC2";
	private String imei;
	private int frameid;
	private int seacageid;
	private int index;
	private int[] sensorid;
	private StringBuffer xml = new StringBuffer();
	private XmlRpcClient xmlrpc;
	private Vector<String> params;

	public SensorSimClass(int imei, int sensors) {
		try {
			this.imei = String.valueOf(imei);
			sensorid = new int[sensors];
			URL url = new URL(_URL);
			xmlrpc = new XmlRpcClient(url);
			params = new Vector<String>();
			
			params.addElement(this.imei);
			
			String xmlconfig = (String) xmlrpc.execute("Output.getConfigAsXml", params);
			
			XMLReader parser = XMLReaderFactory.createXMLReader();
			parser.setContentHandler(this);
			parser.parse(new InputSource(new ByteArrayInputStream(xmlconfig.getBytes())));
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void pulse() {
		try {

			params.removeAllElements();	
			
			xml.delete(0, xml.length());

			xml.append("<xml>");
			for(int i=0; i<sensorid.length;i++) {
				// creating xml elements
				if(sensorid[i]!=-1) {
					xml.append("<command type=\"add\">\n");
					xml.append("<sensorvalue>\n");
					xml.append("<sensorid>"+sensorid[i]+"</sensorid>\n");
//						xml.append("<value>"+(int)(Math.random()*2800)+"</value>\n");
					xml.append("<value>"+ ((Math.random()*1000) + 600) +"</value>\n");
					xml.append("</sensorvalue>\n");
					xml.append("</command>\n");
				}
			}
			xml.append("<command type=\"update\">\n");
			xml.append(
					"<gps>" +
					"<seacageid>" + seacageid + "</seacageid>" +
					"<latlng " +
						"lat=\""+ 63 + " " + 29 + " " + 47 + "\" " +
						"lng=\""+ 10 + " " + 23 + " " + 57 + "\" " +
					"/>" +
					"</gps>");
			xml.append("</command>\n");
			xml.append("</xml>");
			
			params.add(xml.toString());
			
			System.out.println((String)xmlrpc.execute("Input.postSourceXml", params));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@Override
	public void startDocument() throws SAXException {
	}
	
	@Override
	public void startElement(String uri, String localName, String qName, Attributes attributes) throws SAXException {
		if(qName.equals("frame"))
			frameid = Integer.parseInt(attributes.getValue("value"));
		else if(qName.equals("seacage"))
			seacageid =  Integer.parseInt(attributes.getValue("value"));
		else if(qName.equals("sensorid"))
			sensorid[index++] = Integer.parseInt(attributes.getValue("value"));
		
	}

	@Override
	public void characters(char[] chars, int start, int length) throws SAXException {
	}

	@Override
	public void endElement(String uri, String localName, String qName) throws SAXException {
		
	}

	@Override
	public void endDocument() throws SAXException {
	}
}