package com.telenor.apms.fifamos.n12;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Hashtable;
import java.util.Vector;

import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

import org.kxml.kdom.Element;
import org.kxml.parser.XmlParser;
import org.kxmlrpc.N12XmlRpcClient;

import com.nokia.m2m.imp.iocontrol.IOControl;
import com.nokia.m2m.imp.watchdog.WatchdogTimer;
import com.nokia.m2m.orb.ORB;
import com.nokia.m2m.orb.idl.gps.NoGpsDataAvailableException;
import com.nokia.m2m.orb.idl.terminal.ET;
import com.nokia.m2m.orb.idl.terminal.ETHelper;
import com.nokia.m2m.orb.idl.wirelessdevice.Device;
import com.nokia.m2m.orb.idl.wirelessdevice.DeviceHelper;
import com.telenor.apms.fifamos.n12.logger.SerialPortLogger;
import com.telenor.apms.fifamos.n12.utils.Config;
import com.telenor.apms.fifamos.n12.utils.GPSControl;
import com.telenor.apms.fifamos.n12.utils.SMSControl;


public class N12ContextSourceIMlet extends MIDlet implements Runnable {
	
	
	
	private N12XmlRpcClient xmlrpc;
	
	private IOControl ioc;
	
//	public static String RPC_URL = "http://129.241.219.164:8081/RPC2"; //trheim
//	private String RPC_URL = "http://81.191.34.98:80/RPC2"; // oslo
	public static String RPC_URL = "http://localhost:8080/RPC2"; // localhost
	
//	public String FRAME_ID = "0";
//	
//	public String SEACAGE_ID = "0";
//	
//	public String[] SENSOR_ID = {"0","1","2"};
	
	Vector sentAlarms = new Vector(); 
	
	private String msg = "";
	
	private org.omg.CORBA.ORB orb;
	
	private XmlParser parser = null;
	
	private String alarmId = "";

	private SMSControl sms;

	private GPSControl gps;

	private boolean alarm = false;

	private int sensorid = -1;
	
	private int seacageid = -1;

	private String message = "";

	private String minvalue = "";

	private String value = "";

	private String received = "";

	private String imei = "";


	private boolean simulator;

	private WatchdogTimer wdt;

	
	/* (non-Javadoc)
	 * @see javax.microedition.midlet.MIDlet#startApp()
	 */
	protected void startApp() throws MIDletStateChangeException {
		try {
//			try { Thread.sleep(15000); }
//			catch (Exception e) {}

			// Initialize ORB in IIOP mode. This IMlet does not do wireless
			// communications.
			Hashtable props = new Hashtable();
			props.put("com.nokia.m2m.orb.UseM2MGateway", "no");
			orb = ORB.init(null, props);
			
//			initiate the watchdog
			wdt = new WatchdogTimer();
			wdt.setTimeout(5*60);
			
			// Resolve the Embedded Terminal object
			// This is needed to send SMS and to resolve the units IMEI
			String etUrl =  "corbaloc::127.0.0.1:19740/ORB/OA/IDL:ET:1.0";
			org.omg.CORBA.Object etRef = orb.string_to_object(etUrl);
			ET et = ETHelper.narrow(etRef);
			
			imei = et.IMEI();
			if(imei==null || imei.length()==0) {
//				imei = "352540000049568"; //<-- old IMEI
//				new module, new IMEI....
				imei = "352540000046895";
				simulator = true;
				log("IMEI not found (simulator?): " + imei);
			} else
				log("IMEI: " + imei);

			
			xmlrpc = new N12XmlRpcClient(RPC_URL);


			ioc = IOControl.getInstance();
	
			Vector params = new Vector();
			params.addElement("5");
			params.addElement("5");
		
			if(simulator && ioc.getDigitalInputPin(6)) {
				try {
					xmlrpc.execute("Input.fillDB", params);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
				
			getConfig();
			
			gps = new GPSControl(orb);	
			sms = new SMSControl(orb);
			
		} catch (Exception e) {
			e.printStackTrace();
			log("Error - StartApp " + e.getMessage());
//			rebootModule();
		}
		log("done initing");
		new Thread(this).start();
	}
	
	/* (non-Javadoc)
	 * @see javax.microedition.midlet.MIDlet#pauseApp()
	 */
	protected void pauseApp() {}
	
	/* (non-Javadoc)
	 * @see javax.microedition.midlet.MIDlet#destroyApp(boolean)
	 */
	protected void destroyApp(boolean unconditional) throws MIDletStateChangeException {}
	
	/* (non-Javadoc)
	 * @see java.lang.Runnable#run()
	 */
	public void run() {
		try {
//			 GPS warmup...?
			 Thread.sleep(5000);
		
	//		sendInitGPS();
	
	//		a temporary string buffer
			StringBuffer xml = new StringBuffer();
			
	//		creating a vector to hold the xml
			Vector params = new Vector();

			while (true) {
				try {
					log("Reading/Sending");
					
					wdt.resetTimer();
					
					params.removeAllElements();
					
					xml.delete(0, xml.length());
//				start document
					xml.append("<xml>");
//				xml.append("<seacageid>"+Config.seacageid+"</seacageid>");
					for(int i=0; i<Config.sensorid.length;i++) {
						// creating xml nodes
						if(Config.sensorid[i]!=-1) {
							
							xml.append("<command type=\"add\">\n");
							xml.append("<sensorvalue>\n");
							xml.append("<sensorid>"+Config.sensorid[i]+"</sensorid>\n");
							xml.append("<value>"+ioc.getAnalogInputPin(i+1)+"</value>\n");
							xml.append("</sensorvalue>\n");
							xml.append("</command>\n");
						}
//					xml.append("<param name=\"sensorid\" value=\""+Config.sensorid[i]+"\"/>");
//					xml.append("<param name=\"value\" value=\""+ioc.getAnalogInputPin(i+1)+"\"/>");
//					xml.append("</sensorValue>");
					}
					
					
					xml.append("<command type=\"update\">\n");
					if(!simulator) {
						xml.append("<gps>\n"); 
						xml.append("<seacageid>"+ Config.seacageid +"</seacageid>\n");
						
						try {
							gps.read();

//						Handle GPS data.
							String lat = 
								"" + gps.getLatdeg() + 
								" " + gps.getLatmin() + 
								" " + gps.getLatsec();
							String lng = 
								"" + gps.getLngdeg() + 
								" " + gps.getLngmin() + 
								" " + gps.getLngsec();

							xml.append("<latlng ");
							xml.append("lat=\"" + lat + "\" ");
							xml.append("lng=\"" + lng + "\" />");
						} catch (NoGpsDataAvailableException ignored) {
						}
						
//					xml.append(gps.getGpsData());
						xml.append("</gps>\n"); 
						
						
					} else {
//					for simulator use only...
						String gpsString = 
							"<gps>" +
								"<seacageid>" + Config.seacageid + "</seacageid>" +
								"<latlng " +
								"lat=\""+ 63 + " " + (ioc.getDigitalInputPin(5) ? 30 : 29) + " " + 47 + "\" " +
								"lng=\""+ 10 + " " + 23 + " " + 57 +"\" " +
								"/>" +
							"</gps>";
						xml.append(gpsString);
					}
					
					xml.append("</command>\n");
					xml.append("</xml>");
					
					params.addElement(xml.toString());
					String result = (String) xmlrpc.execute("Input.postSourceXml", params);

					log("\n" + result);
					
					parser = new XmlParser(
							new InputStreamReader(
							new ByteArrayInputStream(result.getBytes())));
					
					
					Element el = new Element();
					el.parse(parser);
					
					for(int i=0;i<el.getChildCount();i++) {
						Object o = el.getChild(i);
						if(o instanceof Element) {
							Element child = (Element)o;
							parseElement(child);
						}
					}
					
					if(alarm) {
						if(seacageHasSensor(sensorid) || seacageid == Config.seacageid) {
							sms.sendTextSMS(Config.mobile, message);
							log("Etter sendTextSMS");
						}
						msg = "";
						sensorid = -1;
						seacageid = -1;
						alarm = false;
					}
					
				} catch (Exception e) {
					log("Error - run(): " + e.toString());
				}
				log("Waiting " + Config.interval + " sec");
				// wait, even after an exception
				try {
					Thread.sleep(Config.interval*1000);
				} catch (InterruptedException ignored) {
				}
			}
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
	
	private boolean seacageHasSensor(int sid) {
		for (int i = 0; i < Config.sensorid.length; i++) {
			if(Config.sensorid[i] == sid)
				return true;
		}
		return false;
	}

	/**
	 * @param el the element to parse
	 */
	private void parseElement(Element el) {
		String name = el.getName();

//		alarm parsing
		if(name.equals("alarm")) {
			alarm = true;
			alarmId = el.getValue("id");
			for(int i=0;i<el.getChildCount();i++) {
				if(el.getChild(i) instanceof Element)
					parseElement((Element)el.getChild(i));
			}
		} else if(name.equals("sensorid")) {
			sensorid = Integer.parseInt(el.getText());
		} else if(name.equals("seacageid")) {
			seacageid = Integer.parseInt(el.getText());
		} else if(name.equals("message")) {
			message = el.getText();
		} 
		
//		config parsing
		else if(name.equals("config")) {
			for(int i=0;i<el.getChildCount();i++) {
				if(el.getChild(i) instanceof Element)
					parseElement((Element)el.getChild(i));
			}
		} else if(name.equals("updated")) {
			if(Integer.parseInt(el.getValue("frameid")) == Config.frameid)
				getConfig();
		}
	}
	
	/**
	 * 
	 */
	public void getConfig() {
		try {
			Vector params = new Vector();
			params.addElement(imei);
			String xmlconfig = (String) xmlrpc.execute("Output.getConfigAsXml", params);
			Config.saveConfig(xmlconfig);
		} catch (Exception e) {
			log(e.toString());
		}
	}
	
	/**
	 * 
	 */
	public void rebootModule() {
		log("Rebooting module");
		Device device;
		org.omg.CORBA.Object devRef;
		String url = "corbaloc::127.0.0.1:19740/Device";
		
		try {
			devRef = orb.string_to_object(url);
			device = DeviceHelper.narrow(devRef);
			device.reset();
		} catch(Exception ignored) {
		} finally {
			device = null;
			devRef = null;
		}
	}
	
	/** Method to log different events in the process
	 * @param msg - the String to be logged
	 * @param flag - Not used
	 */
	private void log(String msg) {
		if(!simulator)
			SerialPortLogger.getInstance().write(msg);
		else
			System.out.println(msg);
	}
}