package com.telenor.apms.fifamos.n12.utils;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStreamReader;

import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreException;
import javax.microedition.rms.RecordStoreFullException;
import javax.microedition.rms.RecordStoreNotFoundException;

import org.kxml.kdom.Element;
import org.kxml.parser.AbstractXmlParser;
import org.kxml.parser.XmlParser;

import com.telenor.apms.fifamos.n12.logger.SerialPortLogger;

public class Config {
	
	static AbstractXmlParser parser;
	static String rsName = "n12scg";
	
	public static int frameid = -1;
	public static int seacageid = -1;
	public static int[] sensorid = {-1,-1,-1};
	public static String mobile = "";
	public static String email = "";
	public static int interval= 60;
	
	static int index = 0;
	static boolean isLoaded = false;
	
	public static void saveConfig(String xmlconfig) {
		try {
			try {
				RecordStore.deleteRecordStore(rsName);
			} catch (RecordStoreNotFoundException ingored) {} 
			
			RecordStore store = RecordStore.openRecordStore(rsName, true);
			
			store.addRecord(xmlconfig.getBytes(), 0, xmlconfig.getBytes().length);
			store.closeRecordStore();
			
			loadConfig();
		} catch (RecordStoreFullException e) {
			e.printStackTrace();
		} catch (RecordStoreNotFoundException e) {
			e.printStackTrace();
		} catch (RecordStoreException e) {
			e.printStackTrace();
		}
	}
	
	public static void loadConfig() {
		index = 0;
		try {
			RecordStore store = RecordStore.openRecordStore(rsName, false);
			String xmlsaved = new String(store.getRecord(1));
			store.closeRecordStore();
			
			parser = new XmlParser(new InputStreamReader(new ByteArrayInputStream(xmlsaved.getBytes())));
			
			
			Element el = new Element();
			el.parse(parser);
			
			for(int i=0;i<el.getChildCount();i++) {
				Element child = (Element)el.getChild(i);
				parseElement(child);
				
			}
			if(frameid!=-1&&seacageid!=-1&&sensorid[0]!=-1&&sensorid[1]!=-1&&sensorid[2]!=-1)
				isLoaded  = true;
		} catch (RecordStoreFullException e) {
			e.printStackTrace();
		} catch (RecordStoreNotFoundException e) {
			isLoaded = false;
			e.printStackTrace();
		} catch (RecordStoreException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private static void parseElement(Element el) {
		
		String type = el.getName();
		String value = el.getValue("value");
		
		log(type + ": " + value);
		if(type.equals("frame"))
			frameid = Integer.parseInt(value);
		else if(type.equals("seacage"))
			seacageid =  Integer.parseInt(value);
		else if(type.equals("sensorid"))
			sensorid[index++] = Integer.parseInt(value);
		else if(type.equals("mobile"))
			mobile = value;
		else if(type.equals("email"))
			email = value;
		else if(type.equals("interval"))
			interval = Integer.parseInt(value);
	}

	private static void log(String string) {
		SerialPortLogger.getInstance().write(string);	
		System.out.println(string);
	}

	public static void clearConfig() {
		try {
			RecordStore.deleteRecordStore(rsName);
		} catch (RecordStoreNotFoundException ingored) {
		} catch (RecordStoreException e) {
		} 
	}
}
