package com.telenor.apms.fifamos.n12.utils;

import javax.microedition.io.Connector;
import javax.wireless.messaging.MessageConnection;
import javax.wireless.messaging.TextMessage;

import com.nokia.m2m.orb.idl.terminal.ET;
import com.nokia.m2m.orb.idl.terminal.ETHelper;
import com.nokia.m2m.orb.idl.terminal.ETPackage.MessageStorage;

public class SMSControl {

	private ET et;

	public SMSControl(org.omg.CORBA.ORB orb) {
		
//		Resolve the Device object.
		String url = "corbaloc::127.0.0.1:19740/ORB/OA/IDL:ET:1.0";
		org.omg.CORBA.Object ref = orb.string_to_object(url);
		et = ETHelper.narrow(ref);
	}
	
	public void sendTextSMS(String phoneNumber, String text) {
		
		// Set the correct target address.
		String targetAddress = "sms://"+phoneNumber;
		
		TextMessage msg;
		
		MessageConnection sendConn = null;
		
		try {
			// Creating a MessageConnection to the target address.
			sendConn = (MessageConnection)Connector.open(targetAddress);
			// Creating a text message to be send.
			msg = (TextMessage)sendConn.newMessage(MessageConnection.TEXT_MESSAGE);
			// Set the message text.
			msg.setPayloadText(text);
			// Send the message.
			sendConn.send(msg);

			et.removeShortMessage(MessageStorage.SIM, 0);
			
		}catch (Exception noSMSToDelete){
		}finally{
			// Close the MessageConnection if it is still open.
			try{
				sendConn.close();
			}catch(Exception conNotOpen) {}
		}
	}
}