package com.telenor.apms.fifamos.client.j2me.control;

import java.util.Vector;

import net.comtor.j2me.util.StringVector;

import org.kxmlrpc.TestXmlRpcClient;


/**
 * @author JAG
 * @copyright JAG  2006
 * @version 1.0
 */

public class RpcHandler implements Runnable {

	private String res;
	private StringVector sv;
	private Vector params;
	private String request;
	private RpcHandlerResult listener;
	
	public RpcHandler(String request, Vector params, RpcHandlerResult listener) {
		this.request = request;
		this.params = params;
		this.listener = listener;
	}
	
	public void run() {
		try {
			debug("Contacting web service..");
			
			TestXmlRpcClient xmlrpc = new TestXmlRpcClient(
				Constants.SERVER_URL);
			
			res = (String) xmlrpc.execute(
					request, params);
			debug(request +" -> "+res);
			if(res.length()>1) {
			sv = new StringVector(res, ';');
			
			listener.passResult(sv);
			}
			else listener.passError("Listen er tom");

		} catch (Exception e) {
			debug(e.toString());
			res = "Noe gikk galt: "+e.toString()+" \nSjekk serverinnstillingen!";
			listener.passError(res);
		}
	}

	private void debug(String message) {
		if(Constants.DEBUG) {
			System.out.println("RpcHandler debug*** "+message) ;			
		}
	}
}
