package com.telenor.apms.fifamos.client.j2me.gui;

import java.util.Timer;
import java.util.TimerTask;
import java.util.Vector;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.List;

import com.telenor.apms.fifamos.client.j2me.control.Constants;
import com.telenor.apms.fifamos.client.j2me.control.RpcHandler;
import com.telenor.apms.fifamos.client.j2me.control.RpcHandlerResult;
import com.telenor.apms.fifamos.client.j2me.objects.Sensor;

import net.comtor.j2me.util.StringVector;

/**
 * @author JAG
 * @copyright JAG  2006
 * @version 1.0
 */

public class SensorList extends List implements RpcHandlerResult{
	
	private Command exitCommand;
	private Command backCommand;
	private String seaCage;
	private Timer timer;
	private int interval = Constants.INTERVAL;
	private Vector sensors = new Vector();
	
	public SensorList(String arg0, int arg1, String seaCage) {
		super(arg0, arg1);
		this.seaCage = seaCage;
		append("Et yeblikk, henter data....", null);
		exitCommand = new Command("Exit", Command.EXIT, 1);
		backCommand = new Command("Back", Command.BACK, 1);
		
		this.addCommand(backCommand);
		this.addCommand(exitCommand);
		startTimer();
	}
	
	public void startTimer() {
		//schedule RPC-call
		timer = new Timer();
		timer.scheduleAtFixedRate(new TimerTask() {
			public void run() {
				getSensorData();
			}
		}, 500, interval );
	}
	
	public void stopTimer() {
		timer.cancel();
	}
	
	public void getSensorData() {
		Vector params = new Vector();
		params.addElement(seaCage);
		Thread t = new Thread (new RpcHandler("Output.getSensorsForSeaCage", params, this));
		t.start();
	}
	
	public void passResult(StringVector sv) {
			while (size() > 0) {
				delete(0);
			}
			for(int i = 0; i<sv.size(); i++) {
				Sensor s = new Sensor(sv.stringElementAt(i));
				sensors.addElement(s);
				append(s.toString(), null);
		}
	}
	
	public Sensor getSensor(int i) {
		return (Sensor)sensors.elementAt(i);
	}
	
	public void passError(String error) {
		delete(0);
		append(error, null);
	}
	
	public int[] getMinMax(String sensorID) {
		int[] res = new int[2];
		for (int i = 0; i < sensors.size(); i++) {
			Sensor s = (Sensor)sensors.elementAt(i);
			if(s.getID().equalsIgnoreCase(sensorID)) {
				System.out.println(s.getMinValue());
				res[0] = Integer.parseInt(s.getMinValue());
				res[1] = Integer.parseInt(s.getMaxValue());
			}
		}
		return res;
	}
}


