package com.telenor.apms.fifamos.client.j2me.gui;

/**
 * @author JAG
 * @copyright JAG  2006
 * @version 1.0
 */

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.TextField;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreException;
import javax.microedition.rms.RecordStoreFullException;
import javax.microedition.rms.RecordStoreNotFoundException;
import javax.microedition.rms.RecordStoreNotOpenException;

import com.telenor.apms.fifamos.client.j2me.control.Constants;



public class Settings extends Form{

	private Command saveCommand;
	private Command cancelCommand;
	private String serverURL;
	private RecordStore rs;
	private TextField serverField;
	private int interval;
	private TextField intervalField;
	
	public Settings(String arg0) {
		super(arg0);
		saveCommand = new Command("Lagre", Command.OK, 1);
		cancelCommand = new Command("Avbryt", Command.CANCEL, 1);
		this.addCommand(saveCommand);
		this.addCommand(cancelCommand);
		loadSettings();
		serverField= new TextField("Server-adresse: ", serverURL, 50,TextField.ANY);
		intervalField = new TextField("Oppdateringsfrekvens (ms): ", String.valueOf(interval), 50, TextField.NUMERIC);
		append(serverField);
		append(intervalField);
	}
	
	public void loadSettings() {
		try {
			rs = RecordStore.openRecordStore("settings", false);
			debug("1");
			serverURL = new String(rs.getRecord(1));
			debug("hentet url: "+serverURL);
			interval = Integer.parseInt(new String(rs.getRecord(2)));
			debug("hentet interval: "+interval);
			rs.closeRecordStore();
			debug("2");
		} catch(RecordStoreNotFoundException e) {
			serverURL = Constants.SERVER_URL;//set to default
			interval = Constants.INTERVAL;
			e.printStackTrace();
		} catch (RecordStoreFullException e) {
			serverURL = Constants.SERVER_URL;//set to default
			interval = Constants.INTERVAL;
			e.printStackTrace();
		} catch (RecordStoreException e) {
			serverURL = Constants.SERVER_URL;//set to default
			interval = Constants.INTERVAL;
			try {
				rs.closeRecordStore();
			} catch (RecordStoreNotOpenException e1) {
				e1.printStackTrace();
			} catch (RecordStoreException e1) {
				e1.printStackTrace();
			}
			e.printStackTrace();
		}
	}
	
	public void saveSettings() {
		debug("saving settings");
		try {
			try {
				RecordStore.deleteRecordStore("settings");
			} catch(RecordStoreNotFoundException e) {
				e.printStackTrace();
			}
			rs = RecordStore.openRecordStore("settings", true);
			int recordID = rs.addRecord(serverField.getString().getBytes(), 0, serverField.getString().getBytes().length);
			debug("4");
			int recordID2 = rs.addRecord(intervalField.getString().getBytes(), 0, intervalField.getString().getBytes().length);
			debug("id: "+ recordID+", id2: " + recordID2);
			Constants.SERVER_URL = new String(rs.getRecord(recordID));
			Constants.INTERVAL = Integer.parseInt(new String(rs.getRecord(recordID2)));
			rs.closeRecordStore();
			debug("Settings saved!: " +Constants.SERVER_URL +", "+Constants.INTERVAL);
		} catch (RecordStoreFullException e) {
			e.printStackTrace();
		} catch (RecordStoreException e) {
			e.printStackTrace();
		}
		
	}
	private void debug(String message) {
		if(Constants.DEBUG) {
			System.out.println("Settings debug*** "+message) ;	
		}
	}

}