package com.telenor.apms.fifamos.client.j2me.objects;

import net.comtor.j2me.util.StringVector;

/**
 * SensorValue.java
 * 
 * Class that describe a sensor value
 * 
 * @author JAG
 * @copyright JAG  2006
 * @version 1.0
 */
public class Sensor {
	private String ID;
	private String type;
	private String seaCageID;
	private String currentValue;
	private String maxRange;
	private String minRange;
	private String maxValue;
	private String minValue;
	private String typeName;
	private String unit;
	
	public Sensor(String input) {
		StringVector sv = new StringVector(input,':');
		ID = (sv.stringElementAt(0));
		type = (sv.stringElementAt(1));
		typeName = sv.stringElementAt(2);
		unit = sv.stringElementAt(3);
		maxRange = (sv.stringElementAt(4));
		minRange = (sv.stringElementAt(5));
		maxValue = (sv.stringElementAt(6));
		minValue = (sv.stringElementAt(7));
		currentValue = (sv.stringElementAt(8));
		seaCageID =  (sv.stringElementAt(9));
	}
	
	public Sensor(String type, String maxRange, String minRange, String maxValue, String minValue, String seaCageID) {
		ID = "not set";
		currentValue = "not set";
		this.type = type;
		this.maxRange = maxRange;
		this.minRange = minRange;
		this.maxValue = maxValue;
		this.minValue = minValue;
		this.seaCageID = seaCageID;
	}

	public String getType() {
		return type;
	}
	
	public String getSeaCageID() {
		return seaCageID;
	}
	public String getID() {
		return ID;
	}
	
	public String getCurrentValue() {
		return currentValue;
	}
	
	public String getMaxRange() {
		return maxRange;
	}
	
	public String getMinRange() {
		return minRange;
	}

	public String getMaxValue() {
		return maxValue;
	}
	
	public String getMinValue() {
		return minValue;
	}
	public String toString() {
		return ("ID "+ID+" - "+typeName+": "+currentValue + " "+unit);
	}

	public String getUnit() {
		return unit;
	}

	public String getTypeName() {
		return typeName;
	}
}
