/*
 * ErrorMessage.java
 *
 * Created on August 26, 2004, 11:24 PM
 */

package net.comtor.j2me.gui;

import javax.microedition.lcdui.*;
/**
 *
 * @author  root
 */
public class ErrorMessage extends GraphicsMessageCanvas implements Runnable{
    private Displayable lastDisplay;
    Thread waitThread;
    boolean finish = false;
    long time;
    private long contador;
    /** Creates a new instance of ErrorMessage */
    public ErrorMessage(String logoPath, String title  ,String message, AlertType alertType , long time ) {
        super(logoPath);
        
        init(title, message);
        this.time = time;
        if (time > 0){
            waitThread = new Thread(this);
            waitThread.start();
        }
        GlobalGui.playSound(alertType);
        contador = time/1000;
    }
    
    public ErrorMessage( String title  ,String message) {
        super("");
        init(title, message);
        contador = time/1000;
    }
    
    
    /**
     * @param title
     * @param message
     * @param alertType
     * @param time
     */
    private void init(final String title, final String message) {
        setTitle(title);
        setMessage(message);
        lastDisplay = GlobalGui.getCurrentDisplay().getCurrent();
    }
    
    protected void paint(javax.microedition.lcdui.Graphics g) {
        
        super.paint(g);
        
        
        g.setFont(fontMonoPlainSmall);
        
        g.drawString("OK", 0, getHeight(), g.LEFT|g.BASELINE);
        if (time > 0){
            g.drawString(""+contador+" seg", getWidth()/2, getHeight(), g.HCENTER|g.BASELINE);
        }
    }
    
    protected void keyPressed(int k) {
        super.keyPressed(k);
        
        if (k == SOFT_LEFT){
            restoreDisplay();
        }
    }
    
    private void restoreDisplay() {
        GlobalGui.setCurrentDisplay(lastDisplay);
    }
    
    public void run() {
        while (!finish){
            repaint();
            try{
                Thread.sleep(1000);
            }
            catch(Exception e){
                restoreDisplay();
            }
            contador --;
            if (contador < 0 ){
                
                restoreDisplay();
                return;
            }
        }
        restoreDisplay();
    }
    
    /** Getter for property lastDisplay.
     * @return Value of property lastDisplay.
     *
     */
    public javax.microedition.lcdui.Displayable getLastDisplay() {
        return lastDisplay;
    }
    
    /** Setter for property lastDisplay.
     * @param lastDisplay New value of property lastDisplay.
     *
     */
    public void setLastDisplay(javax.microedition.lcdui.Displayable lastDisplay) {
        this.lastDisplay = lastDisplay;
    }
    
}
