package net.comtor.j2me.gui;
import  net.comtor.j2me.util.*;
import javax.microedition.lcdui.Image;


public class GraphicsMessageCanvas extends CanvasClean {
    private Image logo;
    private String message="";
    private String title = "";
    /** Creates a new instance of CanvasClean */
    /** Autogenerated proxy constructor. */
    public GraphicsMessageCanvas(String logoPath) {
        super();
        try{
            logo = Image.createImage(logoPath);
        }
        catch(Exception e){
            logo= null;
        }
    }
    

    
    protected void paint(javax.microedition.lcdui.Graphics g) {
        super.paint(g);
        
        int logoHeight = 0;
        g.setFont(this.fontMonoBoldSmall);
        g.drawString(title, getWidth()/2, logoHeight, g.TOP|g.HCENTER);
        logoHeight = fontMonoBoldSmall.getSize()+1;
        
        
        if (logo != null){
            g.drawImage(logo, getWidth()/2,logoHeight, g.TOP|g.HCENTER);
            logoHeight += logo.getHeight();
        }
        g.setFont(this.fontMonoPlainSmall);
        
        
        int textWidth = (getWidth()/fontMonoPlainSmall.charWidth('A'));
        
        
        StringVectorUsingWidth svw = new StringVectorUsingWidth(message, textWidth);
        for (int i = 0 ; i < svw.size(); i++){
            g.drawString(svw.stringElementAt(i), getWidth()/2, logoHeight, g.TOP|g.HCENTER);
            logoHeight += fontMonoPlainSmall.getHeight();
        }
        
    }
    
    /** Getter for property message.
     * @return Value of property message.
     *
     */
    public java.lang.String getMessage() {
        
        return message;
    }
    
    /** Setter for property message.
     * @param message New value of property message.
     *
     */
    public void setMessage(java.lang.String message) {
        this.message = message;
        repaint();
    }
    
    /** Getter for property title.
     * @return Value of property title.
     *
     */
    public java.lang.String getTitle() {
        return title;
    }
    
    /** Setter for property title.
     * @param title New value of property title.
     *
     */
    public void setTitle(java.lang.String title) {
        this.title = title;
        repaint();
    }
    
}
