/*
 * Connection.java
 *
 * Created on August 16, 2004, 2:41 PM
 */

package net.comtor.j2me.net;

import java.io.*;
import javax.microedition.io.*;



/**
 *
 * @author  root
 *
 *
 *
 */



public class ConnectionHelper {
    
    
    HttpConnection http = null;
    InputStream in = null ;
    private static ConnectionHelper connectionHelper;
    public  Exception lastException;
    private long timeout = 60000;
    
    
    long lastLength = -1;
    long leftBytes = 0;
    
    static {
        connectionHelper = new ConnectionHelper();
    }
    
    private ConnectionHelper(){
    }
    
    public static ConnectionHelper getInstance(){
        return connectionHelper;
    }
    
    
    
    private class DummyListener implements ConnectionListener{
        public void addConnectionMessage(String message){
        }
    }
    
    public  String readFullyHttpConnection(String url){
        return readFullyHttpConnection( url,null);
    }
    
    public  String readFullyHttpConnection(String url, ConnectionListener listener){
        
        if (listener == null){
            listener = new ConnectionHelper.DummyListener();
        }
        
        listener.addConnectionMessage("Preparando Conexion");
        url = prepareUrl(url);
        System.out.println(url);
        StringBuffer resp = new StringBuffer("");
        try{
            listener.addConnectionMessage("Conectandose");
            http = (HttpConnection) Connector.open(url, Connector.READ,true);
            in = http.openInputStream();
            resetLength(http);
            
            int c;
            int contador =0;
            while((c = readFromConnection()) != -1){
                resp.append((char)c);
                //if (contador %20 == 0  ){
                    if ((lastLength > 0 )){
                         listener.addConnectionMessage("Leyendo "+leftBytes+" / "+lastLength);
                    }
                    else{
                        listener.addConnectionMessage("Leyendo "+contador);
                    }
                //}
                
                   contador++;
            }
            listener.addConnectionMessage("Terminando Conexion");
            in.close();
            http.close();
            resetLength(null);
            System.out.println(resp);
            return resp.toString();
        }
        catch(Exception e){
            resetLength(null);
            listener.addConnectionMessage(""+e);
            lastException = e;
            return "";
        }
    }
    
    /**
     * @return
     */
    
    
    
    private int readFromConnection() throws Exception{
        //System.out.println("      last "+lastLength+" "+ leftBytes);
        if (lastLength != -1){
            try{
                if (lastLength > 0){
                    if (leftBytes > 0){
                        leftBytes--;
                        return in.read();
                    }
                    else {
                        return -1;
                    }
                }
            }
            catch(IOException ee){
                //ee.printStackTrace();
                lastException = ee;
            }
        }
        else {
            try{
                return in.read();
            }
            catch(Exception ee){
                //ee.printStackTrace();
                lastException = ee;
            }
        }
        
        return -1;
        
    }
    
    /**
     * @param url
     * @return
     */
    private String prepareUrl(String url) {
        url = url.replace(' ','+');
        url = url.replace('\n','+');
        
        return url;
    }
    
    
    
    
    /**
     *  This methos auto close Connection
     *
     */
    
    public synchronized String readUntil(String end)  {
        StringBuffer str = new StringBuffer();
        char lastChar = end.charAt(end.length()-1);
        
        
        try{
            int ch;
            int i = 0;
            while ((ch = readFromConnection()) != -1){
                
                //System.out.println("------"+(int)ch+"  "+str);
                
                char c = (char)ch;
                if (c != lastChar){
                    str.append(c);
                }
                else  {
                    str.append(c);
                    if (str.toString().endsWith(end)){
                        return str.toString().substring(0,str.length()-end.length());
                    }
                }
                i++;
            }
            try{
                in.close();
            }
            catch(Exception ee){
            }
            try{
                http.close();
                http = null;
            }catch(Exception ee){
            }
        }
        catch(Exception e){
            if (in != null){
                try{
                    in.close();
                }
                catch(Exception ee){
                }
            }
            if (http != null){
                try{
                    http.close();
                    http = null;
                }catch(Exception ee){
                }
            }
            return null;  // Returns null if something fails
        }
        if (str.length() > 0 ){
            return str.toString();
        }
        else{    // Returns null if str's length  is 0
            return null;
        }
    }
    
    
    /**
     *  This methos auto close Connection
     *
     */
    
    public synchronized String readLine()  {
        StringBuffer str = new StringBuffer();
        
        try{
            int ch;
            int i = 0;
            while ((ch = readFromConnection()) != -1){
                char c = (char)ch;
                if (c != '\n'){
                    str.append(c);
                }
                else  {
                    return str.toString();
                }
                i++;
            }
            try{
                in.close();
                
            }
            catch(Exception ee){
            }
            try{
                http.close();
                http = null;
            }catch(Exception ee){
            }
        }
        catch(Exception e){
            if (in != null){
                try{
                    in.close();
                }
                catch(Exception ee){
                }
            }
            if (http != null){
                try{
                    http.close();
                    http = null;
                }catch(Exception ee){
                }
            }
            return null;  // Returns null if something fails
        }
        if (str.length() > 0 ){
            return str.toString();
        }
        else{    // Returns null if str's length  is 0
            return null;
        }
    }
    
    /**
     *    Se conecta
     */
    
    public synchronized boolean connect(String url){
        url = prepareUrl(url);
        System.out.println("connect "+url);
        resetLength(null);
        
        try {
            http =  (HttpConnection)Connector.open(url, Connector.READ,true);
            resetLength(http);
            in= new DataInputStream(http.openInputStream());
        }
        catch(Exception e){
            lastException = e;
            return false;
        }
        return true;
    }
    
    /** Getter for property timeout.
     * @return Value of property timeout.
     *
     */
    public long getTimeout() {
        return timeout;
    }
    
    /** Setter for property timeout.
     * @param timeout New value of property timeout.
     *
     */
    public void setTimeout(long timeout) {
        this.timeout = timeout;
    }
    
    public void resetLength(HttpConnection http){
        if (http == null){
            lastLength =0;
            leftBytes = lastLength;
            return;
        }
        lastLength = http.getLength();
        leftBytes = lastLength;
        
    }
}
