/*
 * PersistentVector.java
 *
 * Created on July 6, 2004, 2:29 PM
 */

package net.comtor.j2me.util.rms;

import javax.microedition.rms.*;

/**
 *
 * @author  root
 */
public class PersistentVector {
    private String recordStoreName;
    private RecordStore recordStore;
    
    /** Creates a new instance of PersistentVector */
    public PersistentVector(String name)  {
        recordStoreName = name;
        open();
    }
    
    private void open() {
        try{
            recordStore  = RecordStore.openRecordStore(recordStoreName, true);
        }
        catch(Exception e){
            System.out.println("PersistentVector "+e);
        }
    }
    
    public void close() {
        try{
            recordStore.closeRecordStore();
        }
        catch(Exception e){
            System.out.println("PersistentVector "+e);
        }
        
    }
    
    public void setElementAt(Binarizable obj, int index){
        if (index > getSize()-1){
            return ;
        }
        try{
            byte bb[] = ConvertToBytes.saveToBytes(obj);
            recordStore.setRecord(index+1, bb, 0 ,bb.length);
            
        }
        catch(Exception e){
            System.out.println("PersistentVector "+e);
        }
    }
    /**
     * Agrega un elemento al arreglo
     */
    public void addElement(Binarizable obj){
        try{
            byte bb[] = ConvertToBytes.saveToBytes(obj);
            recordStore.addRecord(bb,0, bb.length);
            
        }
        catch(Exception e){
            System.out.println("PersistentVector "+e);
        }
    }
    
    public void  elementAt(int index, Binarizable obj){
        try{
            byte bb[];
            bb = recordStore.getRecord(index+1);
            ConvertToBytes.loadFromBytes(bb, obj);
        }
        catch(Exception e){
            System.out.println("PersistentVector "+e);
        }
    }
    
    
    public int getSize(){
        try{
            return recordStore.getNumRecords();
        }
        catch(Exception e){
        }
        return 0;
    }
    
    /**
     *  Borra  el contenido del recordStore
     */
    public void reset(){
        try{
            close();
            recordStore.deleteRecordStore(recordStoreName);
            open();
        }
        catch(Exception ee){
            
        }
    }
    
}
