<%!
	private static MBeanServer server;
	private RequestResponse reqResponse = new RequestResponse();

   private void showServices(){
		 try{
		 	String output = getHtmlHeader("CoMS services");
		 	HashMap serviceMap = getServiceDescriptions();
		 	
		 	Iterator it = serviceMap.keySet().iterator();
		 	
		 	// For each service description (ie. jar package) in the system
		 	while(it.hasNext()){
		 		ServiceDescription serviceDesc = (ServiceDescription) serviceMap.get((String) it.next());
		 		HashMap services = serviceDesc.getServices();
		 		Iterator sit = services.keySet().iterator();
		 		
		 		// For each service described in this description
		 		while(sit.hasNext()){
		 			Service service = (Service) services.get((String) sit.next());
					String status = "enable";
		 			if(service.isEnabled())
	  					status = "disable";

	 				output += "<small>"+service.getName()+"</small><br>"+
	 						  "<small><a href=\"service.jsp?id=showServiceDescription&amp;pkgID="+serviceDesc.getJarPackage()+"&amp;serviceID="+service.getName()+"\">Description</a></small><br>";
	 				// Get all input
	 				HashMap inputMap = service.getInput();		
	 				Iterator fit = inputMap.keySet().iterator();
	 				
	 				while(fit.hasNext()){
	 					ServiceInput input = (ServiceInput) inputMap.get((String)fit.next());
	 					output += "<small><a href=\"service.jsp?id=showServiceAction&amp;pkgID="+serviceDesc.getJarPackage()+"&amp;serviceID="+service.getName()+"&amp;serviceInput="+input.getName()+"\">"+input.getName()+"</a></small><br>";
	 				}
	 						
	 				output +=  "<small><a href=\"service.jsp?id="+status+"Service&amp;pkgID="+serviceDesc.getJarPackage()+"&amp;serviceID="+service.getName()+"\">"+status+"</a></small><br>"+
		 					  "------------------<br>";
		 		}
		 	}
		 	
		 	output += "";
		 	output += getHtmlFooter();
		 	reqResponse.setHtml(output);
 			 
		}catch(Exception e){
		 	e.printStackTrace();
		 }	
	}
	
	private String getHtmlHeader(String title){
		String output = "<head>"+
						"<title>"+title+"</title>"+
						"</head>"+
						"<body>";
		return output;
	}
	
	private String getHtmlFooter(){
		return "</body>";
	}
						
	
	private void enableService(String pkgID, String serviceID){
		try{
			ObjectName descriptor = new ObjectName("Module_Domain:Name=ServiceDescriptor, Type=Core");
				
			invoke(descriptor, "enableService", 
							new Object[]{pkgID, serviceID}, 
							new String[]{String.class.getName(), String.class.getName()}, "Module_Domain");
		}catch(Exception e){
			e.printStackTrace();
		}			
	}
	
	private void disableService(String pkgID, String serviceID){
		try{
			ObjectName descriptor = new ObjectName("Module_Domain:Name=ServiceDescriptor, Type=Core");	
				
			invoke(descriptor, "disableService", 
							new Object[]{pkgID, serviceID}, 
							new String[]{String.class.getName(), String.class.getName()}, "Module_Domain");
		}catch(Exception e){
			e.printStackTrace();
		}			
	}			
	
	private void showServiceDescription(String pkgID, String serviceID){
		HashMap serviceMap = getServiceDescriptions();
		ServiceDescription serviceDesc = (ServiceDescription) serviceMap.get(pkgID);
	 	Service service = serviceDesc.getService(serviceID);
	 	
	 	String output = getHtmlHeader(service.getName());
	 	output += "<small>"+service.getDescription()+"</small>";
	 	output += getHtmlFooter();
	 	reqResponse.setHtml(output);
	}
	
	private void showServiceAction(String pkgID, String serviceID, String serviceInput, HttpServletRequest request){
		try{
		 	
		 	HashMap serviceDescMap = getServiceDescriptions();
		 	ServiceDescription desc = (ServiceDescription) serviceDescMap.get(pkgID);
		 	Service service = desc.getService(serviceID);
		 	HashMap inputMap = service.getInput();
		 	ServiceInput input = (ServiceInput) inputMap.get(serviceInput);
		 	
		 	HashMap<String, String> parameterValues = new HashMap<String, String>();
		 	
		 	// Get header values (User ip, user-agent, etc)
		 	Enumeration e = request.getHeaderNames();
		 	while(e.hasMoreElements()){
		 		String key = (String) e.nextElement();
		 		parameterValues.put(key, (String) request.getHeader(key));
		 	}
		 	
		 	// Get the request parameters
		 	e = request.getParameterNames();
		 	while(e.hasMoreElements()){
		 		String key  = (String) e.nextElement();
		 		parameterValues.put(key, (String) request.getParameter(key));
		 	}
		 	
		 	// Send mapping to component method
			ObjectName com = new ObjectName("Component_Domain:Name="+input.getComponentName()+", Type="+input.getComponentType());
				
			reqResponse = (RequestResponse) invoke(com, input.getMethod(), 
														new Object[]{parameterValues}, 
														new String[]{HashMap.class.getName()}, "Component_Domain");
		 	
		}catch(Exception e){
		 	e.printStackTrace();
		}
	}
	
	private HashMap getServiceDescriptions(){
		try{
			ObjectName descriptor = new ObjectName("Module_Domain:Name=ServiceDescriptor, Type=Core");
			return (HashMap) getAttribute(descriptor, "ServiceDescriptions", "Module_Domain");
		}catch(Exception e){
			e.printStackTrace();
		}
		return null;
	}
	
	/**
	* Gets an attribute from a mbean
	* @param ObjectName describing the module, String describing which attribute, String describing the domain
	* @return An Object with the attribute
	*/
	private Object getAttribute(ObjectName module, String attr, String domain){
		try{
			getServerHandle(domain);
			Object result = server.getAttribute(module, attr);
			return result;
		}catch(MBeanException e){
			log("getAttribute(): Module "+module+" doesn't exist\nModule: "+ module.toString());
		}catch(AttributeNotFoundException e){
			log("getAttribute(): Attribute \""+attr+"\" was not found\nModule: "+ module.toString());
		}catch(InstanceNotFoundException e){
			log("getAttribute(): Instance not found exception\nModule: "+ module.toString());
		}catch(ReflectionException e){
    		log("getAttribute(): Reflection exception \nModule: "+ module.toString());
    	}
		
		return null;
	}

	/**
	* Invokes a function on an mbean
	*/
	public Object invoke(ObjectName module, String method, Object[] args, String[] types, String domain){
		try{
			
			getServerHandle(domain);
			return server.invoke(module, method, args, types);
		
		}catch(InstanceNotFoundException e){
    		e.printStackTrace();
    		System.exit(0);
    	}catch(MBeanException e){
    		e.printStackTrace();
    		System.exit(0);
    	}catch(ReflectionException e){
    		e.printStackTrace();
    		System.exit(0);
    	}
    	
    		return null;
	}
	
	/**
	* Gets the server handle for the domain specified
	* @param String describing the domain
	*/
	private void getServerHandle(String domain){
    		
			ArrayList mbeanservers = MBeanServerFactory.findMBeanServer(null);
			Iterator iter = mbeanservers.iterator();
		
			while(iter.hasNext()){
				server = (MBeanServer)iter.next();
				
			if(server.getDefaultDomain().equals(domain))
				break;
			}
		
			if(server == null){
				System.out.println("Could not find mbeanserver handle");
				System.exit(0);
			}
	}

%>